package com.yipin.liuwanr;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import com.aliyun.oss.OSSClient;

@Component
@PropertySource(value = "classpath:aliyun.properties")
@Configuration
public class AliyunOssConfig {

	@Value("${oss.endpoint}")
	private String endpoint;// oss外网访问域名
	@Value("${oss.accessKeyId}")
	private String accessKeyId;// oss中的密匙keyId
	@Value("${oss.secretAccessKey}")
	private String secretAccessKey;// oss中的密钥
	@Value("${oss.bucketName}")
	private String bucketName;// 仓库名称
	@Value("${oss.sufferUrl}")
	private  String sufferUrl;
	@Value("${user.userAvatars}")//用户头像
	private String userAvatars;

	@Bean
	@Scope("prototype")
	public OSSClient ossClient() {
		return new OSSClient(endpoint, accessKeyId, secretAccessKey);
	}

	public String getEndpoint() {
		return endpoint;
	}

	public String getAccessKeyId() {
		return accessKeyId;
	}

	public String getSecretAccessKey() {
		return secretAccessKey;
	}

	public String getBucketName() {
		return bucketName;
	}

	public String getSufferUrl() {
		return sufferUrl;
	}

	public String getUserAvatars() {
		return userAvatars;
	}

}
