package com.yipin.liuwanr;

import  java.io.BufferedInputStream;
import  java.io.BufferedOutputStream;
import  java.io.File;
import  java.io.FileInputStream;
import  java.io.IOException;
import  java.io.InputStream;
import  java.io.OutputStream;
import  java.io.UnsupportedEncodingException;
import  java.net.URLEncoder;
import  java.util.HashMap;
import  java.util.Map;

import  javax.servlet.http.HttpServletRequest;
import  javax.servlet.http.HttpServletResponse;
import  javax.servlet.http.HttpSession;

import  org.apache.commons.lang3.StringUtils;



/**
 * online处理工具类
 * @ClassName: OfficeOnlineMethod
 * @Description: TODO(这里用一句话描述这个类的作用) 
 */
public class OfficeOnlineMethod {
	
	private static final Map<String,String> urls;
	
	static {
		urls = new HashMap<String,String>();
		urls.put("view-xls", "x/_layouts/xlviewerinternal.aspx?");
		urls.put("view-xlsx", "x/_layouts/xlviewerinternal.aspx?");
		//urls.put("mobileView-xls", "x/_layouts/xlviewerinternal.aspx?");
		//urls.put("mobileView-xlsx", "x/_layouts/xlviewerinternal.aspx?");
		
		urls.put("view-one", "o/onenoteframe.aspx?a=1");
		urls.put("view-onetoc2", "o/onenoteframe.aspx?a=1");
		urls.put("view-pot", "p/PowerPointFrame.aspx?a=1");
		urls.put("view-potm", "p/PowerPointFrame.aspx?a=1");
		urls.put("view-potx", "p/PowerPointFrame.aspx?a=1");
		urls.put("view-ppt", "p/PowerPointFrame.aspx?a=1");
		urls.put("view-pptm", "p/PowerPointFrame.aspx?a=1");
		urls.put("view-pptx", "p/PowerPointFrame.aspx?a=1");
		
		urls.put("view-doc", "wv/wordviewerframe.aspx?a=1");
		urls.put("view-docm", "wv/wordviewerframe.aspx?a=1");
		urls.put("view-docx", "wv/wordviewerframe.aspx?a=1");
		urls.put("view-dot", "wv/wordviewerframe.aspx?a=1");
		urls.put("view-dotm", "wv/wordviewerframe.aspx?a=1");
		urls.put("view-dotx", "wv/wordviewerframe.aspx?a=1");
		urls.put("view-pdf", "wv/wordviewerframe.aspx?PdfMode=1");
	}
	
	/**
	 * 获取文件资源预览地址
	 * @param request
	 * @param file 文件名
	 * @param path 文件路径
	 * @return
	 */
	public static String getResourceReviewUrl(HttpServletRequest request, String file,String path){
		if(StringUtils.isEmpty(file)){
			return null;
		}
		if(StringUtils.isEmpty(path)){
			return null;
		}
		if(!path.endsWith("/")){
			path = path + "/";
		}
		//String token = ConfigurationUtils.getMustExistsStringConfig(TOKEN_DREAMCLASS_FILE);
		StringBuilder str = new StringBuilder();
		
		//2018.11.22添加
		HttpSession session = request.getSession();
		String officeUrl=(String)session.getAttribute("officeInnerIp");		
		if(officeUrl==null||"".equals(officeUrl)){
			officeUrl=Constants.OFFICE_ONLINE_HOST;//offic online 服务器地址
		}		
		//2018.11.22结束
		
		if(!officeUrl.endsWith("/")){
			officeUrl = officeUrl + "/";
		}
		//文件服务器真实IP地址
		//String fileUrl = "http://"+request.getLocalAddr()+":"+request.getLocalPort()+"/"+request.getLocalName();
		//String fileUrl = getWebPath(request);
		
		//此处修改为获取admin上传服务器地址（由于上传地址保存在admin服务器中）
//		String fileUrl = Constants.ADMIN_WEB_PATH;
//		if(fileUrl==null){//如果未配置则获取当前web地址
//			fileUrl = getWebPath(request);
//		}
		
		String ext = getFileExt(file);
		if(ext == null){
			return null;
		}
		String uri = urls.get("view-"+ext);
		if(uri == null){
			return null;
		}
		//转码处理
//		fileUrl = URLEncoder4UTF8(fileUrl);
		path = URLEncoder4UTF8(path);
		file = URLEncoder4UTF8(URLEncoder4UTF8(file));//文件名如果包含中文必须要二次转码（此处默认二次转码）
		//安装officeonline规则拼接预览地址
//		str.append(officeUrl).append(uri)
//			.append("&WOPISrc=").append(fileUrl).append(URLEncoder4UTF8("/wopi/files")).append(path).append(file);
			//.append("&access_token=").append(token);//token为安全验证口令，暂未添加
		return str.toString();
	}
	//文件地址包含文件名时
	public static String getResourceReviewUrl(HttpServletRequest request, String filePath){
		if(StringUtils.isEmpty(filePath)){
			return null;
		}
		if(filePath.endsWith("/")){
			return null;
		}
		int last = filePath.lastIndexOf("/")+1;
		String file = filePath.substring(last);
		String path = filePath.substring(0, last);
		return getResourceReviewUrl(request, file, path);
	}
	
	/**
	 * 获取文件资源下载地址
	 * @param request
	 * @param file 文件名
	 * @param path 文件路径
	 * @return
	 */
	public static String getResourceDownUrl(HttpServletRequest request, String file,String path){
		if(StringUtils.isEmpty(file)){
			return null;
		}
		if(StringUtils.isEmpty(path)){
			return null;
		}
		if(!path.endsWith("/")){
			path = path + "/";
		}
		StringBuilder str = new StringBuilder();
		//文件服务器真实IP地址
		//String fileUrl = "http://"+request.getLocalAddr()+":"+request.getLocalPort()+"/"+request.getLocalName();
		String fileUrl = getWebPath(request);
		//安装officeonline规则拼接预览地址
		str.append(fileUrl).append(URLEncoder4UTF8("/wopi/files")).append(path).append(file).append("/contents");
		return str.toString();
	}
	//文件地址包含文件名时
	public static String getResourceDownUrl(HttpServletRequest request, String filePath){
		if(StringUtils.isEmpty(filePath)){
			return null;
		}
		if(filePath.endsWith("/")){
			return null;
		}
		int last = filePath.lastIndexOf("/")+1;
		String file = filePath.substring(last);
		String path = filePath.substring(0, last);
		return getResourceDownUrl(request, file, path);
	}
	
	/**
	 * getFile，获取文件流
	 * @param path 文件真实地址
	 * @param response
	 * @return
	 */
	public static HttpServletResponse getFile(String path, HttpServletResponse response) {
        try {
            // path是指欲下载的文件的路径。
            File file = new File(path);
            // 取得文件名。
            String filename = file.getName();
            String contentType = "application/octet-stream";
            // 以流的形式下载文件。
            InputStream fis = new BufferedInputStream(new FileInputStream(path));
            byte[] buffer = new byte[fis.available()];
            fis.read(buffer);
            fis.close();
            // 清空response
            response.reset();
            // 设置response的Header

            response.addHeader("Content-Disposition", "attachment;filename=" + new String(filename.getBytes("utf-8"),"ISO-8859-1"));
            response.addHeader("Content-Length", "" + file.length());
            OutputStream toClient = new BufferedOutputStream(response.getOutputStream());
            response.setContentType(contentType);
            toClient.write(buffer);
            toClient.flush();
            toClient.close();
            //new GetFilterAction().download();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        return response;
    }
	
	/**
     * 获取文件基本信息
     * @param filePath      文件路径
     * @return 
     */
    public static String checkFileInfo(String filePath) {
            File file = new File(filePath);
            String baseFileName = null;     //文件名
            String ownerId = null;  //文件所有者的唯一编号
            long size = 0;  //文件大小，以bytes为单位
            //String sha256 = null; //文件的256位bit的SHA-2编码散列内容
            long version = 0;       //文件版本号，文件如果被编辑，版本号也要跟着改变
            if(file.exists()) {
                    // 取得文件名。
                    baseFileName = file.getName();
                    size = file.length();
                    // 取得文件的后缀名。
                    //String ext = baseFileName.substring(baseFileName.lastIndexOf(".") + 1);
                    ownerId = "admin";
                    //sha256 = new SHAUtils().SHA(FileUtils.readByByte(file), "SHA-256");
                    version = file.lastModified();
            }
            
            return "{\"BaseFileName\":\"" + baseFileName + "\",\"OwnerId\":\"" + ownerId + "\",\"Size\":\"" + size
                            + "\",\"AllowExternalMarketplace\":\"" + true + "\",\"Version\":\"" + version + "\"}";
    }
	
	/**
	 * 获取文件后缀名
	 * @param fileName 文件名
	 * @return 文件后缀名
	 */
	public static String getFileExt(String fileName){
		if(StringUtils.isEmpty(fileName)){
			return null;
		}
		String ext = null;
		int index = -1;
		if((index = fileName.lastIndexOf(".")) > -1){
			ext = fileName.substring(index+1);
			ext = ext.toLowerCase();
		}
		
		return ext;
	}
	
	/**
	 * 获取系统web地址
	 * 如：http://192.168.1.1:8080/ServletTest
	 * @param request
	 * @return 
	 */
	public static String getWebPath(HttpServletRequest request){
		StringBuffer str = request.getRequestURL();
		if ("/ROOT".equals(request.getContextPath())) {
			return str.substring(0, str.indexOf(request.getRequestURI()));
		} else {
			return str.substring(0, str.indexOf(request.getContextPath())+request.getContextPath().length());
		}
	}
	
	/**
	 * utf8转码处理
	 * @Title: URLEncoder4UTF8
	 * @Description: TODO(这里用一句话描述这个方法的作用)
	 * @param @param str
	 * @param @return    设定文件
	 * @return String    返回类型
	 * @throws 
	 */
	public static String URLEncoder4UTF8(String str){
		try {
			str = URLEncoder.encode(str, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return str;
	}
	
}

