package com.yipin.liuwanr;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;

public class PropertiesUtils extends PropertyPlaceholderConfigurer {

	public static Map<String, Object> ctxPropertiesMap;

	@Override
	protected void processProperties(ConfigurableListableBeanFactory beanFactoryToProcess, Properties props)
			throws BeansException {
		super.processProperties(beanFactoryToProcess, props);
		ctxPropertiesMap = new HashMap<String, Object>();
		for (Object key : props.keySet()) {
			String keyStr = key.toString();
			String value = props.getProperty(keyStr);
			ctxPropertiesMap.put(keyStr, value);
		}
	}

	public static String getContextProperty(String name) {
		return (String)ctxPropertiesMap.get(name);
	}
	
    /*private static Properties PRO = new Properties();
    
    static {
        InputStream ins = null;
        try {
            ins = PropertiesUtils.class.getResourceAsStream("/config/application-dev.properties");
            PRO.load(ins);
        } catch (IOException e) {
            System.out.println("加载连连支付配置文件失败！");
            e.printStackTrace();
        } finally {
            try {
                ins.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
    
    public static String getContextProperty(String key){
        String value = PRO.getProperty(key);
        return value;
    }*/

}
