package com.yipin.liuwanr.controller;

import java.util.HashMap;

import javax.servlet.http.HttpServletResponse;

import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.service.AliyunOssService;

@RestController
@RequestMapping("/aliyun")
public class AliyunOssController {

    @Autowired
    private AliyunOssService ossService;

    /**
     * 上传文件
     * @param file
     * @return
     */
    @Log("上传文件")
    @PostMapping("/uploadFiles")
    Response uploadFiles(MultipartFile file) {
        Response resp = new Response();
        HashMap<String, Object> ret = ossService.uploadFiles(file);
        int status = (int) ret.get("retcode");
        if (200 == status) {
            resp.setStatus(status);
            resp.setMessage(ret.get("retvalue"));
        } else {
            resp.setStatus(status);
            resp.setErrmessage(ret.get("retvalue").toString());
        }
        return resp;
	}
	
	/**
	 * 下载文件
	 * @param objectName：在阿里云的文件路径
	 * @return
	 */
	@Log("下载文件")
	@GetMapping("/downloadFiles")
	Response downloadFiles(HttpServletResponse response,@RequestParam String objectName) {
		Response resp = new Response();
		try {
			ossService.downloadFiles(response,objectName);
			resp.setStatus(200);
			resp.setMessage("下载成功！");
		} catch (Exception e) {	
			resp.setStatus(300);
			resp.setErrmessage("下载失败");
		}
		return null;
	}
	
}
