package com.yipin.liuwanr.controller;

import java.util.HashMap;

import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.service.AttendanceService;

@RestController
@RequestMapping("/attendance")
/**
 * 考勤记录
 * @author 或然
 *
 */
public class AttendanceController {
	
	@Autowired
	private AttendanceService attendanceService;
	
    /**
     * 考勤记录展示
     * @param studentId
     * @param courseId
     * @param pageNo
     * @param pageSize
     * @return
     */
	@GetMapping("/queryAttendanceDetailed")
	Response queryAttendanceDetailed(@RequestParam  Integer studentId, @RequestParam Integer courseId,@RequestParam  Integer pageNo,@RequestParam  Integer pageSize) {
		Response resp = new Response();
		if (null==studentId) {
			resp.setStatus(300);
			resp.setErrmessage("学生信息为空");
		}else {
			HashMap<String, Object> ret = attendanceService.queryAttendanceDetailed(studentId,courseId,pageNo, pageSize);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}	
		}		   
		return resp;
	}
	
	
	/**
	 * 考勤记录导出
	 * @param response
	 * @param studentId
	 * @param courseId
	 * @param titles
	 * @return
	 */
	@GetMapping("/exportPractice")
	Response exportPractice(HttpServletResponse response,@RequestParam Integer studentId,@RequestParam Integer courseId,@RequestParam String[] titles) {
		try {
			attendanceService.exportPractice(response,studentId,courseId,titles);
		} catch (Exception e) {
			return null;			
		}		
		return null;			
	}
	
	
	/**
	 * 考勤个人信息展示
	 * @param studentId
	 * @param courseId
	 * @return
	 */
	@GetMapping("/queryAttendanceSignIn")
	Response queryAttendanceSignIn(@RequestParam Integer studentId,@RequestParam Integer courseId) {
		Response resp = new Response();
		if (null==studentId) {
			resp.setStatus(300);
			resp.setErrmessage("学生信息为空");
		}else {
			HashMap<String, Object> ret = attendanceService.queryAttendance(studentId,courseId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
}
