package com.yipin.liuwanr.controller;

import java.util.HashMap;

import com.yipin.liuwanr.entity.StudentCity;
import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.helper.RedisHelper;
import com.yipin.liuwanr.service.CityService;

@RestController
@RequestMapping("/city")
@CrossOrigin
public class CityController {

	@Autowired
	private CityService cityService;

	@Autowired
	RedisHelper redisHelper;	

	/**
	 * 	添加城市
	 */
	@Log("添加城市")
	@PostMapping("/addCity")
	Response addCustomer(@RequestBody StudentCity studentCity) {
		Response resp = new Response();
			HashMap<String, Object> ret = cityService.addCity(studentCity);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		return resp;
	}
	
	/**
	 * 	查询城市
	 */
	@GetMapping("/queryCity")
	Response queryCity(@RequestParam Integer provinceId) {
		Response resp = new Response();
		HashMap<String, Object> ret = cityService.queryCity(provinceId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
}
	
	/**
	 * 	删除城市
	 */
	@Log("删除城市")
	@PostMapping("/deleteCity")
	Response deleteCity(@RequestParam Integer cityId) {
		Response resp = new Response();
		if (cityId==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = cityService.deleteCity(cityId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	更新城市
	 */
	@Log("更新城市")
	@RequestMapping(value="/updateCity",method = RequestMethod.POST)
	Response updateCity(@RequestBody StudentCity studentCity) {
		Response resp = new Response();
		if (studentCity ==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = cityService.updateCity(studentCity);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
}
