package com.yipin.liuwanr.controller;

import java.util.HashMap;
import java.util.List;

import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Course;
import com.yipin.liuwanr.entity.CourseLink;
import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.entity.ServiceConfig;
import com.yipin.liuwanr.helper.RedisHelper;
import com.yipin.liuwanr.service.CourseService;
import com.yipin.liuwanr.vo.CourseVO;

@RestController
@RequestMapping("/course")
@CrossOrigin
public class CourseController {

	@Autowired
	private CourseService courseService;

	@Autowired
	RedisHelper redisHelper;	

	/**
	 * 	添加课程
	 * 
	 */
	@Log("添加课程")
	@PostMapping("/addCourse")
	Response addCustomer(@RequestBody CourseVO vo) {
		Response resp = new Response();
		Course course = vo.getCourse();
		List<ServiceConfig> serviceConfigList = vo.getServiceConfigList();
		//课程名称
		String courseName = course.getCourseName();
		//课程类型
		Integer courseType = course.getCourseType();
		//学科类型id
		Integer disciplineId = course.getDisciplineId();
		//专业类id
		Integer professionalClassId = course.getProfessionalClassId();
		//专业id
		Integer professionalId = course.getProfessionalId();
		//市场价格
		double marketPrice = course.getMarketPrice();
		Double price =new Double(marketPrice);
		//课程简介
		String CourseIntroduction = course.getCourseIntroduction();
		//教学目标
		String TeachingGoal = course.getTeachingGoal();
		//绑定系统id
		String SystemId = course.getSystemId();
		if (courseName==null||courseName=="") {
			resp.setStatus(300);
			resp.setErrmessage("课程名称为空!");
		}else if(courseType==null){
			resp.setStatus(300);
			resp.setErrmessage("课程类型为空!");
		}else if(course.getDisciplineId()==null){
			resp.setStatus(300);
			resp.setErrmessage("学科类别为空!");
		}else if(professionalClassId==null){
			resp.setStatus(300);
			resp.setErrmessage("专业类为空!");
		}else if(professionalId==null){
			resp.setStatus(300);
			resp.setErrmessage("专业为空!");
		}else if(price==null){
			resp.setStatus(300);
			resp.setErrmessage("市场价格为空!");
		}else if(CourseIntroduction==null||CourseIntroduction==""){
			resp.setStatus(300);
			resp.setErrmessage("课程简介为空!");
		}else if(TeachingGoal==null||TeachingGoal==""){
			resp.setStatus(300);
			resp.setErrmessage("教学目标为空!");
		}else if(SystemId==null||SystemId==""){
			resp.setStatus(300);
			resp.setErrmessage("绑定系统id为空!");
		}else {
			HashMap<String, Object> ret = courseService.addCourse(course);
			Integer courseId = (Integer) ret.get("retvalue");
			Integer size = vo.getServiceConfigList().size(); 
			for (int i = 0; i < size; i++) {
				serviceConfigList.get(i).setCourseId(courseId);
			}
//			HashMap<String, Object> retPC = courseService.addCoursePC(serviceConfigList);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				HashMap<String, Object> retPC = courseService.addCoursePC(serviceConfigList);
				int statusPC = (int) retPC.get("retcode");
				if (statusPC == 200) {
					resp.setStatus(statusPC);
					resp.setMessage(retPC.get("retvalue"));
				}else{
					resp.setStatus(statusPC);
					resp.setErrmessage(retPC.get("retvalue").toString());
				}
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	/**
	 * 	查询课程名称是否存在
	 */
	@GetMapping("/queryCourseNameIsExists")
	Response queryCourseNameIsExists(@RequestParam String courseName) {
		Response resp = new Response();
		if (courseName==null||courseName=="") {
			resp.setStatus(300);
			resp.setErrmessage("课程名称为空！");
		}else {
			HashMap<String, Object> ret = courseService.queryCourseNameIsExists(courseName);
			int status = (int) ret.get("retcode");
				if (200 == status) {
					resp.setStatus(status);
					resp.setMessage(ret.get("retvalue"));
				} else {
					resp.setStatus(status);
					resp.setErrmessage(ret.get("retvalue").toString());
				}
		}
		return resp;
	}

	/**
	 * 	查询课程
	 */
	@GetMapping("/queryCourse")
	Response queryCourse(@RequestParam Integer disciplineId,Integer professionalClassId,Integer professionalId,Integer pageNo,Integer pageSize,String searchContent,Integer courseType) {
		Response resp = new Response();
		Course course  = new Course();
		if (searchContent!=null&&searchContent!="") {
			course.setSearchContent(searchContent);
		}
		if (disciplineId!=null) {
			course.setDisciplineId(disciplineId);
		}
		if (professionalClassId!=null) {
			course.setProfessionalClassId(professionalClassId);
		}
		if (professionalId!=null) {
			course.setProfessionalId(professionalId);
		}
		if (courseType!=null) {
			course.setCourseType(courseType);
		}
		HashMap<String, Object> ret = courseService.queryCourse(course,pageNo,pageSize);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
}
	
	/**
	 * 	查询课程详情
	 */
	@GetMapping("/queryCourseDetails")
	Response queryCourseDetails(@RequestParam Integer courseId) {
		Response resp = new Response();
		if (courseId==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}else {
			HashMap<String, Object> ret = courseService.queryCourseDetails(courseId);
			resp.setStatus(200);
			resp.setErrmessage("Parameter effective");
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}	
		}
	return resp;
}
	
//	/**
//	 * 	查询课程详情课程权限
//	 */
//	@GetMapping("/queryCourseDetailsTC")
//	Response queryCourseDetailsTC(@RequestParam Integer courseId,Integer pageNo,Integer pageSize) {
//		Response resp = new Response();
//		if (courseId==null) {
//			resp.setStatus(300);
//			resp.setErrmessage("Parameter Invalid");
//		}else {
//			HashMap<String, Object> ret = courseService.queryCourseDetailsTC(courseId,pageNo,pageSize);
//			resp.setStatus(200);
//			resp.setErrmessage("Parameter effective");
//			int status = (int) ret.get("retcode");
//			if (200 == status) {
//				resp.setStatus(status);
//				resp.setMessage(ret.get("retvalue"));
//			} else {
//				resp.setStatus(status);
//				resp.setErrmessage(ret.get("retvalue").toString());
//			}	
//		}
//	return resp;
//}
	
	/**
	 * 	删除课程
	 */
	@Log("删除课程")
	@PostMapping("/deleteCourse")
	Response deleteCourse(@RequestBody List<Integer> courseId) {
		Response resp = new Response();
		if (courseId.isEmpty()) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = courseService.deleteCourse(courseId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	更新课程
	 */
	@Log("更新课程")
	@RequestMapping(value="/updateCourse",method = RequestMethod.POST)
	Response updateCourse(@RequestBody CourseVO vo) {
		Response resp = new Response();
		Course course = vo.getCourse();
		List<ServiceConfig> serviceConfigList = vo.getServiceConfigList();
		if (course.getCourseId()==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = courseService.updateCourse(course);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				Integer courseId = course.getCourseId();
				HashMap<String, Object> ret1 = courseService.deleteCoursePC(courseId);
				Integer size = vo.getServiceConfigList().size(); 
				for (int i = 0; i < size; i++) {
					serviceConfigList.get(i).setCourseId(courseId);
				}
				HashMap<String, Object> ret2 = courseService.addCoursePC(serviceConfigList);
//				int status1 = (int) ret1.get("retcode");
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	是否上架课程控制
	 */
	@PostMapping("/isShelves")
	Response isShelves(@RequestBody Course course) {
		Response resp = new Response();
		if (course.getCourseId()==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}else if (course.getIsShelves() == null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = courseService.isShelves(course);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	查询课程学科
	 */
	@GetMapping("/queryCourseDiscipline")
	Response queryCourseDiscipline() {
		Response resp = new Response();
		HashMap<String, Object> ret = courseService.queryCourseDiscipline();
		resp.setStatus(200);
		resp.setErrmessage("Parameter effective");
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}	
	return resp;
	}
	
	/**
	 * 	查询课程专业类
	 */
	@GetMapping("/queryCourseProfessionalClass")
	Response queryCourseProfessionalClass(@RequestParam Integer disciplineId) {
		Response resp = new Response();
		HashMap<String, Object> ret = courseService.queryCourseProfessionalClass(disciplineId);
		resp.setStatus(200);
		resp.setErrmessage("Parameter effective");
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}	
	return resp;
	}
	
	/**
	 * 	查询课程专业
	 */
	@GetMapping("/queryCourseProfessional")
	Response queryCourseProfessional(@RequestParam Integer professionalClassId) {
		Response resp = new Response();
		HashMap<String, Object> ret = courseService.queryCourseProfessional(professionalClassId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
	}
	
	/**
	 * 	查询应用配置
	 */
	@GetMapping("/queryAppConfig")
	Response queryAppConfig(@RequestParam String searchContent,@RequestParam List<Integer> systemId) {
		Response resp = new Response();
		ServiceConfig serviceConfig = new ServiceConfig();
		HashMap<String, Object> ret = courseService.queryAppConfig(searchContent,systemId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
}
	
	/**
	 * 	添加项目环节
	 */
	@PostMapping("/addCourseLink")
	Response addCourseLink(@RequestBody CourseLink courseLink) {
		Response resp = new Response();
		List<CourseLink> courseLinkList = courseLink.getCourseLink();
		if (courseLinkList.isEmpty()) {
			resp.setStatus(300);
			resp.setErrmessage("courseLinkList Is Null!");
		}else {
			Integer size = courseLinkList.size();
			//根据courseId批量删除hr_course_link表中数据
			int j = courseService.deleteCourseLink(courseLinkList.get(0).getCourseId());
			for (int i = 0; i < size; i++) {
				Integer courseId = courseLinkList.get(i).getCourseId();
				Integer projectId = courseLinkList.get(i).getProjectId();
				if (courseId==null) {
					resp.setStatus(300);
					resp.setErrmessage("courseId Is Null!");
					return resp;
				}if(projectId==null) {
					resp.setStatus(300);
					resp.setErrmessage("projectId Is Null!");
					return resp;
				}
			}
				HashMap<String, Object> ret = courseService.addCourseLink(courseLinkList);
				int status = (int) ret.get("retcode");
				if (200 == status) {
					resp.setStatus(status);
					resp.setMessage(ret.get("retvalue"));
				} else {
					resp.setStatus(status);
					resp.setErrmessage(ret.get("retvalue").toString());
				
			}
	}
		return resp;
}
	
	/**
	 * 	查询实训配置
	 */
	@GetMapping("/queryTrainingConfig")
	Response queryTrainingConfig(@RequestParam Integer courseId) {
		Response resp = new Response();
		if (courseId ==null) {
			resp.setStatus(300);
			resp.setErrmessage("courseId Is Null!");
		}
		HashMap<String, Object> ret = courseService.queryTrainingConfig(courseId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
	}
	
	/**
	 * 	绑定实训配置
	 */
	@PostMapping("/addTrainingConfig")
	Response addTrainingConfig(@RequestBody Course course) {
		Response resp = new Response();
		Integer courseId = course.getCourseId();
		String systemId = course.getSystemId();
		if (courseId==null) {
			resp.setStatus(300);
			resp.setErrmessage("courseId Is Null!");
		}
		if (systemId==null) {
			resp.setStatus(300);
			resp.setErrmessage("systemId Is Null!");
		}
		HashMap<String, Object> ret = courseService.addTrainingConfig(course);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
	}
	
	/**
	 * 	查询环节详情
	 */
	@GetMapping("/queryLinkDetails")
	Response queryLinkDetails(@RequestParam Integer courseId,Integer projectId) {
		Response resp = new Response();
		CourseLink courseLink = new CourseLink();
		if (projectId!=null) {
			courseLink.setProjectId(projectId);
		}
		if(courseId!= null){
			courseLink.setCourseId(courseId);
		}
		HashMap<String, Object> ret = courseService.queryLinkDetails(courseLink);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
	}
	
	/**
	 * 	更新环节
	 */
	@Log("更新环节")
	@PostMapping("/updateLink")
	Response updateLink(@RequestBody CourseLink courseLink) {
		Response resp = new Response();
		if (courseLink.getLinkId() ==null) {
			resp.setStatus(300);
			resp.setErrmessage("LinkId Is Null!");
		}
		HashMap<String, Object> ret = courseService.updateLink(courseLink);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
	}
	
//	/**
//	 * 	删除实训配置
//	 */
//	@PostMapping("/deleteTrainingConfig")
//	Response deleteTrainingConfig(@RequestBody Course course) {
//		Response resp = new Response();
//		if (course.getProjectId()==null) {
//			resp.setStatus(300);
//			resp.setErrmessage("Parameter Invalid");
//		} else {
//			HashMap<String, Object> ret = courseService.deleteTrainingConfig(course);
//			int status = (int) ret.get("retcode");
//			if (200 == status) {
//				resp.setStatus(status);
//				resp.setMessage(ret.get("retvalue"));
//			} else {
//				resp.setStatus(status);
//				resp.setErrmessage(ret.get("retvalue").toString());
//			}
//		}
//		return resp;
//	}
	
//	/**
//	 * 	是否展示项目控制
//	 */
//	@PostMapping("/isShow")
//	Response isShow(@RequestBody Course course) {
//		Response resp = new Response();
//		if (course.getProjectId()==null) {
//			resp.setStatus(300);
//			resp.setErrmessage("Parameter Invalid");
//		}else if (course.getIsShow() == null) {
//			resp.setStatus(300);
//			resp.setErrmessage("Parameter Invalid");
//		} else {
//			HashMap<String, Object> ret = courseService.isShow(course);
//			int status = (int) ret.get("retcode");
//			if (200 == status) {
//				resp.setStatus(status);
//				resp.setMessage(ret.get("retvalue"));
//			} else {
//				resp.setStatus(status);
//				resp.setErrmessage(ret.get("retvalue").toString());
//			}
//		}
//		return resp;
//	}
	
	/**
	 * 	查询配置
	 */
	@GetMapping("/queryConfig")
	Response queryConfig(@RequestParam String systemId,Integer pageNo,Integer pageSize) {
		Response resp = new Response();
		if (systemId ==null||systemId == "") {
			resp.setStatus(300);
			resp.setErrmessage("systemId Is Null!");
		}
		HashMap<String, Object> ret = courseService.queryConfig(systemId,pageNo,pageSize);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
	}
	
	
	@GetMapping("/platformQueryCourse")
	Response platformQueryCourse(Integer schoolId) {
		Response resp = new Response();
		HashMap<String, Object> ret = courseService.platformQueryCourse(schoolId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}	
		return resp;
	}
	
	@GetMapping("/getCourse")
	Response getcouese(Integer courseId) {
		Response resp = new Response();
		HashMap<String, Object> ret = courseService.getcouese(courseId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}	
		return resp;
	}
}
