package com.yipin.liuwanr.controller;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.service.DeviceService;


@RestController
@RequestMapping("/device")
public class DeviceController {
	
	@Autowired
	DeviceService deviceService;

    @GetMapping("/bundling")
    Response bindDevice(@RequestHeader("X-UUID") String uuid, @RequestParam("puid") String puid, @RequestParam("duid") String duid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.bound(uuid, puid, duid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
    
    @DeleteMapping("/bundling")
    Response unbindDevice(@RequestHeader("X-UUID") String uuid, @RequestParam("puid") String puid, @RequestParam("duid") String duid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.unbundling(uuid, puid, duid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
    
    @GetMapping("/detail")
    Response getDeviceDetail(@RequestHeader("X-UUID") String uuid, @RequestParam("duid") String duid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.detail(uuid, duid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
    
    @GetMapping("/status")
    Response getDeviceStatus(@RequestHeader("X-UUID") String uuid, @RequestParam("duid") String duid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.status(uuid, duid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
    
    @GetMapping("/refresh")
    Response callDeviceToRefresh(@RequestHeader("X-UUID") String uuid, @RequestParam("duid") String duid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.refresh(uuid, duid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
    
    @GetMapping("/health")
    Response getPetHealth(@RequestHeader("X-UUID") String uuid, @RequestParam("duid") String duid, @RequestParam("period") String period) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.health(uuid, duid, period);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
    
    @GetMapping("/track")
    Response trackPetPath(@RequestHeader("X-UUID") String uuid, @RequestParam("duid") String duid, @RequestParam("from") long from, @RequestParam("to") long to) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.track(uuid, duid, from, to);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
    
    @GetMapping("/snapshot")
    Response callDeviceToSnapshot(@RequestHeader("X-UUID") String uuid, @RequestParam("duid") String duid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = deviceService.snapshot(uuid, duid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
}
