package com.yipin.liuwanr.controller;

import java.util.HashMap;

import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import com.yipin.liuwanr.entity.Attendance;
import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.service.ExperimentallearningService;

@RestController
@RequestMapping("/Experimentallearning")
public class ExperimentallearningController {

	@Autowired
	private ExperimentallearningService service;
	
	/**
	 * 实验项目
	 * @param courseId
	 * @return
	 */
	@GetMapping("/queryExperimentallearning")
	Response queryExperimentallearning(@RequestParam Integer studentId,@RequestParam  Integer courseId) {
		Response resp = new Response();
		if(StringUtils.isEmpty(studentId)){
			resp.setStatus(300);
			resp.setMessage("学生信息为空");
		}else {
			HashMap<String, Object> ret = service.queryProject(studentId,courseId);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	

	
	/**
	 * 添加签到记录
	 */
	@Log("添加签到记录")
	@PostMapping("/insertAttendance")
	Response insertAttendance(@RequestBody Attendance attendance) {
		Response resp = new Response();
		if(null==attendance) {
			resp.setStatus(300);
			resp.setMessage("attendance is null");
		}else {
			HashMap<String, Object> ret = service.insertAttendance(attendance);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	
	/**
	 * 获取教师信息
	 */
	@GetMapping("/queryTeacherName")
	Response queryTeacherName(@RequestParam Integer courseId,@RequestParam Integer studentId) {
		Response resp = new Response();
		if(StringUtils.isEmpty(studentId)){
			resp.setStatus(300);
			resp.setErrmessage("学生信息为空");
		}else{
			HashMap<String, Object> ret = service.queryTeacherName(courseId,studentId);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	
	
	/**
	 * 获取学生信息
	 */
	@GetMapping("/queryStudentName")
	Response queryStudentName(@RequestParam Integer courseId,@RequestParam Integer studentId) {
		Response resp = new Response();
		if(StringUtils.isEmpty(studentId)){
			resp.setStatus(300);
			resp.setErrmessage("学生信息为空");
		}else{
			HashMap<String, Object> ret = service.queryStudentName(courseId,studentId);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 进入考核
	 */
	@GetMapping("/queryAssesment")
	Response queryAssesment(@RequestParam Integer studentId,@RequestParam  Integer courseId) {
		Response resp = new Response();
		if(StringUtils.isEmpty(studentId)){
			resp.setStatus(300);
			resp.setMessage("学生信息为空");
		}else {
			HashMap<String, Object> ret = service.queryAssesment(courseId, studentId);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	@GetMapping("/queryStudentCourse")
	Response queryStudentCourse(@RequestParam Integer studentId) {
		Response resp = new Response();
		if(StringUtils.isEmpty(studentId)){
			resp.setStatus(300);
			resp.setMessage("学生信息为空");
		}else {
			HashMap<String, Object> ret = service.queryStudentCourse(studentId);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	
}
