package com.yipin.liuwanr.controller;


import com.github.pagehelper.PageInfo;
import com.yipin.liuwanr.entity.HrUserAccount;
import com.yipin.liuwanr.entity.PageResult;
import com.yipin.liuwanr.entity.ServiceConfig;
import com.yipin.liuwanr.entity.response.ResponseResult;
import com.yipin.liuwanr.entity.response.UserSysDetailRes;
import com.yipin.liuwanr.entity.vo.UserInfoReq;
import com.yipin.liuwanr.service.IHrUserAccountService;
import com.yipin.liuwanr.service.UserInfoService;
import com.yipin.liuwanr.util.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.stereotype.Controller;

import java.util.List;

/**
 * <p>
 * 各个平台账号表 前端控制器
 * </p>
 *
 * @author Qyq
 * @since 2021-06-18
 */
@RestController
@RequestMapping("/hr-user-account")
public class HrUserAccountController {

    @Autowired
    private UserInfoService userInfoService;

    @Autowired
    private IHrUserAccountService iHrUserAccountService;

    /**
     * 	查询用户管理列表
     */
    @PostMapping("/queryUserInfoList")
    ResponseResult queryUserInfoList(@RequestBody UserInfoReq userInfoReq) {
        List data = iHrUserAccountService.queryPage(userInfoReq.getPage(), userInfoReq.getSize(), userInfoReq);
        //单独的分页操作
        PageInfo<ServiceConfig> info = new PageInfo<ServiceConfig>(data);
        int total1 = (int) info.getTotal();
        int totalPages;
        totalPages = total1 / userInfoReq.getSize();
        if (total1 % userInfoReq.getSize() != 0) {
            totalPages++;
        }
        long total = total1;
        return ResponseResult.SUCCESS(new PageResult(total, data, totalPages));
    }

    /**
     * 	密码重置，以手机号的维度，重置所有账号密码为111aaa
     */
    @GetMapping("/resetPwd")
    ResponseResult resetPwd(@RequestParam("userId") Integer userId) {
        int result = iHrUserAccountService.resetPwd(userId);
        return result>0 ? ResponseResult.SUCCESS() : ResponseResult.FAIL();
    }

    /**
     * 	删除用户以及账号
     */
    @GetMapping("/delUserAccount")
    ResponseResult delUserAccount(@RequestParam("userId") Integer userId,@RequestParam("isdel")Integer isdel) {
        int result = iHrUserAccountService.delUserAccount(userId,isdel);
        return result>0 ? ResponseResult.SUCCESS() : ResponseResult.FAIL();
    }

    /**
     * 	查看用户系统绑定详情
     */
    @GetMapping("/selectUserSysBind")
    ResponseResult selectUserSysBind(@RequestParam("userId") Integer userId,@RequestParam("platformId")Integer platformId) {
        UserSysDetailRes result = iHrUserAccountService.selectUserSysBind(userId,platformId);
        return ResponseResult.SUCCESS(result);
    }

    /**
     * 	查看个人账号信息详情
     */
    @GetMapping("/selectAccountDetail")
    ResponseResult selectAccountDetail(@RequestParam("accountId") Integer accountId) {
        HrUserAccount result = iHrUserAccountService.selectAccountDetail(accountId);
        return ResponseResult.SUCCESS(result);
    }

    /**
     * 	查询用户管理列表(不可用)
     */
    @PostMapping("/queryUserInfoList2")
    ResponseResult queryUserInfoList2(@RequestBody UserInfoReq userInfoReq) {
        PageUtils data = iHrUserAccountService.queryPage2(userInfoReq.getPage(), userInfoReq.getSize(), userInfoReq);
        return ResponseResult.SUCCESS(data);
    }
}
