package com.yipin.liuwanr.controller;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.HashMap;

import javax.servlet.http.HttpServletResponse;

import com.yipin.liuwanr.vo.MakeupStudentsVo;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.helper.ExcelExportHelper;
import com.yipin.liuwanr.service.MakeuplistService;

@RestController
@RequestMapping("/makeuplist")
public class MakeuplistController {

	@Autowired
	private MakeuplistService makeuplistService;

	/**
	 * 上传Excel文件，读取数据到数据库
	 * @return
	 */
	@PostMapping("/importMakeuplist")
	Response queryCustomer( MakeupStudentsVo  vo) {
		Response resp = new Response();
		MultipartFile file=vo.getFile();
		Integer staffId=vo.getStaffId();
		Integer schoolId=vo.getSchoolId();
		long uploadTime=vo.getUploadTime();

		if(StringUtils.isEmpty(staffId)) {
			resp.setStatus(300);
			resp.setMessage("教师信息为空");
		}else if(StringUtils.isEmpty(uploadTime)){
			resp.setStatus(300);
			resp.setMessage("文件上传时间为空");
		}else if(StringUtils.isEmpty(schoolId)){
			resp.setStatus(300);
			resp.setMessage("学校为空");
		}else{
			HashMap<String, Object> ret = makeuplistService.addMakeuplist(file,schoolId,staffId,uploadTime);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}

		return resp;
	}

	/**
	 * 在补考名单中，渲染表格
	 * @return
	 */
	@GetMapping("/queryGetByClassName")
	Response queryGetByClassName(@RequestParam Integer staffId,@RequestParam Long uploadTime,
         @RequestParam Integer uploadType,@RequestParam Integer schoolId) {
		Response resp = new Response();
		if(StringUtils.isEmpty(staffId)) {
			resp.setStatus(300);
			resp.setMessage("staffId cannot be empty ");
		} else if(StringUtils.isEmpty(uploadTime)){
			resp.setStatus(300);
			resp.setMessage("文件上传时间为空");
		}else if(StringUtils.isEmpty(uploadType)){
			resp.setStatus(300);
			resp.setMessage("文件上传选项为空");
		}else if(StringUtils.isEmpty(schoolId)){
			resp.setStatus(300);
			resp.setMessage("学校信息为空");
		}else {
			HashMap<String, Object> ret = makeuplistService.queryAllMakeuplist(staffId,uploadTime,uploadType,schoolId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	/**
	 * 下载Excel
	 * @param response
	 * @return
	 */
	@GetMapping("/excelExport")
	Response excelExport( HttpServletResponse response,String fileName,String[] titles) {
		ExcelExportHelper excelExportHelper=new ExcelExportHelper();
		
		String filename=fileName+".xlsx";
		XSSFWorkbook bos=excelExportHelper.excelExport(fileName,titles);
        try {
        	response.setHeader("content-Type","application/vnd.ms-excel");
        	response.setHeader("Content-disposition","attachment;filename="+URLEncoder.encode(filename,"UTF-8"));
        	response.flushBuffer();
			bos.write(response.getOutputStream());			
			bos.close();
			
		} catch (IOException e) {
		
		}
	    return null;
	}

	@GetMapping("/getStudent")
	Response getStudent(@RequestParam Integer staffId,@RequestParam Long  uploadTime,@RequestParam Integer uploadType,
        @RequestParam Integer schoolId){
		Response resp = new Response();
		if(StringUtils.isEmpty(staffId)) {
			resp.setStatus(300);
			resp.setMessage(" 教师信息为空 ");
		} else if(StringUtils.isEmpty(uploadTime)){
			resp.setStatus(300);
			resp.setMessage("文件上传时间为空");
		}else if(StringUtils.isEmpty(uploadType)){
			resp.setStatus(300);
			resp.setMessage("文件上传选项为空");
		}else if(StringUtils.isEmpty(schoolId)){
			resp.setStatus(300);
			resp.setMessage("学校为空");
		}else {
			HashMap<String, Object> ret = makeuplistService.getStudent(staffId,uploadTime,uploadType,schoolId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
}

