package com.yipin.liuwanr.controller;

import com.yipin.liuwanr.service.OrganizationRelationshipService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;

@RestController
@RequestMapping("user")
public class OrganizationRelationshipController {

    @Autowired
    private OrganizationRelationshipService organizationRelationshipService;

    @GetMapping("/list")
    Response updateState(@RequestParam Integer userId) {
        Response resp = new Response();
        if(StringUtils.isEmpty(userId)){
            resp.setStatus(300);
            resp.setErrmessage("用户信息不完整");
        }else{
            HashMap<String, Object> ret = organizationRelationshipService.getByuserId(userId);
            int status = (int) ret.get("retcode");
            if (200 == status) {
                resp.setStatus(status);
                resp.setMessage(ret.get("retvalue"));
            } else {
                resp.setStatus(status);
                resp.setErrmessage(ret.get("retvalue").toString());
            }
        }
        return resp;
    }

    @DeleteMapping("/delete")
    Response delorganizationRelationship(@RequestParam Integer organizationRelationshipId) {
        Response resp = new Response();
        if(StringUtils.isEmpty(organizationRelationshipId)){
            resp.setStatus(300);
            resp.setErrmessage("组织关系信息为空");
        }else{
            HashMap<String, Object> ret = organizationRelationshipService.deleteByorganizationRelationshipId(organizationRelationshipId);
            int status = (int) ret.get("retcode");
            if (200 == status) {
                resp.setStatus(status);
                resp.setMessage(ret.get("retvalue"));
            } else {
                resp.setStatus(status);
                resp.setErrmessage(ret.get("retvalue").toString());
            }
        }
        return resp;
    }
}
