package com.yipin.liuwanr.controller;

import java.util.HashMap;

import com.yipin.liuwanr.entity.CourseSchedule;
import com.yipin.liuwanr.entity.annotation.Log;
import com.yipin.liuwanr.vo.CourseAndProjectVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import com.yipin.liuwanr.entity.Project_Management;
import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.service.ProjectAndCourseService;


@RestController
@RequestMapping("/ProjectAndCourse")
public class ProjectAndCourseController {
	
	@Autowired
	private ProjectAndCourseService service;
	
	/**
	 * 根据课程查询实验项目信息
	 * @param courseId
	 * @return
	 */
	@GetMapping("/queryProject")
	Response queryProject(@RequestParam  Integer courseId,@RequestParam Integer experimentalClassId,
	    @RequestParam  Integer pageNo,@RequestParam  Integer pageSize) {
		Response resp = new Response();
		if(StringUtils.isEmpty(experimentalClassId)){
			resp.setStatus(300);
			resp.setErrmessage("实验班级信息为空");
		}else {
			HashMap<String, Object> ret = service.queryProject(courseId,experimentalClassId,pageNo, pageSize);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	/**
	 * 修改项目状态
	 * @return
	 */
	@Log("修改项目状态")
	@PostMapping("/updateIsExperiment")
	Response updateIsExperiment(@RequestBody CourseAndProjectVo vo) {
		Response resp = new Response();
        if(null==vo) {
        	resp.setStatus(300);
			resp.setErrmessage("management Is null");
			return resp;
        }else {	
			HashMap<String, Object> ret = service.updateIsExperiment(vo);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
        }
		return resp;
	}

	/**
	 * 修改考勤状态
	 * @return
	 */
	@Log("修改考勤状态")
	@PostMapping("/updateIsAttendance")
	Response updateIsAttendance(@RequestBody CourseAndProjectVo vo) {
		Response resp = new Response();
		if(null==vo) {
        	resp.setStatus(300);
			resp.setErrmessage("management Is null");
			return resp;
        }else {	
			HashMap<String, Object> ret = service.updateIsAttendance(vo);
			int status = (int) ret.get("retcode");
			if (status == 200) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
        }
		return resp;
	}

	//课程进度
	@GetMapping("/getCourseSchedule")
	Response getCourseSchedule(@RequestParam Integer courseId,@RequestParam Integer experimentalClassId,@RequestParam Integer studentId) {
		Response resp = new Response();

		HashMap<String, Object> ret = service.getCourseSchedule(courseId,experimentalClassId,studentId);
		int status = (int) ret.get("retcode");
		if (status == 200) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
	}

	//添加课程进度
	@Log("添加课程进度")
	@PostMapping("/addCourseSchedule")
	Response addCourseSchedule(@RequestBody CourseSchedule courseSchedule) {
		Response resp = new Response();
		HashMap<String, Object> ret = service.addCourseSchedule(courseSchedule);
		int status = (int) ret.get("retcode");
		if (status == 200) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
	}

	@GetMapping("/getCoursevideo")
	Response getCoursevideo(@RequestParam Integer courseId,@RequestParam Integer experimentalClassId,@RequestParam Integer studentId) {
		Response resp = new Response();
		HashMap<String, Object> ret = service.getCoursevideo(courseId,experimentalClassId,studentId);
		int status = (int) ret.get("retcode");
		if (status == 200) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
	}
}
