package com.yipin.liuwanr.controller;

import java.util.HashMap;

import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Province;
import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.helper.RedisHelper;
import com.yipin.liuwanr.service.ProvinceService;

@RestController
@RequestMapping("/province")
@CrossOrigin
public class ProvinceController {

	@Autowired
	private ProvinceService ProvinceService;

	@Autowired
	RedisHelper redisHelper;	

	/**
	 * 	添加省份
	 */
	@Log("添加省份")
	@PostMapping("/addProvince")
	Response addProvince(@RequestBody Province province) {
		Response resp = new Response();
			HashMap<String, Object> ret = ProvinceService.addProvince(province);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		return resp;
	}
	
	/**
	 * 	查询省份
	 */
	@GetMapping("/queryProvince")
	Response queryProvince() {
		Response resp = new Response();
		Province province  = new Province();
		HashMap<String, Object> ret = ProvinceService.queryProvince(province);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
}
	
	/**
	 * 	删除省份
	 */
	@Log("删除省份")
	@PostMapping("/deleteProvince")
	Response deleteProvince(@RequestParam Integer provinceId) {
		Response resp = new Response();
		if (provinceId==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = ProvinceService.deleteProvince(provinceId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	更新省份
	 */
	@Log("更新省份")
	@RequestMapping(value="/updateProvince",method = RequestMethod.POST)
	Response updateProvince(@RequestBody Province province) {
		Response resp = new Response();
		if (province==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = ProvinceService.updateProvince(province);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
}
