package com.yipin.liuwanr.controller;

import java.util.HashMap;

import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.entity.School;
import com.yipin.liuwanr.helper.RedisHelper;
import com.yipin.liuwanr.service.SchoolService;

@RestController
@RequestMapping("/school")
@CrossOrigin
public class SchoolController {

	@Autowired
	private SchoolService schoolService;

	@Autowired
	RedisHelper redisHelper;	

	/**
	 * 	添加学校
	 */
	@Log("添加学校")
	@PostMapping("/addSchool")
	Response addSchool(@RequestBody School school) {
		Response resp = new Response();
		if (school==null) {
			resp.setStatus(300);
			resp.setErrmessage("Course Name Is Null!");
		}else {
			HashMap<String, Object> ret = schoolService.addSchool(school);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	查询学校
	 */
	@GetMapping("/querySchool")
	Response querySchool(@RequestParam Integer provinceId,Integer cityId,Integer level) {
		Response resp = new Response();
		School school  = new School();
		if (provinceId!=null) {
			school.setProvinceId(provinceId);
		}
		if (cityId!=null) {
			school.setCityId(cityId);
		}
		if (level!=null) {
			school.setLevel(level);
		}
		HashMap<String, Object> ret = schoolService.querySchool(school);
		resp.setStatus(200);
		resp.setErrmessage("Parameter effective");
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	return resp;
}
	
	/**
	 * 	查询学校详情
	 */
	@GetMapping("/querySchoolDetails")
	Response querySchoolDetails(@RequestParam Integer schoolId) {
		Response resp = new Response();
		School school  = new School();
		if (schoolId==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}else {
			HashMap<String, Object> ret = schoolService.querySchoolDetails(schoolId);
			resp.setStatus(200);
			resp.setErrmessage("Parameter effective");
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}	
		}
	return resp;
}
	
	/**
	 * 	删除学校
	 */
	@Log("删除学校")
	@PostMapping("/deleteSchool")
	Response deleteSchool(@RequestBody School school) {
		Response resp = new Response();
		if (school==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = schoolService.deleteSchool(school);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	更新学校
	 */
	@Log("更新学校")
	@PostMapping("/updateSchool")
	Response updateSchool(@RequestBody School school) {
		Response resp = new Response();
		if (school==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = schoolService.updateSchool(school);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
}
