package com.yipin.liuwanr.controller;

import java.util.HashMap;

import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.entity.StaffProfessionalArchitecture;
import com.yipin.liuwanr.helper.RedisHelper;
import com.yipin.liuwanr.service.StaffProfessionalArchitectureService;

@RestController
@RequestMapping("/staffProfessionalArchitecture")
@CrossOrigin
public class StaffProfessionalArchitectureController {

	@Autowired
	private StaffProfessionalArchitectureService staffProfessionalArchitectureService;

	@Autowired
	RedisHelper redisHelper;

	/**
	 * 	添加员工专业组织
	 */
	@Log("添加员工专业组织")
	@PostMapping("/addStaffProfessionalArchitecture")
	Response addCustomer(@RequestBody StaffProfessionalArchitecture staffProfessionalArchitecture) {
		Response resp = new Response();
		String staffProfessionalArchitectureName = staffProfessionalArchitecture.getStaffProfessionalArchitectureName();
		Integer schoolId = staffProfessionalArchitecture.getSchoolId();
		if (staffProfessionalArchitectureName==null||staffProfessionalArchitectureName==""||schoolId ==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}
		else {
			HashMap<String, Object> ret = staffProfessionalArchitectureService.addStaffProfessionalArchitecture(staffProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	查询员工专业架构
	 */
	@GetMapping("/queryStaffProfessionalArchitecture")
	Response queryStaffProfessionalArchitecture(@RequestParam Integer schoolId) {
		Response resp = new Response();
		if (schoolId == null) {
			resp.setStatus(300);
			resp.setMessage("schoolId is null!");
		}else {
			HashMap<String, Object> ret = staffProfessionalArchitectureService.queryStaffProfessionalArchitecture(schoolId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
}
	
	/**
	 * 	查询员工全部专业架构
	 */
	@GetMapping("/queryAllStaffProfessionalArchitecture")
	Response queryAllStaffProfessionalArchitecture(@RequestParam Integer schoolId) {
		Response resp = new Response();
		if (schoolId == null) {
			resp.setStatus(300);
			resp.setMessage("schoolId is null!");
		}else {
			HashMap<String, Object> ret = staffProfessionalArchitectureService.queryAllStaffProfessionalArchitecture(schoolId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
}
	
	/**
	 * 	删除员工专业架构
	 */
	@Log("删除员工专业架构")
	@PostMapping("/deleteStaffProfessionalArchitecture")
	Response deleteStaffProfessionalArchitecture(@RequestBody StaffProfessionalArchitecture staffProfessionalArchitecture) {
		Response resp = new Response();
		Integer staffProfessionalArchitectureId = staffProfessionalArchitecture.getStaffProfessionalArchitectureId();
		if (staffProfessionalArchitectureId==null) {
			resp.setStatus(300);
			resp.setErrmessage("staffProfessionalArchitectureId Parameter Invalid");
		} else {
			HashMap<String, Object> ret = staffProfessionalArchitectureService.deleteStaffProfessionalArchitecture(staffProfessionalArchitectureId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	更新员工专业架构
	 */
	@Log("更新员工专业架构")
	@PostMapping("/updateStaffProfessionalArchitecture")
	Response updateStaffProfessionalArchitecture(@RequestBody StaffProfessionalArchitecture staffProfessionalArchitecture) {
		Response resp = new Response();
		String staffProfessionalArchitectureName = staffProfessionalArchitecture.getStaffProfessionalArchitectureName();
		if (staffProfessionalArchitectureName==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = staffProfessionalArchitectureService.updateStaffProfessionalArchitecture(staffProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}

	/**
	 * 	查询员工专业架构名称
	 */
	@GetMapping("/queryStaffPAN")
	Response queryStaffPAN(@RequestParam("name") String name,@RequestParam("schoolId") Integer schoolId) {
		Response resp = new Response();
		if (name == null) {
			resp.setStatus(300);
			resp.setMessage("专业组织架构名称为空！");
		}else {
			HashMap<String, Object> ret = staffProfessionalArchitectureService.queryStaffPAN(name,schoolId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
}
