package com.yipin.liuwanr.controller;

import java.util.HashMap;

import com.yipin.liuwanr.entity.annotation.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.entity.StuProfessionalArchitecture;
import com.yipin.liuwanr.helper.RedisHelper;
import com.yipin.liuwanr.service.StuProfessionalArchitectureService;

@RestController
@RequestMapping("/stuProfessionalArchitecture")
@CrossOrigin
public class StuProfessionalArchitectureController {

	@Autowired
	private StuProfessionalArchitectureService stuProfessionalArchitectureService;

	@Autowired
	RedisHelper redisHelper;

	/**
	 * 	添加学生专业组织
	 */
	@Log("添加学生专业组织")
	@PostMapping("/addStuProfessionalArchitecture")
	Response addStuProfessionalArchitecture(@RequestBody StuProfessionalArchitecture stuProfessionalArchitecture) {
		Response resp = new Response();
		String stuProfessionalArchitectureName = stuProfessionalArchitecture.getStuProfessionalArchitectureName();
		Integer SchoolId = stuProfessionalArchitecture.getSchoolId();
		if (stuProfessionalArchitectureName==null||stuProfessionalArchitectureName==""||SchoolId ==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}
		else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.addStuProfessionalArchitecture(stuProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	查询学生专业架构
	 */
	@GetMapping("/queryStuProfessionalArchitecture")
	Response queryStuProfessionalArchitecture(@RequestParam Integer schoolId) {
		Response resp = new Response();
		if (schoolId == null) {
			resp.setStatus(300);
			resp.setMessage("schoolId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStuProfessionalArchitecture(schoolId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
}
	/**
	 * 	查询学生专业架构详情
	 */
	@GetMapping("/queryStuPAD")
	Response queryStuPAD(@RequestParam Integer stuProfessionalArchitectureId) {
		Response resp = new Response();
		if (stuProfessionalArchitectureId == null) {
			resp.setStatus(300);
			resp.setMessage("stuProfessionalArchitectureId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStuPAD(stuProfessionalArchitectureId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
}
	
	/**
	 * 	删除学生专业架构
	 */
	@Log("删除学生专业架构")
	@PostMapping("/deleteStuProfessionalArchitecture")
	Response deleteStuProfessionalArchitecture(@RequestBody StuProfessionalArchitecture professionalArchitecture) {
		Response resp = new Response();
		Integer stuProfessionalArchitectureId = professionalArchitecture.getStuProfessionalArchitectureId();
		if (stuProfessionalArchitectureId==null) {
			resp.setStatus(300);
			resp.setErrmessage("stuProfessionalArchitectureId Parameter Invalid");
		} else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.deleteStuProfessionalArchitecture(stuProfessionalArchitectureId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	删除学生年级
	 */
	@Log("删除学生年级")
	@PostMapping("/deleteStuGrade")
	Response deleteStuGrade(@RequestBody StuProfessionalArchitecture stu) {
		Response resp = new Response();
		Integer gradeId = stu.getGradeId();
		if (gradeId==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.deleteStuGrade(gradeId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	删除学生班级
	 */
	@Log("删除学生班级")
	@PostMapping("/deleteStuClass")
	Response deleteStuClass(@RequestBody StuProfessionalArchitecture stu) {
		Response resp = new Response();
		Integer classId = stu.getClassId();
		if (classId==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.deleteStuClass(classId);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	更新学生专业架构
	 */
	@Log("更新学生专业架构")
	@PostMapping("/updateStuProfessionalArchitecture")
	Response updateStuProfessionalArchitecture(@RequestBody StuProfessionalArchitecture stuProfessionalArchitecture) {
		Response resp = new Response();
		Integer professionalArchitectureId = stuProfessionalArchitecture.getStuProfessionalArchitectureId();
		if (professionalArchitectureId==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		} else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.updateStuProfessionalArchitecture(stuProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	查询全部学生专业架构
	 */
	@GetMapping("/queryStudentProfessionalArchitecture")
	Response queryStudentProfessionalArchitecture(@RequestParam Integer schoolId) {
		Response resp = new Response();
		if (schoolId == null) {
			resp.setStatus(300);
			resp.setMessage("schoolId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStudentProfessionalArchitecture(schoolId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
}
	
	/**
	 * 	查询学生年级
	 */
	@GetMapping("/queryStuGrade")
	Response queryStuGrade(@RequestParam Integer stuProfessionalArchitectureId) {
		Response resp = new Response();
		if (stuProfessionalArchitectureId == null) {
			resp.setStatus(300);
			resp.setMessage("stuProfessionalArchitectureId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStuGrade(stuProfessionalArchitectureId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
}
	
	/**
	 * 	查询学生年级详情
	 */
	@GetMapping("/queryStuGradeD")
	Response queryStuGradeD(@RequestParam Integer gradeId) {
		Response resp = new Response();
		if (gradeId == null) {
			resp.setStatus(300);
			resp.setMessage("gradeId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStuGradeD(gradeId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
}
	
	/**
	 * 	查询学生班级
	 */
	@GetMapping("/queryStuClass")
	Response queryStuClass(@RequestParam Integer gradeId) {
		Response resp = new Response();
		if (gradeId == null) {
			resp.setStatus(300);
			resp.setMessage("gradeId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStuClass(gradeId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
	}
	
	/**
	 * 	查询学生班级详情
	 */
	@GetMapping("/queryStuClassD")
	Response queryStuClassD(@RequestParam Integer classId) {
		Response resp = new Response();
		if (classId == null) {
			resp.setStatus(300);
			resp.setMessage("classId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStuClassD(classId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
	}
	
	/**
	 * 	添加班级
	 */
	@Log("添加班级")
	@PostMapping("/addStuClass")
	Response addStuClass(@RequestBody StuProfessionalArchitecture stuProfessionalArchitecture) {
		Response resp = new Response();
		String stuClassName = stuProfessionalArchitecture.getClassName();
		Integer gradeId = stuProfessionalArchitecture.getGradeId();
		if (stuClassName==null||stuClassName==""||gradeId ==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}
		else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.addStuClass(stuProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	修改班级
	 */
	@Log("修改班级")
	@PostMapping("/updateStuClass")
	Response updateStuClass(@RequestBody StuProfessionalArchitecture stuProfessionalArchitecture) {
		Response resp = new Response();
		String stuClassName = stuProfessionalArchitecture.getClassName();
		if (stuClassName==null||stuClassName=="") {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}
		else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.updateStuClass(stuProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	添加年级
	 */
	@Log("添加年级")
	@PostMapping("/addStuGrade")
	Response addStuGrade(@RequestBody StuProfessionalArchitecture stuProfessionalArchitecture) {
		Response resp = new Response();
		String stuGradeName = stuProfessionalArchitecture.getGradeName();
		Integer stuProfessionalArchitectureId = stuProfessionalArchitecture.getStuProfessionalArchitectureId();
		if (stuGradeName==null||stuGradeName==""||stuProfessionalArchitectureId ==null) {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.addStuGrade(stuProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	修改年级
	 */
	@Log("修改年级")
	@PostMapping("/updateStuGrade")
	Response updateStuGrade(@RequestBody StuProfessionalArchitecture stuProfessionalArchitecture) {
		Response resp = new Response();
		String stuGradeName = stuProfessionalArchitecture.getGradeName();
			if (stuGradeName==null||stuGradeName=="") {
			resp.setStatus(300);
			resp.setErrmessage("Parameter Invalid");
		}
		else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.updateStuGrade(stuProfessionalArchitecture);
			int status = (int) ret.get("retcode");
			if (200 == status) {
				resp.setStatus(status);
				resp.setMessage(ret.get("retvalue"));
			} else {
				resp.setStatus(status);
				resp.setErrmessage(ret.get("retvalue").toString());
			}
		}
		return resp;
	}
	
	/**
	 * 	查询学生
	 */
	@GetMapping("/queryStudent")
	Response queryStudent(@RequestParam Integer classId) {
		Response resp = new Response();
		if (classId == null) {
			resp.setStatus(300);
			resp.setMessage("classId is null!");
		}else {
			HashMap<String, Object> ret = stuProfessionalArchitectureService.queryStudent(classId);
		int status = (int) ret.get("retcode");
		if (200 == status) {
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		} else {
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
	}
	return resp;
	}
	
}
