package com.yipin.liuwanr.controller;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.yipin.liuwanr.entity.Comment;
import com.yipin.liuwanr.entity.Response;
import com.yipin.liuwanr.entity.Topic;
import com.yipin.liuwanr.service.TopicService;

@RestController
@RequestMapping("/topic")
public class TopicController {
	
	@Autowired
	private TopicService topicService;

	@PostMapping("/create")
    Response createTopic(@RequestBody Topic topic) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.create(topic);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
	
	@DeleteMapping("/delete")
    Response deleteTopic(@RequestHeader("X-UUID") String uuid, @RequestParam("tuid") String tuid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.delete(uuid, tuid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
	
	@GetMapping("/detail")
    Response showTopic(@RequestHeader("X-UUID") String uuid, @RequestParam("tuid") String tuid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.detail(uuid, tuid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
	
	@GetMapping("/around")
    Response aroundTopic(@RequestHeader("X-UUID") String uuid, @RequestParam("longitude") double longitude, @RequestParam("latitude") double latitude) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.around(uuid, latitude, longitude);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
	
	@GetMapping("/list")
    Response listTopic(@RequestHeader("X-UUID") String uuid, @RequestParam("uuid") String buuid, @RequestParam(value = "type", required = false, defaultValue = "0") int type) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.list(uuid, buuid, type);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
	
	@GetMapping("/tag")
    Response topicTag(@RequestHeader("X-UUID") String uuid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.tags(uuid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
	
	@PostMapping("/comment")
    Response deleteTopic(@RequestBody Comment comment) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.comment(comment);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
	
	@DeleteMapping("/comment")
    Response deleteComment(@RequestHeader("X-UUID") String uuid, @RequestParam("cuid") String cuid) {
    	Response resp = new Response();
		HashMap<String, Object> ret = topicService.deleteComment(uuid, cuid);
		int status = (int) ret.get("retcode");
		if(200 == status){
			resp.setStatus(status);
			resp.setMessage(ret.get("retvalue"));
		}
		else{
			resp.setStatus(status);
			resp.setErrmessage(ret.get("retvalue").toString());
		}
		return resp;
    }
}
