package com.yipin.liuwanr.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 各个平台账号表
 * </p>
 *
 * @author Qyq
 * @since 2021-06-18
 */
@Data
@TableName("hr_user_account")
public class HrUserAccount implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "id", type = IdType.ID_WORKER)
    private Integer id;

    /**
     * 用户表id
     */
    private Integer userId;

    /**
     * 账号
     */
    private String account;

    /**
     * 密码
     */
    private String password;

    /**
     * 工号
     */
    private String workNumber;

    /**
     * 绑定的角色id
     */
    private String roleId;

    /**
     * 绑定院校id
     */
    private Integer schoolId;

    /**
     * 所属平台：1->职站 2->数据平台
     */
    private Integer platformId;

    /**
     * 平台端区分：0->教师端 1->学生端
     */
    private Integer type;

    /**
     * 是否删除(0、未删除 1、已删除)
     */
    private Integer isdel;

    /**
     * 邮箱
     */
    private String email;

    /**
     * 手机号
     */
    private String phone;

    /**
     * 微信号
     */
    private String wechatId;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 修改时间
     */
    private Date updateTime;

}
