package com.yipin.liuwanr.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 用户信息表
 * </p>
 *
 * @author Qyq
 * @since 2021-06-23
 */
@Data
@TableName("hr_user_info")
public class HrUserInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 用户id
     */
    @TableId(value = "userId", type = IdType.AUTO)
    private Integer userId;

    /**
     * 用户姓名
     */
    @TableField("userName")
    private String userName;

    /**
     * 唯一标识账号
     */
    @TableField("uniqueIdentificationAccount")
    private String uniqueIdentificationAccount;

    /**
     * 证件类型（1、身份证）
     */
    @TableField("documentType")
    private Integer documentType;

    /**
     * 证件号码
     */
    @TableField("IDNumber")
    private String IDNumber;

    /**
     * 绑定省份id
     */
    @TableField("provinceId")
    private Integer provinceId;

    /**
     * 绑定城市id
     */
    @TableField("cityId")
    private Integer cityId;

    /**
     * 国家归属地
     */
    private String countries;

    /**
     * 出生日期
     */
    @TableField("dateBirth")
    private String dateBirth;

    /**
     * 教育程度
     */
    @TableField("educationDegree")
    private Integer educationDegree;

    /**
     * 绑定学校id
     */
    @TableField("schoolId")
    private Integer schoolId;

    /**
     * 电话
     */
    private String phone;

    /**
     * 微信号
     */
    @TableField("weChatID")
    private String weChatID;

    /**
     * 邮箱
     */
    private String email;

    /**
     * 账号(中台管理的所有平台的账号均不显示在这里)
     */
    private String account;

    /**
     * 密码
     */
    private String password;

    /**
     * 创建时间
     */
    @TableField("creationTime")
    private String creationTime;

    /**
     * 登陆次数
     */
    @TableField("logInNumber")
    private Integer logInNumber;

    /**
     * 性别（1、男 2、女）
     */
    private Integer sex;

    /**
     * 用户头像路径
     */
    @TableField("userAvatars")
    private String userAvatars;

    /**
     * 是否删除(0、未删除 1、已删除)
     */
    private Integer isdel;

    /**
     * 最后登陆时间
     */
    @TableField("lastLoginTime")
    private String lastLoginTime;

    /**
     * 绑定多个角色id
     */
    @TableField("roleId")
    private String roleId;

    /**
     * 禁用状态（0未禁用1已禁用默认0）
     */
    @TableField("disableAccount")
    private Integer disableAccount;

    /**
     * 所属院校id(绑定学校id)
     */
    @TableField("schoolAppellationId")
    private String schoolAppellationId;

    /**
     * token
     */
    private String token;

    /**
     * 最后更新时间
     */
    @TableField("updateTime")
    private Date updateTime;
}
