package com.yipin.liuwanr.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 菜单权限表
 * </p>
 *
 * @author Qyq
 * @since 2021-02-26
 */
@Data
@TableName("sys_permission")
public class SysPermission implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 权限标识符
     */
    private String code;

    /**
     * 名称
     */
    private String name;

    /**
     * 父权限id
     */
    private Long parentId;

    /**
     * 层级
     */
    private Integer level;

    /**
     * 是否是菜单：1、是，0、不是（0目前为按钮）
     */
    private Integer menuOrNot;

    /**
     * 状态：0、启用，1、禁用
     */
    private Integer status;

    /**
     * 路径
     */
    private String url;

    /**
     * 页面路径
     */
    private String menuUrl;

    /**
     * 排序
     */
    private Integer sort;

    /**
     * 图标
     */
    private String icon;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date motifyTime;
    /**
     * 子权限
     */
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    @TableField(exist = false)
    private List<SysPermission> children;
}
