package com.yipin.liuwanr.entity.response;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.ToString;

/**
 * @Author: gongsj.
 * @Description: 系统操作状态集
 * @Date:Created in 2020/09/07 11:35.
 * @Modified By:
 */
@ToString
@AllArgsConstructor
public enum CommonCode implements ResultCode {

    SUCCESS(true, 10000, "操作成功！"),
    FAIL(false, 11111, "操作失败！"),
    INEXISTENCE(false,10004,"抱歉,当前客户信息已不存在!"),
    START_FAIL(false,10009,"启用或禁用失败,当前用户状态异常!"),
    RESET_FAIL(false,10010,"重置密码失败,当前用户状态异常!"),
    PERMISSION_IS_NOT(false,10011,"当前角色的权限信息不存在!"),
    DISABLE_FAIL(false,10012,"禁用失败,禁用结束时间可能早于当前时间"),
    UPDATE_FAIL(false,10005,"更新信息失败!"),
    SAVE_FAIL(false,10006,"新增信息失败!"),
    DELETE_FAIL(false,10007,"删除失败!"),
    UNAUTHENTICATED(false, 10001, "此操作需要登陆系统！"),
    UNAUTHORISE(false, 10002, "权限不足，无权操作！"),
    INVALID_PARAM(false, 10003, "非法参数！"),
    USER_IS_NOT_EXIST(false, 10004, "用户不存在或用户已禁用！"),
    USER_LOGIN_NULL(false,10013,"获取当前用户登录信息失败!"),
    POSITION_DEPT_NOT_NULL(false,10014,"职位名称或所属部门不能为空!"),
    PASSWORD_IS_ERROR(false, 10005, "密码错误！"),
    IMPORT_ERROR(false,10008,"导入数据失败!"),
    SERVER_ERROR(false, 99999, "抱歉，系统繁忙，请稍后重试！"),
    GET_LOGIN_USER_FAIL(false,10015,"获取当前登录用户失败,请稍后重试!");

    /**
     * 操作是否成功
     */
    @Getter
    private boolean success;

    /**
     * 状态码
     */
    @Getter
    private int code;

    /**
     * 提示信息
     */
    @Getter
    private String message;

    @Override
    public boolean success() {
        return this.success;
    }

    @Override
    public int code() {
        return this.code;
    }

    @Override
    public String message() {
        return this.message;
    }
}
