package com.yipin.liuwanr.entity.response;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;

/**
 * @Author: gongsj.
 * @Description: 统一返回的结果集。
 * @Date:Created in 2020/09/07 12:28.
 * @Modified By:
 */
@Data
@ToString
@NoArgsConstructor
@AllArgsConstructor
public class ResponseResult<T> {
    /**
     * 操作是否成功
     */
    private boolean success;

    /**
     * 状态码
     */
    private int code;

    /**
     * 返回的数据
     */
    private T data;

    /**
     * 提示信息
     */
    private String message;

    public ResponseResult(boolean success, int code, String message) {
        this.success = success;
        this.code = code;
        this.message = message;
    }

    public ResponseResult(ResultCode resultCode) {
        this.success = resultCode.success();
        this.code = resultCode.code();
        this.message = resultCode.message();
    }

    public static ResponseResult SUCCESS() {
        return new ResponseResult(CommonCode.SUCCESS);
    }

    public static ResponseResult SUCCESS(Object t) {
        return new ResponseResult<>(true, 10000, t, "操作成功!");
    }

    public static ResponseResult FAIL(Object t) {
        return new ResponseResult<>(false, 99999, t, "操作失败,请检查客户名称是否已存在或者文件和数据格式是否正确!");
    }

    public ResponseResult SUCCESS_DATA(T t) {
        return new ResponseResult<>(false, 20000, t, "操作失败!");
    }

    public static ResponseResult FAIL() {
        return new ResponseResult(CommonCode.FAIL);
    }

    public static ResponseResult FAIL(int code, String message) {
        return new ResponseResult<>(false, code, null, message);
    }

}
