package com.yipin.liuwanr.entity.response;

/**
 * @Author: gongsj.
 * @Description: 系统操作状态集接口
 * @Date:Created in 2020/09/09 15:35.
 * @Modified By:
 * 10000-- 通用错误码
 * 22000-- 人资管理系统错误码
 * 23000-- 人资管理系统认证系统错误码
 * 24000-- 客户管理系统错误码
 * 25000-- 客户管理系统认证系统错误码
 * 26000-- 工作流程管理系统错误码
 * 27000-- 担保业务系统错误码
 */
public interface ResultCode {
    /**
     * 操作是否成功
     *
     * @return true为成功，false操作失败
     */
    boolean success();

    /**
     * 操作码
     *
     * @return 操作码
     */
    int code();

    /**
     * 提示信息
     *
     * @return 提示信息
     */
    String message();
}
