package com.yipin.liuwanr.filter;


import org.jasig.cas.client.validation.AssertionImpl;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.util.StringUtils;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.Field;
import java.util.Map;
import java.util.Objects;

/**
 * @description
 * @author: Mr.JK
 * @create: 2021-06-03 16:19
 **/
public class AuthInterceptor implements HandlerInterceptor {


    @Resource
    StringRedisTemplate stringRedisTemplate;

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        response.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=utf-8");

        Object attribute = request.getSession().getAttribute("_const_cas_assertion_");
        if (!StringUtils.isEmpty(attribute)){
            AssertionImpl assertion = (AssertionImpl) attribute;
//            Field[] fields = assertion.getClass().getDeclaredFields();
            /*for (Field field : fields) {
                System.out.println(field);
            }*/
            //获取用户信息中的公开属性
            Map<String,Object> map = assertion.getPrincipal().getAttributes();
            //获取用户信息中公开的Attributes部分
            Object userName = map.get("user_name");//获取登录用户姓名，默认可获取
            Object uid = map.get("uid");//获取登录用户id，需接入应用配置方可获取
            System.out.println(userName +"-"+uid);
        }

        String token = request.getHeader("token");

        if (StringUtils.isEmpty(token)) {
            response.getWriter().print("0");//用户未登录，请登录后操作！
            return false;
        }
        ValueOperations<String, String> ops = stringRedisTemplate.opsForValue();
        Object loginStatus = ops.get(token);
        if( Objects.isNull(loginStatus)){
            response.getWriter().print("1");//token错误
            return false;
        }else {
            if (request.getRequestURI().contains("logins")){
                String userId = request.getParameter("userId");
                return userId.equals(loginStatus);
            }else {
                return true;
            }
        }
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {

    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

    }

}
