package com.yipin.liuwanr.filter;

import com.yipin.liuwanr.util.CASUtil;
import lombok.extern.slf4j.Slf4j;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.Map;

/**
 * 本地用户信息过滤器
 *
 * @author weiller 2018年1月23日10:27:30
 */
@Slf4j
public class LocalUserInfoFilter implements Filter {

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
        HttpServletRequest httpServletRequest = (HttpServletRequest)request;
        Map<String,Object> loginName = CASUtil.getAccountNameFromCas(httpServletRequest);
        assert loginName != null;
        if(!loginName.isEmpty()){
            log.info("访问者 ：" +loginName.get("user_name"));
            log.info("访问者 ：" +loginName.get("uid"));
            httpServletRequest.getSession().setAttribute("loginName", loginName.get("user_name"));
            //登录成功之后加入数据库

        }
        chain.doFilter(request, response);

    }

    @Override
    public void destroy() {

    }
}

