package com.yipin.liuwanr.helper;


import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.yipin.liuwanr.entity.Assesment;

public class AssesmentHelper {
	
	/**
	 * 考核耗时计算
	 * @param time
	 * @return
	 */
	public static String getGapTime(long time) {
		long hours = time / (1000 * 60 * 60);
		long minutes = (time - hours * (1000 * 60 * 60)) / (1000 * 60);
		StringBuffer buffer = new StringBuffer();
		buffer.append(hours).append("h").append(minutes).append("m");
//		if(minutes!=0) {
//			buffer.append(minutes).append("m");
//		}
		return buffer.toString();
	}

	/**
	 * 毫秒数转Date
	 * 
	 * @param lo
	 * @return
	 */
	public static String longPointDate(long lo) {
		Date date = new Date(lo);
		SimpleDateFormat sd = new SimpleDateFormat("yyyy-MM-dd HH:mm");
		return sd.format(date);
	}

	
	public static long stringToLong(String time) {
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm");
		try {
			return format.parse(time).getTime();
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return 0;

	}

	public static Assesment helpAssesment(Assesment assesment) {
		String createTime = assesment.getCreationTime();
		String endTime = assesment.getEndTime();
		String timesum = assesment.getTimesum();
		if (assesment.getReleaseType() == 0) {
			// 手动发布,设置考核时长,考核状态
			long time = Long.parseLong(timesum);
			assesment.setTimesum(getGapTime(time));
			assesment.setAssesmentState(0);

		} else if (assesment.getReleaseType() == 1) {
			// 定时发布,设置考核状态,开始时间,结束时间,考核时长
			long starttime = Long.parseLong(createTime);
			long endtime = Long.parseLong(endTime);
			long now = new Date().getTime();
			if (starttime < now) {
				assesment.setAssesmentState(1);
			} else if (starttime >= now) {
				assesment.setAssesmentState(0);
			}
			assesment.setTimesum(getGapTime(endtime - starttime));
			assesment.setCreationTime(longPointDate(starttime));
			assesment.setEndTime(longPointDate(endtime));
		}
		return assesment;
	}
	
	
}
