package com.yipin.liuwanr.helper;

import java.util.List;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.VerticalAlignment;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFFont;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.yipin.liuwanr.entity.Attendance;
import com.yipin.liuwanr.entity.Record;

/**
*
* 
* @author 全承珠
*
*/
public class ExcelExportHelper {
	
	public  XSSFWorkbook  excelExport(String  sheetName,String[] titles) {
		//创建工作簿
		XSSFWorkbook workbook=new XSSFWorkbook();
		//在工作簿创建sheet
		XSSFSheet sheet=workbook.createSheet(sheetName);
		//创行
		XSSFRow row=sheet.createRow(0);
		//样式
		XSSFCellStyle cellStyle=workbook.createCellStyle();
		//居中
		cellStyle.setAlignment(HorizontalAlignment.CENTER);
		cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);
		//设置字体
		XSSFFont font=workbook.createFont();
		font.setBold(true);
		font.setFontHeightInPoints((short)10);
		cellStyle.setFont(font);
		for (int i = 0; i < titles.length; i++) {
			String title = titles[i];
			Cell cell1 = row.createCell(i);
			cell1.setCellValue(title);
			cell1.setCellStyle(cellStyle);
		}

		return workbook;
	}
	
	
	
	// 考勤记录Excel
	public static HSSFWorkbook exportAttendance(List<Attendance> attendances, String sheetName,String[] titles) {
		// 一组装excel文档
		// 1,创建工作簿
		HSSFWorkbook workbook = new HSSFWorkbook();
		// 2,创建样式
		HSSFCellStyle baseStyle = ExprotHSSFCellStyle.createBaseStyle(workbook);
		HSSFCellStyle subTitleStyle = ExprotHSSFCellStyle.createSubTitleStyle(workbook);
		// 3在工作簿创建sheet
		HSSFSheet sheet = workbook.createSheet(sheetName);
		sheet.setDefaultColumnWidth(20);
		int index = 0;
		HSSFRow row1 = sheet.createRow(index);
		for (int i = 0; i < titles.length; i++) {
			HSSFCell row1_cell = row1.createCell(i);
			row1_cell.setCellStyle(subTitleStyle);
			row1_cell.setCellValue(titles[i]);
		}
		// 第二行
		for (int i = 0; i < attendances.size(); i++) {
			index++;
			Attendance attendance = attendances.get(i);
			HSSFRow row = sheet.createRow(index);
			// 2.1次序
			HSSFCell row_identity = row.createCell(0);
			row_identity.setCellStyle(baseStyle);
			row_identity.setCellValue(i + 1);
			// 2.2创建项目名称
			HSSFCell row_custname = row.createCell(1);
			row_custname.setCellStyle(baseStyle);
			row_custname.setCellValue(attendance.getExperimentName());
			// 2.3创建实验项目
			HSSFCell row_phone = row.createCell(2);
			row_phone.setCellStyle(baseStyle);
			row_phone.setCellValue(attendance.getExperimentName());
			// 2.4创建考勤记录
			HSSFCell row_address = row.createCell(3);
			row_address.setCellStyle(baseStyle);
			row_address.setCellValue(attendance.getSignIn() == 0 ? "签到成功" : "缺勤");
			// 2.5创建签到时间
			HSSFCell row_career = row.createCell(4);
			row_career.setCellStyle(baseStyle);
			row_career.setCellValue(attendance.getCreationTime());
		}

		return workbook;
	}
	 /**
     * 练习记录 and 考核记录
     * @param list
     * @param sheetName
     * @param titles
     * @return
     */
	public static HSSFWorkbook exportPractice(List<Record> list,String sheetName,String[] titles) {
		// 一组装excel文档
		// 1,创建工作簿
		HSSFWorkbook workbook = new HSSFWorkbook();
		// 2,创建样式
		HSSFCellStyle baseStyle = ExprotHSSFCellStyle.createBaseStyle(workbook);
		HSSFCellStyle subTitleStyle = ExprotHSSFCellStyle.createSubTitleStyle(workbook);
		// 3在工作簿创建sheet
		HSSFSheet sheet = workbook.createSheet(sheetName);
		sheet.setDefaultColumnWidth(20);
		int index=0;
		HSSFRow row1 = sheet.createRow(index);
		for (int i = 0; i < titles.length; i++) {
			HSSFCell row3_cell = row1.createCell(i);
			row3_cell.setCellStyle(subTitleStyle);
			row3_cell.setCellValue(titles[i]);
		}
		//第二行
		for (int i = 0; i < list.size(); i++) {
			index++;
			Record vo=list.get(i);
			HSSFRow row = sheet.createRow(index);
			//2.1次序
			HSSFCell row_identity = row.createCell(0);
			row_identity.setCellStyle(baseStyle);
			row_identity.setCellValue(i+1);
			//2.2创建练习名称
			HSSFCell row_custname = row.createCell(1);
			row_custname.setCellStyle(baseStyle);
			row_custname.setCellValue(vo.getProjectName());
			//2.3创建实验项目
			HSSFCell row_phone = row.createCell(2);
			row_phone.setCellStyle(baseStyle);
			row_phone.setCellValue(vo.getProjectName());
			//2.4创建得分
			HSSFCell row_address= row.createCell(3);
			row_address.setCellStyle(baseStyle);
			row_address.setCellValue(vo.getScore()==null?0:vo.getScore());
			//2.5创建耗时
			HSSFCell row_career = row.createCell(4);
			row_career.setCellStyle(baseStyle);
			row_career.setCellValue(vo.getTimeSum()==null?null:vo.getTimeSum());
			//2.6创建开始时间
			HSSFCell row_sex = row.createCell(5);
			row_sex.setCellStyle(baseStyle);
			row_sex.setCellValue(vo.getCreateTime());
			//2.7创建结束时间
			HSSFCell row_createtime = row.createCell(6);
			row_createtime.setCellStyle(baseStyle);
			row_createtime.setCellValue(vo.getEndTime()==null?null:vo.getEndTime());
		}

		return workbook;
		
	}
}
