package com.yipin.liuwanr.helper;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.jboss.logging.Logger;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

import io.netty.util.internal.StringUtil;

public class PushHelper {
	
	private static Logger logger = Logger.getLogger(PushHelper.class);
    //各种请求路径URL
    private static final String USER_CREATE_URL="https://api.netease.im/nimserver/user/create.action";
    private static final String USER_REFRESH_URL="https://api.netease.im/nimserver/user/update.action";
    private static final String USER_DETAIL_URL="https://api.netease.im/nimserver/user/getUinfos.action";
    private static final String USER_UPDATE_URL="https://api.netease.im/nimserver/user/updateUinfo.action";
    private static final String SEND_MESSAGE_URL="https://api.netease.im/nimserver/msg/sendMsg.action";
    private static final String SEND_NOTICE_URL="https://api.netease.im/nimserver/msg/sendAttachMsg.action";
    //网易云信分配的账号，请替换你在管理后台应用下申请的Appkey
    private static final String APP_KEY="c5b67474245381d7995449394a468e45";
    //网易云信分配的密钥，请替换你在管理后台应用下申请的appSecret
    private static final String APP_SECRET="0915b37c5aa7";
    //系统通知用户id
    private static final String APP_SYSTEM_ID = "16a00afdb0e94ab5a2f04b3b4ad20d0b";

    public static boolean registerIMAccount(String uuid) {

        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        HttpPost httpPost = new HttpPost(USER_CREATE_URL);
        String curTime = String.valueOf((new Date()).getTime() / 1000L);
        /*
         * 参考计算CheckSum的java代码，在上述文档的参数列表中，有CheckSum的计算文档示例
         */
        String nonce = RandomUtil.getNonce(uuid);
        String checkSum = RandomUtil.getCheckSum(APP_SECRET, nonce, curTime);
        
        if(null == checkSum){
        	return false;
        }
        

        // 设置请求的header
        httpPost.addHeader("AppKey", APP_KEY);
        httpPost.addHeader("Nonce", nonce);
        httpPost.addHeader("CurTime", curTime);
        httpPost.addHeader("CheckSum", checkSum);
        httpPost.addHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");

        // 设置请求的的参数，requestBody参数
        List<NameValuePair> nvps = new ArrayList<NameValuePair>();

        nvps.add(new BasicNameValuePair("accid", uuid));

        try {
			httpPost.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
			// 执行请求
	        HttpResponse response = httpClient.execute(httpPost);
	        /*
	         * 1.打印执行结果，打印结果一般会200、315、403、404、413、414、500
	         * 2.具体的code有问题的可以参考官网的Code状态表
	         */
	        String retmessage = EntityUtils.toString(response.getEntity(), "utf-8");
	        JSONObject obj = (JSONObject) JSON.parse(retmessage);
	        if(200 != obj.getIntValue("code")){
	        	logger.error(retmessage);
	        	return false;
	        }
		} catch (UnsupportedEncodingException e) {
			logger.error(e.getLocalizedMessage());
		} catch (ClientProtocolException e) {
			logger.error(e.getLocalizedMessage());
		} catch (IOException e) {
			logger.error(e.getLocalizedMessage());
		}

        
        return true;
    }
    

    public static boolean refreshIMToken(String uuid, String token) {

        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        HttpPost httpPost = new HttpPost(USER_REFRESH_URL);
        String curTime = String.valueOf((new Date()).getTime() / 1000L);
        /*
         * 参考计算CheckSum的java代码，在上述文档的参数列表中，有CheckSum的计算文档示例
         */
        String nonce = RandomUtil.getNonce(uuid);
        String checkSum = RandomUtil.getCheckSum(APP_SECRET, nonce, curTime);
        
        if(null == checkSum){
        	return false;
        }
        

        // 设置请求的header
        httpPost.addHeader("AppKey", APP_KEY);
        httpPost.addHeader("Nonce", nonce);
        httpPost.addHeader("CurTime", curTime);
        httpPost.addHeader("CheckSum", checkSum);
        httpPost.addHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");

        // 设置请求的的参数，requestBody参数
        List<NameValuePair> nvps = new ArrayList<NameValuePair>();

        nvps.add(new BasicNameValuePair("accid", uuid));
        nvps.add(new BasicNameValuePair("token", token));

        try {
			httpPost.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
			// 执行请求
	        HttpResponse response = httpClient.execute(httpPost);
	        /*
	         * 1.打印执行结果，打印结果一般会200、315、403、404、413、414、500
	         * 2.具体的code有问题的可以参考官网的Code状态表
	         */
	        String retmessage = EntityUtils.toString(response.getEntity(), "utf-8");
	        JSONObject obj = (JSONObject) JSON.parse(retmessage);
	        if(200 != obj.getIntValue("code")){
	        	logger.error(retmessage);
	        	return false;
	        }
		} catch (UnsupportedEncodingException e) {
			logger.error(e.getLocalizedMessage());
		} catch (ClientProtocolException e) {
			logger.error(e.getLocalizedMessage());
		} catch (IOException e) {
			logger.error(e.getLocalizedMessage());
		}
        return true;
    }
    
    public static String watchIMUser(String uuid) {

        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        HttpPost httpPost = new HttpPost(USER_DETAIL_URL);
        String curTime = String.valueOf((new Date()).getTime() / 1000L);
        /*
         * 参考计算CheckSum的java代码，在上述文档的参数列表中，有CheckSum的计算文档示例
         */
        String nonce = RandomUtil.getNonce(uuid);
        String checkSum = RandomUtil.getCheckSum(APP_SECRET, nonce, curTime);
        
        if(null == checkSum){
        	return null;
        }
        

        // 设置请求的header
        httpPost.addHeader("AppKey", APP_KEY);
        httpPost.addHeader("Nonce", nonce);
        httpPost.addHeader("CurTime", curTime);
        httpPost.addHeader("CheckSum", checkSum);
        httpPost.addHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");

        // 设置请求的的参数，requestBody参数
        List<NameValuePair> nvps = new ArrayList<NameValuePair>();

        nvps.add(new BasicNameValuePair("accids", uuid));

        try {
			httpPost.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
			// 执行请求
	        HttpResponse response = httpClient.execute(httpPost);
	        /*
	         * 1.打印执行结果，打印结果一般会200、315、403、404、413、414、500
	         * 2.具体的code有问题的可以参考官网的Code状态表
	         */
	        return EntityUtils.toString(response.getEntity(), "utf-8");
		} catch (UnsupportedEncodingException e) {
			logger.error(e.getLocalizedMessage());
		} catch (ClientProtocolException e) {
			logger.error(e.getLocalizedMessage());
		} catch (IOException e) {
			logger.error(e.getLocalizedMessage());
		}
        return null;
    }
    
    public static boolean updateIMUser(String uuid, String name, String icon) {

        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        HttpPost httpPost = new HttpPost(USER_UPDATE_URL);
        String curTime = String.valueOf((new Date()).getTime() / 1000L);
        /*
         * 参考计算CheckSum的java代码，在上述文档的参数列表中，有CheckSum的计算文档示例
         */
        String nonce = RandomUtil.getNonce(uuid);
        String checkSum = RandomUtil.getCheckSum(APP_SECRET, nonce, curTime);
        
        if(null == checkSum){
        	return false;
        }
        

        // 设置请求的header
        httpPost.addHeader("AppKey", APP_KEY);
        httpPost.addHeader("Nonce", nonce);
        httpPost.addHeader("CurTime", curTime);
        httpPost.addHeader("CheckSum", checkSum);
        httpPost.addHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");

        // 设置请求的的参数，requestBody参数
        List<NameValuePair> nvps = new ArrayList<NameValuePair>();

        nvps.add(new BasicNameValuePair("accid", uuid));
        if(!StringUtil.isNullOrEmpty(name)){
        	nvps.add(new BasicNameValuePair("name", name));
        }
        if(!StringUtil.isNullOrEmpty(icon)){
        	nvps.add(new BasicNameValuePair("icon", icon));
        }
        

        try {
			httpPost.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
			// 执行请求
	        HttpResponse response = httpClient.execute(httpPost);
	        /*
	         * 1.打印执行结果，打印结果一般会200、315、403、404、413、414、500
	         * 2.具体的code有问题的可以参考官网的Code状态表
	         */
	        String retmessage = EntityUtils.toString(response.getEntity(), "utf-8");
	        JSONObject obj = (JSONObject) JSON.parse(retmessage);
	        if(200 != obj.getIntValue("code")){
	        	logger.error(retmessage);
	        	return false;
	        }
		} catch (UnsupportedEncodingException e) {
			logger.error(e.getLocalizedMessage());
		} catch (ClientProtocolException e) {
			logger.error(e.getLocalizedMessage());
		} catch (IOException e) {
			logger.error(e.getLocalizedMessage());
		}
        return true;
    }
    
    public static boolean sendNotification(String to, int msgtype, String attach) {

        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        HttpPost httpPost = new HttpPost(SEND_NOTICE_URL);
        String curTime = String.valueOf((new Date()).getTime() / 1000L);
        /*
         * 参考计算CheckSum的java代码，在上述文档的参数列表中，有CheckSum的计算文档示例
         */
        String nonce = RandomUtil.getNonce(to);
        String checkSum = RandomUtil.getCheckSum(APP_SECRET, nonce, curTime);
        
        if(null == checkSum){
        	return false;
        }
        

        // 设置请求的header
        httpPost.addHeader("AppKey", APP_KEY);
        httpPost.addHeader("Nonce", nonce);
        httpPost.addHeader("CurTime", curTime);
        httpPost.addHeader("CheckSum", checkSum);
        httpPost.addHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");

        // 设置请求的的参数，requestBody参数
        List<NameValuePair> nvps = new ArrayList<NameValuePair>();

        nvps.add(new BasicNameValuePair("from", APP_SYSTEM_ID));
        nvps.add(new BasicNameValuePair("msgtype", "" + msgtype));
        nvps.add(new BasicNameValuePair("to", to));
        nvps.add(new BasicNameValuePair("attach", attach));

        try {
			httpPost.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
			// 执行请求
	        HttpResponse response = httpClient.execute(httpPost);
	        /*
	         * 1.打印执行结果，打印结果一般会200、315、403、404、413、414、500
	         * 2.具体的code有问题的可以参考官网的Code状态表
	         */
	        String retmessage = EntityUtils.toString(response.getEntity(), "utf-8");
	        JSONObject obj = (JSONObject) JSON.parse(retmessage);
	        if(200 != obj.getIntValue("code")){
	        	logger.error(retmessage);
	        	return false;
	        }
		} catch (UnsupportedEncodingException e) {
			logger.error(e.getLocalizedMessage());
		} catch (ClientProtocolException e) {
			logger.error(e.getLocalizedMessage());
		} catch (IOException e) {
			logger.error(e.getLocalizedMessage());
		}
        return true;
    }
    
    public static boolean sendMessage(String to, int msgtype, String attach) {

        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        HttpPost httpPost = new HttpPost(SEND_MESSAGE_URL);
        String curTime = String.valueOf((new Date()).getTime() / 1000L);
        /*
         * 参考计算CheckSum的java代码，在上述文档的参数列表中，有CheckSum的计算文档示例
         */
        String nonce = RandomUtil.getNonce(to);
        String checkSum = RandomUtil.getCheckSum(APP_SECRET, nonce, curTime);
        
        if(null == checkSum){
        	return false;
        }
        

        // 设置请求的header
        httpPost.addHeader("AppKey", APP_KEY);
        httpPost.addHeader("Nonce", nonce);
        httpPost.addHeader("CurTime", curTime);
        httpPost.addHeader("CheckSum", checkSum);
        httpPost.addHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");

        // 设置请求的的参数，requestBody参数
        List<NameValuePair> nvps = new ArrayList<NameValuePair>();

        nvps.add(new BasicNameValuePair("from", APP_SYSTEM_ID));
        nvps.add(new BasicNameValuePair("ope", "0"));
        nvps.add(new BasicNameValuePair("to", to));
        nvps.add(new BasicNameValuePair("type", "100"));
        nvps.add(new BasicNameValuePair("body", attach));

        try {
			httpPost.setEntity(new UrlEncodedFormEntity(nvps, "utf-8"));
			// 执行请求
	        HttpResponse response = httpClient.execute(httpPost);
	        /*
	         * 1.打印执行结果，打印结果一般会200、315、403、404、413、414、500
	         * 2.具体的code有问题的可以参考官网的Code状态表
	         */
	        String retmessage = EntityUtils.toString(response.getEntity(), "utf-8");
	        JSONObject obj = (JSONObject) JSON.parse(retmessage);
	        if(200 != obj.getIntValue("code")){
	        	logger.error(retmessage);
	        	return false;
	        }
		} catch (UnsupportedEncodingException e) {
			logger.error(e.getLocalizedMessage());
		} catch (ClientProtocolException e) {
			logger.error(e.getLocalizedMessage());
		} catch (IOException e) {
			logger.error(e.getLocalizedMessage());
		}
        return true;
    }
}