package com.yipin.liuwanr.helper;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Repository;

import com.alibaba.fastjson.JSONArray;
import com.yipin.liuwanr.entity.ImagePart;
import com.yipin.liuwanr.entity.UploadInfo;

@Repository
public class RedisHelper {
	
	@Resource
	RedisTemplate<String, Object> redisTemplate;
	
	public void set(String key, Object value){
		redisTemplate.opsForValue().set(key, value);
	}
	
	public Object get(String key){
		return redisTemplate.opsForValue().get(key);
	}
	
	public boolean confirm(String key){
		return redisTemplate.hasKey(key);
	}
	
	public boolean remove(String key){
		return redisTemplate.delete(key);
	}

	public void setTokenById(String uuid, String token, int expire){
		if(null == redisTemplate){
			return;
		}
		redisTemplate.opsForValue().set(uuid + "_token", token, expire);
	}
	
	public String getTokenById(String uuid){
		if(null == redisTemplate){
			return null;
		}
		if(!redisTemplate.hasKey(uuid + "_token")){
			return "none";
		}
		return redisTemplate.opsForValue().get(uuid + "_token").toString();
	}
	
	public void setRefreshTokenById(String uuid, String refresh, int expire){
		if(null == redisTemplate){
			return;
		}
		redisTemplate.opsForValue().set(uuid + "_fresh_token", refresh, expire);
	}
	
	public String getRefreshTokenById(String uuid){
		if(null == redisTemplate){
			return null;
		}
		if(!redisTemplate.hasKey(uuid + "_token")){
			return "none";
		}
		return redisTemplate.opsForValue().get(uuid + "_fresh_token").toString();
	}
	
	public void setDeviceStatueById(String duid, String token){
		redisTemplate.opsForValue().set(duid + "_status", token);
	}
	
	public String getDeviceStatueById(String duid){
		return redisTemplate.opsForValue().get(duid + "_status").toString();
	}
	
	public void setLastUploadInfoById(String duid, UploadInfo info){
		redisTemplate.opsForValue().set(duid + "_info", info);
	}
	
	public UploadInfo getLastUploadInfoById(String duid){
		Object obj = redisTemplate.opsForValue().get(duid + "_info");
		return obj==null?null:(UploadInfo)obj;
	}
	
	public List<ImagePart> getImageByName(String name){
		Object obj = redisTemplate.opsForValue().get(name);
		return obj==null?null:((JSONArray)obj).toJavaList(ImagePart.class);
	}
	
	public void setImageByName(String name, List<ImagePart> image){
		redisTemplate.opsForValue().set(name, image);
	}
}
