package com.yipin.liuwanr.mapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.yipin.liuwanr.vo.AssesmentRecordVo;

/**
 * 考核记录
 * @author 或然
 *
 */
@Mapper
public interface AssesmentRecordMapper {

	/**
	 * 学生姓名、最高考核得分、考核平均分
	 * @param studentId
	 * @return
	 */
	@Select("SELECT stu.studentName as studentName,MAX(re.score) as heightscore,AVG(re.score) as avgscore FROM record re,student stu,hr_project_management pm " + 
			"WHERE re.studentId=stu.studentId AND re.projectId=pm.projectId AND pm.projectPermissions=1 AND re.studentId=#{studentId} AND re.courseId=#{courseId}")
    AssesmentRecordVo getByStudentId(@Param("studentId")Integer studentId,@Param("courseId")Integer courseId);
	
	
	/**
	 * 查询学校最高平均考核分
	 * @param studentId
	 * @return
	 */
	@Select("SELECT MAX(avgscore) as schoolheightscore FROM (SELECT stu.schoolId,stu.studentId,AVG(re.score) as avgscore FROM student stu,record re,hr_project_management pm WHERE stu.studentId=re.studentId" + 
			" AND re.projectId=pm.projectId AND pm.projectPermissions=1 AND re.courseId=#{courseId} AND stu.schoolId=(SELECT schoolId FROM student WHERE studentId=#{studentId}) GROUP BY stu.studentId) school")
	Integer getBySchool(@Param("courseId")Integer courseId,@Param("studentId")Integer studentId);
	
	
	/**
	 * 查询全国考核平均分，最高平均分
	 * @return
	 */
	@Select("SELECT SUM(score)/COUNT(studentId) as countryavgscore,MAX(score) as countryheightscore FROM (SELECT re.studentId AS studentId,AVG(re.score) AS score FROM record re,hr_project_management pm " + 
			" WHERE re.projectId=pm.projectId AND pm.projectPermissions=1 AND re.courseId=#{courseId} GROUP BY re.studentId) student")
	AssesmentRecordVo getByCountry(@Param("courseId")Integer courseId);

}
