package com.yipin.liuwanr.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.yipin.liuwanr.entity.Attendance;
@Mapper
public interface AttendanceMapper {

	/**
	 * 考勤记录
	 * @param studentId：学生id
	 * @param courseId：课程id
	 * @return
	 */
	@Select("SELECT pm.projectName as experimentName,att.signIn as signIn,att.creationTime as creationTime FROM hr_project_management pm,attendance att"
			+ " WHERE pm.projectId=att.experimentId  AND att.studentId=#{studentId} AND FIND_IN_SET(pm.systemId,(SELECT systemId FROM course WHERE courseId=#{courseId})) > 0")
	List<Attendance> getByCourseId(@Param("studentId") Integer studentId,@Param("courseId") Integer courseId);
	
	
	/**
	 * 获取该课程的所有练习项目id
	 * @param courseId
	 * @return
	 */
	@Select("SELECT projectId FROM hr_project_management WHERE isdel=0 AND projectPermissions=0  "
			+ " AND FIND_IN_SET(systemId,(SELECT systemId FROM course WHERE courseId=#{courseId}))")
	List<Integer> queryProjectIds(Integer courseId);
	
	
	/**
	 * 获取考勤记录表中，已经被签到过的项目，及签到状态
	 * @param projectIds
	 * @return
	 */
	@Select({"<script>",
		"SELECT experimentId,signIn  FROM attendance WHERE studentId=#{studentId}",
		"<foreach collection='projectIds' item='projectId' open='AND experimentId in (' separator=',' close=') GROUP BY experimentId'>" + "#{projectId}" + "</foreach> ",
		"</script>"})
	List<Attendance> querySigIn(@Param("studentId")Integer studentId,@Param("projectIds")List<Integer> projectIds);
	
	
	/**
	 * 获取学生姓名
	 * @param studentId
	 * @return
	 */
	@Select("SELECT studentName FROM student WHERE studentId=#{studentId}")
	String getByStudentName(Integer studentId);
}
