package com.yipin.liuwanr.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import com.yipin.liuwanr.entity.Course;
import com.yipin.liuwanr.entity.CourseLink;
import com.yipin.liuwanr.entity.CoursePermissions;
import com.yipin.liuwanr.entity.Discipline;
import com.yipin.liuwanr.entity.Professional;
import com.yipin.liuwanr.entity.ProfessionalClass;
import com.yipin.liuwanr.entity.ServiceConfig;
@Mapper
public interface CoursePermissionsMapper {
	
	@Insert("INSERT INTO hr_course_permissions(usePeriod,marketPrice,transactionPrice,discount,portAddressId,isDeliverGoods,courseId,orderId,isdel)"
			+ "VALUES(#{usePeriod},#{marketPrice},#{transactionPrice},#{discount},#{portAddressId},#{isDeliverGoods},#{courseId},#{orderId},0)")
//	@Options(useGeneratedKeys=true, keyProperty="courseId", keyColumn="courseId")
	void addCoursePermissions(CoursePermissions coursePermissions);
	
	@Insert({"<script>",
		"INSERT INTO hr_course_link(projectId,fileLink,linkName,isdel) values"
				+ "<foreach collection = 'courseLink' item='link' separator=','>"
				+ "(#{link.projectId},#{link.fileLink},#{link.linkName},0)" + "</foreach>",
        "</script> "})
	void addCourseLink(CourseLink courseLink);
	
	@Select({"<script>",
        "SELECT c.courseId,c.courseName,c.courseType,c.disciplineId,c.professionalClassId,c.professionalId,c.courseHours,c.marketPrice,c.courseIntroduction,c.teachingGoal,c.systemId,c.isShelves,(SELECT GROUP_CONCAT(ser.systemName) FROM `service_config` ser WHERE FIND_IN_SET(ser.systemId,c.systemId) ) as systemName from course c,service_config sc where c.isdel = 0 and c.systemId = sc.systemId",
        " <if test='disciplineId!=null'>and c.disciplineId = #{disciplineId} </if>",
        " <if test='courseType!=null'>and c.courseType = #{courseType} </if>",
        " <if test='professionalClassId!=null'>and c.professionalClassId = #{professionalClassId} </if>",
        " <if test='professionalId!=null'>and c.professionalId = #{professionalId} </if>",
        " <if test='searchContent!=null'> and c.courseName like CONCAT('%',#{searchContent},'%')</if>",
        "</script> "})
	List<Course> queryCourse(Course course);
	
	@Select({"<script>",
        "SELECT courseId,courseName,courseType,disciplineId,professionalClassId,professionalId,courseHours,marketPrice,courseIntroduction,teachingGoal,systemId,isShelves from course where isdel = 0 and courseId = #{courseId}",
        "</script> "})
	List<Course> queryCourseDetails(Integer courseId);
	
	@Update("UPDATE course SET isdel = 1 where courseId = #{courseId}")
	void deleteCourse(Integer courseId);
	
	@Update("UPDATE course SET courseName = #{courseName},courseType = #{courseType},disciplineId = #{disciplineId},professionalClassId = #{professionalClassId},professionalId = #{professionalId},"
			+ "courseHours = #{courseHours},marketPrice = #{marketPrice},courseIntroduction = #{courseIntroduction},teachingGoal = #{teachingGoal} where courseId = #{courseId}")
	void updateCourse(Course course);
	
	@Select({"<script>",
        "SELECT disciplineId,disciplineName,disciplineLevelId from discipline",
        "</script> "})
	List<Discipline> queryCourseDiscipline();
	
	@Select({"<script>",
        "SELECT professionalClassId,professionalClassName,disciplineId from professional_class where disciplineId = #{disciplineId}",
        "</script> "})
	List<ProfessionalClass> queryCourseProfessionalClass(Integer disciplineId);
	
	@Select({"<script>",
        "SELECT professionalId,professionalName,professionalClassId from professional where professionalClassId = #{professionalClassId}",
        "</script> "})
	List<Professional> queryCourseProfessional(Integer professionalClassId);
	
	@Select({"<script>",
        "SELECT systemId,systemName,systemType,systemAttribution,systemStatus from service_config where isdel = 0 ",
        " <if test='searchContent!=null'> and systemName like CONCAT('%',#{searchContent},'%')</if>",
        "</script> "})
	List<ServiceConfig> queryAppConfig(ServiceConfig serviceConfig);
	
	@Select({"<script>",
        "SELECT sc.systemId,sc.systemName,sc.systemType,sc.systemAttribution,sc.systemStatus,pm.projectName,pm.projectId,pm.isShow from service_config sc,hr_project_management pm,course c where sc.isdel = 0 and  sc.systemId = pm.systemId  and FIND_IN_SET(sc.systemId,c.systemId) and pm.isdel = 0 and c.courseId = #{courseId} ",
        "</script> "})
	List<ServiceConfig> queryTrainingConfig(Integer courseId);
	
	@Update("UPDATE course SET systemId = #{systemId} where courseId = #{courseId}")
	void addTrainingConfig(Course course);
	
	@Select({"<script>",
        "SELECT linkId,projectId,fileLink,linkName from hr_course_link where linkId = #{linkId} ",
        "</script> "})
	List<CourseLink> queryLinkDetails(Integer linkId);
	
	@Update("UPDATE hr_course_link SET fileLink = #{fileLink},linkName = #{linkName},projectId = #{projectId} where linkId = #{linkId}")
	void updateLink(CourseLink courseLink);
	
	@Update("UPDATE hr_project_management SET isdel = 1 where projectId = #{projectId}")
	void deleteTrainingConfig(Course course);
	
	@Update({"<script>",
        "UPDATE hr_project_management SET "
        + "<if test='isShow==1'> isShow = 1 </if>"
        + "<if test='isShow==0'> isShow = 0 </if>"
        + "where projectId = #{projectId} ",
        "</script> "})
	void isShow(Course course);
	
	@Update({"<script>",
        "UPDATE course SET "
        + "<if test='isShelves==1'> isShelves = 1 </if>"
        + "<if test='isShelves==0'> isShelves = 0 </if>"
        + "where courseId = #{courseId} ",
        "</script> "})
	void isShelves(Course course);
	
}