package com.yipin.liuwanr.mapper;

import java.util.List;

import com.yipin.liuwanr.entity.*;
import org.apache.ibatis.annotations.*;

import com.yipin.liuwanr.vo.CustomerVO;

@Mapper
public interface CustomerMapper {

	@Insert("INSERT INTO customer(countries,industry,provinceId,adminName,adminPhone,cityId,customerType,stopTime,email,isdel,schoolId,industryClassId,industryId,customerName,creationTime,account,position)"
			+ "VALUES(#{countries},#{industry},#{provinceId},#{adminName},#{adminPhone},#{cityId},#{customerType},#{stopTime},#{email},0,#{schoolId},#{industryClassId},#{industryId},#{customerName},now(),#{account},#{position})")
	void addCustomer(Customer customer);

	@Insert("INSERT INTO user(countries,provinceId,cityId,accountRole,creationTime,phone,password,email,isdel"
			+ ") VALUES(#{countries},#{provinceId},#{cityId},2,"
			+ "now(),#{phone},'huoran123',#{email},0)")
	void addAdmin(UserM userm);

	@Select({"<script>",
			"SELECT c.customerId,ic.industryClassName,i.industryName,c.customerName,c.countries,c.provinceId,c.adminName,c.adminPhone,c.cityId,c.customerType,c.stopTime,c.email,c.schoolId,cit.cityName,p.provinceName,s.schoolName,s.level from customer c,province p,city cit,school s,hr_industry_class ic,hr_industry i where c.isdel = 0 and p.provinceId=c.provinceId and cit.cityId = c.cityId and s.schoolId = c.schoolId and ic.industryClassId = c.industryClassId and i.industryId = c.industryId",
			" <if test='countries!=null'>and c.countries = #{countries} </if>",
			" <if test='provinceId!=null'>and c.provinceId = #{provinceId} </if>",
			" <if test='cityId!=null'>and c.cityId = #{cityId} </if>",
			" <if test='searchContent!=null'> AND CONCAT(c.customerName, c.adminName, c.adminPhone) LIKE CONCAT('%',#{searchContent},'%')</if>",
			"GROUP BY c.customerId order by c.creationTime desc",
			"</script> "})
	List<Customer> queryCustomer(Customer customer);

	@Select("SELECT c.*,s.`level` from customer c,school s where c.isdel = 0 and s.schoolId = c.schoolId and c.customerId = #{customerId}")
	@Results({
			@Result(property = "customers", column = "customerId",one = @One(select = "com.yipin.liuwanr.mapper.CustomerMapper.queryCustomerDetailsC")),
			@Result(property = "contractInformations", column = "customerId",one = @One(select = "com.yipin.liuwanr.mapper.CustomerMapper.queryOrderDetailsCI")),
			@Result(property = "coursePermissionss", column = "customerId",many = @Many(select = "com.yipin.liuwanr.mapper.CustomerMapper.queryCustomerDetailsCP"))
	})
	List<CustomerVO> queryCustomerDetails(Integer customerId);

	@Select({"<script>",
			"SELECT ic.industryClassName,i.industryName,c.industryClassId,c.industryId,c.customerName,c.countries,c.industry,c.provinceId,c.adminName,c.adminPhone,c.cityId,c.customerType,c.stopTime,c.email,c.schoolId,s.`level` from customer c,school s,hr_industry_class ic,hr_industry i where c.isdel = 0 and s.schoolId = c.schoolId and c.customerId = #{customerId} and ic.industryClassId = c.industryClassId and i.industryId = c.industryId",
			"</script> "})
	Customer queryCustomerDetailsC(Integer customerId);

	@Select({"<script>",
			"SELECT cp.*,c.courseName FROM hr_course_permissions cp,course c WHERE cp.orderId in (SELECT orderId FROM orders WHERE customerId = #{customerId}) and cp.courseId = c.courseId",
			"</script> "})
	List<CoursePermissions>queryCustomerDetailsCP(Integer customerId);

	@Select({"<script>",
			"SELECT ci.* from hr_contract_information ci where ci.orderId in (SELECT orderId FROM orders WHERE customerId = #{customerId})",
			"</script> "})
	ContractInformation queryOrderDetailsCI(Integer customerId);

	@Update({ "<script>",
			"UPDATE customer SET isdel = 1 where customerId in "
					+"<foreach collection='customer' item='cus' open='(' separator=',' close=')'>"
					+"#{cus.customerId} "
					+ "</foreach> ",
			"</script>" })
	void deleteCustomer(Customer customer);

	@Update("UPDATE customer SET customerName = #{customerName},countries = #{countries},industry = #{industry},provinceId = #{provinceId},adminName = #{adminName},"
			+ "adminPhone = #{adminPhone},cityId = #{cityId},customerType = #{customerType},stopTime = #{stopTime},email = #{email},schoolId = #{schoolId},account = #{account},position = #{position} where customerId = #{customerId}")
	void updateCustomer(Customer customer);

	@Select({"<script>",
			"SELECT customerId,schoolId from customer where isdel = 0 and schoolId = #{schoolId}",
			"</script> "})
	List<Customer> queryCustomerIsExists(Integer schoolId);

	//查询行业类
	@Select({"<script>",
			"SELECT industryClassId,industryClassName from hr_industry_class",
			"</script> "})
	List<IndustryClass> queryCustomerIndustryClass();

	//查询行业
	@Select({"<script>",
			"SELECT industryId,industryClassId,industryName from hr_industry where industryClassId = #{industryClassId}",
			"</script> "})
	List<Industry> queryCustomerIndustry(Integer industryClassId);

	//查询行业
	@Select({"<script>",
			"SELECT schoolId,schoolName,provinceId,cityId,level,provinceName,cityName from school where isdel = 0",
			" <if test='provinceId!=null'>and provinceId = #{provinceId} </if>",
			" <if test='cityId!=null'>and cityId = #{cityId} </if>",
			" <if test='schoolName!=null and schoolName!=\"\"'>and schoolName like concat('%',#{schoolName},'%') </if>",
			"</script> "})
	List<School> querySchool(School school);
}