package com.yipin.liuwanr.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yipin.liuwanr.entity.HrUserAccount;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.yipin.liuwanr.entity.response.UserAccountListRes;
import com.yipin.liuwanr.entity.response.UserInfoListRes;
import com.yipin.liuwanr.entity.vo.UserInfoReq;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;


/**
 * <p>
 * 各个平台账号表 Mapper 接口
 * </p>
 *
 * @author Qyq
 * @since 2021-06-18
 */
@Mapper
public interface HrUserAccountMapper extends BaseMapper<HrUserAccount> {

    @Select({"<script>",
            "        SELECT\n" +
            "            ui.userId,\n" +
            "            GROUP_CONCAT( DISTINCT ua.account ) as account,\n" +
            "            ui.userName,\n" +
            "            GROUP_CONCAT( DISTINCT s.schoolName ) AS schoolName,\n" +
            "            GROUP_CONCAT( DISTINCT p.platformName ) as platformName,\n" +
            "            ui.phone,\n" +
            "            ui.creationTime,\n" +
            "            ui.logInNumber\n" +
            "        FROM\n" +
            "            hr_user_info ui\n" +
            "            INNER JOIN hr_user_account ua ON ui.userId = ua.user_id\n" +
            "            LEFT JOIN school s on s.schoolId=ua.school_id\n" +
            "            LEFT JOIN hr_platform p on p.platformId=ua.platform_id where ui.isdel=0 and ua.isdel=0\n" +
            "       <if test='userInfoReq.creationTime!=null and userInfoReq.endTime!=null and userInfoReq.endTime!=\"\" and userInfoReq.creationTime!=\"\" '> " +
                        "AND ui.creationTime between #{userInfoReq.creationTime} and #{userInfoReq.endTime}" +
                    "</if>\n"+
            "       <if test='userInfoReq.month !=null'> " +
                        "AND ui.creationTime &gt; date_sub(curdate(),interval #{userInfoReq.month} MONTH) " +
                    "</if>\n" +
            "       <if test='userInfoReq.platformId !=null'> " +
                        "AND  FIND_IN_SET(ua.platform_id,#{userInfoReq.platformId}) " +
                    "</if>\n" +
            "       <if test='userInfoReq.schoolId !=null'> " +
                        "AND  FIND_IN_SET(ua.school_id,#{userInfoReq.schoolId}) " +
                    "</if>\n" +
            "       <if test='userInfoReq.searchContent !=null'> " +
                        "AND (ui.userName LIKE CONCAT('%',#{userInfoReq.searchContent},'%') OR ua.account LIKE CONCAT('%',#{userInfoReq.searchContent},'%') OR ui.phone LIKE CONCAT('%',#{userInfoReq.searchContent},'%'))" +
                    "</if>\n" +
            "        GROUP BY ui.phone",
            "</script> "})
    List<UserInfoListRes> pageByCondition(Page page, @Param("userInfoReq") UserInfoReq userInfoReq);

    IPage<UserInfoListRes> pageByCondition2(Page page);

    @Select("select ua.*,s.schoolName from hr_user_account ua left join school s on s.schoolId = ua.school_id where user_id=#{userId} and platform_id=#{platformId}")
    List<UserAccountListRes> selectUserSysBindById(Integer userId, Integer platformId);
}
