package com.yipin.liuwanr.mapper;

import java.util.List;

import com.yipin.liuwanr.entity.Makeuplist;
import com.yipin.liuwanr.entity.Student;
import com.yipin.liuwanr.vo.MakeupStudentsVo;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

/**
*
* 
* @author 全承珠
*
*/
@Mapper
public interface MakeuplistMapper {

	@Select("select professionalName,gradeName,className,m.studentNumber,studentName from makeuplist m,student s,class c,grade g,professional p " +
			"where m.studentId=s.studentId and m.classId=c.classId and c.gradeId=g.gradeId and s.professionalId=p.professionalId  and m.staffId=#{staffId} and m.uploadTime=#{uploadTime} and m.schoolId=#{schoolId}")
	List<Makeuplist> queryClassMakeuplist(@Param("staffId")Integer staffId, @Param("uploadTime")String uploadTime,@Param("schoolId") Integer schoolId);

	@Select("select professionalName,gradeName,experimentalClassName,m.studentNumber,studentName from makeuplist m,student s,class c,experimental_class_ning ecn,grade g,professional p " +
			"where m.studentId=s.studentId and s.classId=c.classId and c.gradeId=g.gradeId and s.professionalId=p.professionalId and m.experimentalClassId=ecn .experimentalClassId  and m.staffId=#{staffId} and m.uploadTime=#{uploadTime} and m.schoolId=#{schoolId}")
	List<Makeuplist> queryExperimentalClassMakeuplist(@Param("staffId")Integer staffId, @Param("uploadTime")String uploadTime,@Param("schoolId") Integer schoolId);

	@Select("select experimentalClassId,studentId,classId from makeuplist where staffId=#{staffId} and uploadTime=#{uploadTime} and schoolId=#{schoolId} and uploadType=#{uploadType}")
	List<Student> getstudent(@Param("staffId")Integer staffId, @Param("uploadTime")String uploadTime,@Param("schoolId") Integer schoolId,@Param("uploadType")Integer uploadType);

	@Select("select classId,studentId from makeuplist where staffId=#{staffId} and uploadTime=#{uploadTime}")
	List<Student> getClass(@Param("staffId")Integer staffId, @Param("uploadTime")String uploadTime);
	
	@Insert(
		"insert into  makeuplist (schoolId,classId,experimentalClassId,studentNumber,studentId,staffId,uploadType,uploadTime) values"
		+ "(#{schoolId},#{classId},#{experimentalClassId},#{studentNumber},#{studentId},#{staffId},#{uploadType},#{time})")
	void addMakeuplist(MakeupStudentsVo vo);

	//实验班级信息
	@Select("SELECT exn.experimentalClassId,studentNumber,s.studentId  from student s left join  experimental_class_student ecs on s.studentId=ecs.studentId  left join experimental_class_ning  exn on ecs.experimentalClassId=exn.experimentalClassId " +
			" where  exn.experimentalClassName=#{experimentalClassName} and exn.schoolId=#{schoolId} and s.studentNumber=#{studentNumber}")
	Student queryExperimentalClassStudent(@Param("experimentalClassName") String experimentalClassName,@Param("schoolId")Integer schoolId,@Param("studentNumber")String studentNumber);

	//行政班级信息
	@Select("select classId,studentNumber,studentId from student where studentNumber=#{studentNumber} and schoolId=#{schoolId}")
	Student queryClassStudent(@Param("studentNumber")String studentNumber,@Param("schoolId")Integer schoolId);
}
