package com.yipin.liuwanr.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import com.yipin.liuwanr.entity.School;
@Mapper
public interface SchoolMapper {
	
	@Insert("INSERT INTO school(schoolName,provinceId,cityId,level,isdel)"
			+ "VALUES(#{schoolName},#{provinceId},#{cityId},#{level},0)")
	void addSchool(School school);
	
	@Select({"<script>",
        "SELECT schoolId,schoolName,provinceId,cityId,level from school where isdel = 0 ",
        " <if test='provinceId!=null'>and provinceId = #{provinceId} </if>",
        " <if test='cityId!=null'>and cityId = #{cityId} </if>",
        " <if test='level!=null'>and level = #{level} </if>",
        "</script> "})
	List<School> querySchool(School school);
	
	@Select({"<script>",
        "SELECT schoolId,schoolName,provinceId,cityId,level from school where isdel = 0 and schoolId = #{schoolId}",
        "</script> "})
	List<School> querySchoolDetails(Integer schoolId);
	
	@Update("UPDATE school SET isdel = 1 where schoolId = #{schoolId}")
	void deleteSchool(School school);
	
	@Update("UPDATE school SET schoolName = #{schoolName},provinceId = #{provinceId},cityId = #{cityId},level = #{level} where schoolId = #{schoolId}")
	void updateSchool(School school);
}