package com.yipin.liuwanr.mapper;

import com.yipin.liuwanr.entity.ServiceConfig;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;
@Mapper
public interface ServiceConfigMapper {

    @Insert("INSERT INTO service_config(systemName,systemType,systemAttribution,systemStatus,isdel) VALUES(#{systemName},#{systemType},#{systemAttribution},#{systemStatus},0)")
    void addServiceConfig(ServiceConfig serviceConfig);

    @Select({"<script>",
            "SELECT systemId,systemName,systemType,systemAttribution,systemStatus,projectSystemAddress,markPointsAddress from service_config where isdel = 0 ",
            " <if test='systemAttribution !=null'>and systemAttribution = #{systemAttribution} </if>",
            " <if test='systemType !=null'>and systemType = #{systemType} </if>",
            " <if test='searchContent!=null'> and systemName like CONCAT('%',#{searchContent},'%')</if>",
            "</script> "})
    List<ServiceConfig> queryServiceConfig(ServiceConfig serviceConfig);

    @Select({"<script>",
            "SELECT systemId,systemName,systemType,systemAttribution,systemStatus,projectSystemAddress,markPointsAddress from service_config where systemId = #{systemId} ",
            "</script> "})
    List<ServiceConfig> queryServiceConfigDetails(Integer systemId);

    @Update("UPDATE service_config SET isdel = 1 where systemId = #{systemId}")
    void deleteServiceConfig(ServiceConfig serviceConfig);

    @Update("UPDATE service_config SET systemName = #{systemName},systemType = #{systemType},systemAttribution = #{systemAttribution},systemStatus = #{systemStatus} where systemId = #{systemId}")
    void updateServiceConfig(ServiceConfig serviceConfig);
}