package com.yipin.liuwanr.mapper;

import java.util.List;

import com.yipin.liuwanr.entity.Student;
import org.apache.ibatis.annotations.*;

import com.yipin.liuwanr.entity.Staff;
import com.yipin.liuwanr.entity.StaffGrade;
@Mapper
public interface StaffGradeMapper {
	@Insert("INSERT INTO staff_grade(staffGradeName,staffProfessionalArchitectureId,isdel)"
			+ "VALUES(#{staffGradeName},#{staffProfessionalArchitectureId},0)")
	@Options(useGeneratedKeys=true, keyProperty="staffGradeId", keyColumn="staffGradeId")
	void addStaffGrade(StaffGrade staffGrade);
	
	@Select({"<script>",
        "SELECT staffGradeId,staffGradeName,staffProfessionalArchitectureId from staff_grade where isdel = 0 and staffProfessionalArchitectureId = #{staffProfessionalArchitectureId}",
		"</script> "})
	List<StaffGrade> queryStaffGrade(Integer staffProfessionalArchitectureId);

	@Update({"<script>",
			"UPDATE staff s,hr_user_info u SET s.isdel = 1,u.isdel = 1 WHERE s.userId = u.userId AND s.userId IN"
			+ "<foreach collection='userIds' item='stu' open='(' separator=',' close=')'>"
					+ "#{stu}"
					+ "</foreach> ",
			"</script>"})
	void deleteStaffGrade(@Param("userIds") List<Integer> userIds);


	@Update("UPDATE staff_grade SET isdel = 1 where staffGradeId = #{staffGradeId}")
	void deleteStaffGradePs(Integer staffGradeId);
	
	@Select({"<script>",
        "SELECT staffGradeId,staffGradeName,staffProfessionalArchitectureId from staff_grade where isdel = 0 and staffGradeId = #{staffGradeId}",
        "</script> "})
	List<Staff> queryStaffGradeDetails(Integer staffGradeId);
	
	@Update("UPDATE staff_grade SET staffGradeName = #{staffGradeName},staffProfessionalArchitectureId = #{staffProfessionalArchitectureId} where staffGradeId = #{staffGradeId}")
	void updateStaffGrade(StaffGrade staffGrade);

	@Select("select userId from staff where staffGradeId =#{staffGradeId} and isdel = 0")
	List<Integer> queryUserIdsByGradeId(Integer staffGradeId);

	@Update("UPDATE staff_grade SET isdel = 1 where staffProfessionalArchitectureId = #{staffProfessionalArchitectureId}")
	void delStaffGradeByArchId(Integer staffProfessionalArchitectureId);

	@Update("UPDATE staff_grade SET isdel = 1 where staffProfessionalArchitectureId = #{staffProfessionalArchitectureId}")
	void deleteStaffArch(Integer staffProfessionalArchitectureId);
}