package com.yipin.liuwanr.mapper;

import java.util.List;

import com.yipin.liuwanr.entity.*;
import com.yipin.liuwanr.vo.UserInfoVO;
import com.yipin.liuwanr.vo.UserVO;
import org.apache.ibatis.annotations.*;

import io.lettuce.core.dynamic.annotation.Param;
@Mapper
public interface StaffMapper {
//	@Insert("INSERT INTO staff(staffName,staffWorkNumber,phone,email,staffProfessionalArchitectureId,staffGradeId,roleId,isdel,uniqueIdentificationAccount,schoolId)VALUES(#{staffName},#{staffWorkNumber},#{phone},#{email},#{staffProfessionalArchitectureId},#{staffGradeId},#{roleId},0,#{uniqueIdentificationAccount},#{schoolId})")
//	void addStaff(Staff staff);
	//添加员工
	@Insert("INSERT INTO staff(staffName,workNumber,phone,email,staffProfessionalArchitectureId,staffGradeId,roleId,isdel,uniqueIdentificationAccount,schoolId)VALUES(#{staffName},#{workNumber},#{phone},#{email},#{staffProfessionalArchitectureId},#{staffGradeId},#{roleId},0,#{uniqueIdentificationAccount},#{schoolId})")
	void addStaff(Staff staff);
	
	@Select({"<script>",
		"SELECT hui.lastLoginTime,hor.userId,hor.organizationRelationshipId,hui.userName,hor.workNumber,hor.oneDepartmentId,hor.oneDepartmentName,hor.twoDepartmentId,hor.twoDepartmentName,hor.roleId,hui.logInNumber as logInNumber,hui.lastLoginTime as lastTimeOfLanding FROM hr_user_info hui,hr_organization_relationship hor WHERE hui.userId = hor.userId and hor.roleId != 1 and hor.roleId !=4 and hor.schoolId = #{schoolId} and hor.isdel=0",
      	" <if test='searchContent!=null'> and hui.userName like CONCAT('%',#{searchContent},'%') or hor.workNumber like CONCAT('%',#{searchContent},'%')</if>",
        " <if test='oneDepartmentIds!=null'>and FIND_IN_SET(hor.oneDepartmentId,#{oneDepartmentIds})</if>",
        " <if test='twoDepartmentIds!=null'> and FIND_IN_SET(hor.twoDepartmentId,#{twoDepartmentIds}) </if>",
		"GROUP BY hui.userId",
		"</script> "})
	List<UserInfo> queryStaff(UserInfo userInfo);
	
	@Update({"<script>",
		"UPDATE hr_organization_relationship SET isdel = 1 where organizationRelationshipId = #{organizationRelationshipId}",
		"</script> "})
	void deleteStaff(Integer organizationRelationshipId);

	@Update({"<script>",
			"UPDATE user SET isdel = 1 where phone = #{phone}",
			"</script> "})
	void deleteUser(String phone);
	
	@Select({"<script>",
        "SELECT roleId,oneDepartmentId,oneDepartmentName,twoDepartmentId,twoDepartmentName,workNumber from hr_organization_relationship where userId = #{userId} and roleId = #{roleId}",
        "</script> "})
	List<OrganizationRelationship> queryStaffDetails(Integer userId,Integer roleId);

	//查询员工用户详情
	@Select({ "<script>",
			"SELECT userId,userName,uniqueIdentificationAccount,account,phone,email from hr_user_info where isdel = 0 and userId = #{userId}",
			"</script> " })
	List<UserInfo> queryStaffDetailsU(Integer userId);

	//查询用户角色
	@Select({ "<script>",
			"SELECT roleId from hr_organization_relationship where userId = #{userId}",
			"</script> " })
	List<OrganizationRelationship> queryRole(Integer userId);

	//修改员工
	@Update("UPDATE staff SET staffName = #{staffName},workNumber = #{workNumber},phone = #{phone},email = #{email},staffProfessionalArchitectureId = #{staffProfessionalArchitectureId},"
			+ "staffProfessionalArchitectureId = #{staffProfessionalArchitectureId},staffGradeId = #{staffGradeId},roleId = #{roleId} where staffId = #{staffId}")
	void updateStaff(Staff staff);

	//修改用户
	@Update("UPDATE user SET phone = #{phone},name = #{name},userAccount = #{userAccount},workNumber = #{workNumber},provinceId = #{provinceId},cityId = #{cityId},email = #{email},schoolId = #{schoolId},uniqueIdentificationAccount = #{uniqueIdentificationAccount},disciplineId = #{disciplineId},professionalClassId = #{professionalClassId},professionalId = #{professionalId} where phone = #{phone}")
	void updateUser(UserM user);

	//修改员工
	@Update("UPDATE hr_organization_relationship SET oneDepartmentId = #{oneDepartmentId},oneDepartmentName = #{oneDepartmentName},twoDepartmentId = #{twoDepartmentId},twoDepartmentName = #{twoDepartmentName},workNumber = #{workNumber}"
			+ "where organizationRelationshipId = #{organizationRelationshipId}")
	void updateNewStaff(OrganizationRelationship organizationRelationship);

	//修改用户
	@Update("UPDATE hr_user_info SET userName = #{userName},uniqueIdentificationAccount = #{uniqueIdentificationAccount},account = #{account},phone = #{phone},email = #{email} where userId = #{userId}")
	void updateNewUser(UserInfo userInfo);

	/**
	 * 得到所有未删除的部门信息
	 * @return
	 */
	@Select("SELECT staffGradeId,staffGradeName FROM staff_grade WHERE isdel=0")
	List<StaffGrade> queryStaffGrade();
	
	/**
	 * 根据id查部门
	 * @param staffGradeId
	 * @return
	 */
	@Select("SELECT staffGradeName  FROM staff_grade WHERE staffGradeId=#{staffGradeId}")
	String getStaffGradeName(Integer staffGradeId);
	
	/**
	  * 批量导入员工 信息
	  * @param staffs
	  */
	 @Insert({
	        "<script>",
	        "insert into staff(staffName,workNumber,staffGradeId,staffProfessionalArchitectureId,roleId,phone,uniqueIdentificationAccount,email,schoolId,isdel) values ",
	        "<foreach collection='list' item='staff' index='index' separator=','>",
	        "(#{staff.staffName}, #{staff.workNumber}, #{staff.staffGradeId},#{staff.staffProfessionalArchitectureId}, #{staff.roleId} ,#{staff.phone},#{staff.uniqueIdentificationAccount},#{staff.email},#{staff.schoolId},0)",
	        "</foreach>",
	        "</script>"
	     })
	 void batchAddStaff(@Param("staffs")List<Staff> staffs);
	 
	 
	 //查询专业、部门id 
	 @Select("select a.staffProfessionalArchitectureId,g.staffGradeId from staff_professional_architecture a left join staff_grade g on (a.staffProfessionalArchitectureId=g.staffProfessionalArchitectureId)" + 
	   "where a.isdel=0 and g.isdel=0 and schoolId=#{schoolId} and staffProfessionalArchitectureName=#{staffProfessionalArchitectureName}  and  staffGradeName=#{staffGradeName}")
	 Staff getStaff(Staff staff);



	 //=======全承珠

	@Select({"<script>",
			"select staffId,workNumber,logNumber from staff where isdel=0",
			"<if test='phone!=null'>and phone=#{phone} </if>",
			"<if test='workNumber!=null'>and workNumber=#{workNumber} </if>",
			"<if test='uniqueIdentificationAccount!=null'>and uniqueIdentificationAccount=#{uniqueIdentificationAccount} </if>",
			"</script>"})
	Staff queryStaffQ(UserM user);


	@Update("update staff set lastTimeOfLanding=#{lastTime},logNumber=#{logNumber}  where staffId=#{staffId}")
	void updateStaffQ(@Param("lastTime") String lastTime,@Param("logNumber") Integer logNumber,@Param("staffId") Integer staffId);

	@Select("select schoolId,staffId FROM staff WHERE userId = #{userId} AND isdel = 0 GROUP BY schoolId ORDER BY staffId limit 1")
	Integer querySchoolId(Integer userId);
	@Select("select userId from staff where staffProfessionalArchitectureId =#{staffProfessionalArchitectureId} and isdel = 0")
	List<Integer> queryUserIdsByArchId(Integer staffProfessionalArchitectureId);

}