package com.yipin.liuwanr.mapper;

import java.util.List;

import org.apache.ibatis.annotations.*;

import com.yipin.liuwanr.entity.StaffProfessionalArchitecture;
@Mapper
public interface StaffProfessionalArchitectureMapper {
	
	@Insert("INSERT INTO staff_professional_architecture(staffProfessionalArchitectureName,schoolId,isdel)"
			+ "VALUES(#{staffProfessionalArchitectureName},#{schoolId},0)")
	@Options(useGeneratedKeys=true, keyProperty="staffProfessionalArchitectureId", keyColumn="staffProfessionalArchitectureId")
	void addStaffProfessionalArchitecture(StaffProfessionalArchitecture staffProfessionalArchitecture);
	
	@Select({"<script>",
        "SELECT staffProfessionalArchitectureId,staffProfessionalArchitectureName,schoolId from staff_professional_architecture where isdel = 0 and schoolId = #{schoolId}",
        "</script> "})
	List<StaffProfessionalArchitecture> queryStaffProfessionalArchitecture(Integer schoolId);

	@Select("SELECT staffProfessionalArchitectureId,staffProfessionalArchitectureName,schoolId from staff_professional_architecture where isdel = 0 and staffProfessionalArchitectureName = #{staffProfessionalArchitectureName} and schoolId=#{schoolId}")
	List<StaffProfessionalArchitecture> queryStaffPAN(@Param("staffProfessionalArchitectureName") String staffProfessionalArchitectureName, @Param("schoolId") Integer schoolId);

	
	@Update("UPDATE staff_professional_architecture SET isdel = 1 where staffProfessionalArchitectureId = #{staffProfessionalArchitectureId}")
	void deleteStaffProfessionalArchitecture(Integer staffProfessionalArchitectureId);
	
	@Update("UPDATE staff_professional_architecture SET staffProfessionalArchitectureName = #{staffProfessionalArchitectureName} where staffProfessionalArchitectureId = #{staffProfessionalArchitectureId}")
	void updateStaffProfessionalArchitecture(StaffProfessionalArchitecture staffProfessionalArchitecture);
	
	@Select({"<script>",
        "SELECT pro.staffProfessionalArchitectureId,pro.staffProfessionalArchitectureName,pro.schoolId,sch.schoolName from staff_professional_architecture pro,school sch where pro.isdel = 0 and pro.schoolId = sch.schoolId and  pro.schoolId = #{schoolId}",
        "</script> "})
	List<StaffProfessionalArchitecture> queryAllStaffProfessionalArchitecture(Integer schoolId);

	@Update("UPDATE staff sta,\n" +
			"staff_professional_architecture spa \n" +
			"SET sta.staffProfessionalArchitectureName = spa.staffProfessionalArchitectureName \n" +
			"WHERE\n" +
			"\tsta.staffProfessionalArchitectureId = spa.staffProfessionalArchitectureId")
	void updateStaffArchitectureName();
}