package com.yipin.liuwanr.mapper;

import java.util.List;

import com.yipin.liuwanr.entity.Class;
import org.apache.ibatis.annotations.*;

import com.yipin.liuwanr.entity.Grade;
import com.yipin.liuwanr.entity.StuProfessionalArchitecture;
import com.yipin.liuwanr.entity.Student;
@Mapper
public interface StuProfessionalArchitectureMapper {
	
	@Insert("INSERT INTO stu_professional_architecture(stuProfessionalArchitectureName,schoolId,isdel)"
			+ "VALUES(#{stuProfessionalArchitectureName},#{schoolId},0)")
	@Options(useGeneratedKeys=true, keyProperty="stuProfessionalArchitectureId", keyColumn="stuProfessionalArchitectureId")
	void addStuProfessionalArchitecture(StuProfessionalArchitecture stuProfessionalArchitecture);
	
	@Select({"<script>",
        "SELECT stuProfessionalArchitectureId,stuProfessionalArchitectureName,schoolId from stu_professional_architecture where isdel = 0 and schoolId = #{schoolId}",
        "</script> "})
	List<StuProfessionalArchitecture> queryStuProfessionalArchitecture(Integer schoolId);
	
	@Select({"<script>",
        "SELECT stuProfessionalArchitectureId,stuProfessionalArchitectureName,schoolId from stu_professional_architecture where isdel = 0 and stuProfessionalArchitectureId = #{stuProfessionalArchitectureId}",
        "</script> "})
	List<StuProfessionalArchitecture> queryStuPAD(Integer stuProfessionalArchitectureId);
	
	@Update("UPDATE stu_professional_architecture SET isdel = 1 where stuProfessionalArchitectureId = #{stuProfessionalArchitectureId}")
	void deleteStuProfessionalArchitecture(Integer stuProfessionalArchitectureId);
	
	@Update("UPDATE stu_professional_architecture SET stuProfessionalArchitectureName = #{stuProfessionalArchitectureName} where stuProfessionalArchitectureId = #{stuProfessionalArchitectureId}")
	void updateStuProfessionalArchitecture(StuProfessionalArchitecture professionalArchitecture);
	
	@Select({"<script>",
        "SELECT stu.stuProfessionalArchitectureId,stu.stuProfessionalArchitectureName,gra.gradeName,cla.className,st.studentName "
        + "from stu_professional_architecture stu,grade gra,class cla,student st  where stu.isdel = 0 "
        + "and stu.stuProfessionalArchitectureId = gra.stuProfessionalArchitectureId and gra.gradeId = cla.gradeId and st.classId = cla.classId and stu.schoolId =#{schoolId}",
        "</script> "})
	List<StuProfessionalArchitecture> queryStudentProfessionalArchitecture(Integer schoolId);
	
	@Select({"<script>",
        "SELECT gradeId,gradeName from grade where stuProfessionalArchitectureId = #{stuProfessionalArchitectureId} and isdel = 0",
        "</script> "})
	List<Grade> queryStuGrade(Integer stuProfessionalArchitectureId);
	
	@Select({"<script>",
        "SELECT gradeId,gradeName from grade where gradeId = #{gradeId}",
        "</script> "})
	List<Grade> queryStuGradeD(Integer gradeId);
	
	@Select({"<script>",
        "SELECT classId,className from class where gradeId = #{gradeId} and isdel = 0",
        "</script> "})
	List<Class> queryStuClass(Integer gradeId);
	
	@Select({"<script>",
        "SELECT classId,className from class where classId = #{classId}",
        "</script> "})
	List<Class> queryStuClassD(Integer classId);
	
	@Insert("INSERT INTO class(className,gradeId)"
			+ "VALUES(#{className},#{gradeId})")
	@Options(useGeneratedKeys=true, keyProperty="classId", keyColumn="classId")
	void addStuClass(StuProfessionalArchitecture stuProfessionalArchitecture);
	
	@Update("UPDATE class SET className = #{className} where classId = #{classId}")
	void updateStuClass(StuProfessionalArchitecture professionalArchitecture);
	
	@Update("UPDATE class SET isdel = 1 where classId = #{classId}")
	void deleteStuClass(Integer classId);
	
	@Insert("INSERT INTO grade(gradeName,stuProfessionalArchitectureId)"
			+ "VALUES(#{gradeName},#{stuProfessionalArchitectureId})")
	@Options(useGeneratedKeys=true, keyProperty="gradeId", keyColumn="gradeId")
	void addStuGrade(StuProfessionalArchitecture stuProfessionalArchitecture);
	
	@Update("UPDATE grade SET gradeName = #{gradeName} where gradeId = #{gradeId}")
	void updateStuGrade(StuProfessionalArchitecture professionalArchitecture);

	@Update("UPDATE grade SET isdel = 1 where gradeId = #{gradeId}")
	void deleteStuGrade(Integer gradeId);
	
	@Select({"<script>",
        "SELECT studentId,studentName from student where classId = #{classId} and isdel = 0",
        "</script> "})
	List<Student> queryStudent(Integer classId);
	
}