package com.yipin.liuwanr.mapper;

import com.yipin.liuwanr.entity.SysPermission;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * 菜单权限表 Mapper 接口
 * </p>
 *
 * @author Qyq
 * @since 2021-02-26
 */
@Mapper
public interface SysPermissionMapper extends BaseMapper<SysPermission> {
    @Select({"<script>",
"        select id,code,name,parent_id as parentId,level,menu_or_not as menuOrNot," +
        "status,url,menu_url as menuUrl,sort,icon,create_time as createTime,motify_time as motifyTime from sys_permission\n" +
        "        where id in\n" +
        "        <foreach collection=\"ids\" open=\"(\" separator=\",\" close=\")\" item=\"id\">\n" +
        "            #{id}\n" +
        "        </foreach>",
            "</script> "})
    List<SysPermission> queryPermissionsByIds(@Param("ids")List<Long> ids);
}
