package com.yipin.liuwanr.mapper;

import java.util.List;

import com.yipin.liuwanr.entity.CourseLink;
import com.yipin.liuwanr.entity.CourseSchedule;
import com.yipin.liuwanr.vo.CourseAndProjectVo;
import org.apache.ibatis.annotations.*;

import com.yipin.liuwanr.entity.Project_Management;

/**
 * 实验管理
 * @author 或然
 *
 */
@Mapper
public interface TeacherProjectAndCourseMapper {
	
	/**
	 * 查询实验项目信息
	 */
//	@Select({"<script>",
//	      "select projectId,projectName,isExperiment,isAttendance from  hr_project_management  WHERE isdel=0 and projectPermissions=0 and state=1 " +
//				  " and systemId in (select systemId FROM hr_course_tc where courseId=#{courseId} GROUP BY systemId)",
//	      "<if test='isExperiment!=null'> and isExperiment=0</if>",
//	      "<if test='isAttendance!=null'> and isAttendance=0</if>",
//	    "</script>"})

	@Select("select DISTINCT hpm.projectId,projectName,isOpenProject,isAttendance from hr_project_management hpm left join teacher_project tp on hpm.projectId=tp.projectId " +
			" where tp.courseId=#{courseId} and tp.experimentalClassId=#{experimentalClassId} and hpm.isShow=0 ")
	List<Project_Management> getBySystemId(@Param("courseId") Integer  courseId,@Param("experimentalClassId")Integer experimentalClassId);


	/**
	 * 修改是否开启项目
	 */
	@Update("update teacher_project set isOpenProject=#{project.isOpenProject} where courseId=#{courseId} and experimentalClassId=#{experimentalClassId} and projectId=#{project.projectId}")
	void  updateIsExperiment(CourseAndProjectVo vo);

	/**
	 * 修改是否开启考勤
	 */
	@Update("update teacher_project set isAttendance=#{project.isAttendance} where courseId=#{courseId} and experimentalClassId=#{experimentalClassId} and projectId=#{project.projectId}")
	void  updateIsAttendance(CourseAndProjectVo vo);

	@Select("select count(*) from hr_course_schedule where courseId=#{courseId}")
	Integer getCourseSchedule(Integer courseId);

	@Select("select DISTINCT tc.projectId from hr_course_tc tc left join hr_project_management pm on tc.projectId=pm.projectId where pm.isdel=0 and tc.courseId=#{courseId} and pm.projectPermissions=0 ")
	List<Integer> queryProject(Integer courseId);

	@Insert({"<script>",
			"insert into teacher_project(courseId,experimentalClassId,projectId) values ",
			"<foreach collection='projectIds' item='projectId' index='index' separator=','>",
			"(#{courseId},#{experimentalClassId}, #{projectId})",
			"</foreach>",
			"</script>"})
	void  addBatchTeachProject(@Param("experimentalClassId") Integer experimentalClassId,@Param("courseId") Integer courseId,@Param("projectIds") List<Integer> projectIds);


	//添加课程进度
	@Insert("insert into hr_course_schedule (courseId,experimentalClassId,projectId) VALUES (#{courseId},#{experimentalClassId},#{projectId})")
	void  addCourseSchedule(CourseSchedule courseSchedule);

	@Select("select DISTINCT hpm.projectId,projectName from hr_project_management hpm left join teacher_project tp on hpm.projectId=tp.projectId " +
			" where tp.courseId=#{courseId} and tp.experimentalClassId=#{experimentalClassId}")
	@Results({
			@Result(id = true,column = "projectId",property = "projectId"),
			@Result(column = "projectName",property = "projectName"),
			@Result(column = "projectId",property = "courseLinks",many = @Many(select = "com.yipin.liuwanr.mapper.TeacherProjectAndCourseMapper.queryCourseLink"))
	})
	List<Project_Management> queryProjects(@Param("courseId") Integer  courseId,@Param("experimentalClassId")Integer experimentalClassId);


	@Select("select linkName,fileLink from hr_course_link where projectId=#{projectId} and isdel=0 GROUP BY linkId")
	List<CourseLink> queryCourseLink(Integer projectId);
}
