package com.yipin.liuwanr.mapper;

import com.yipin.liuwanr.entity.*;
import com.yipin.liuwanr.vo.UserInfoReceiveVo;
import org.apache.ibatis.annotations.*;

import java.util.List;
@Mapper
public interface UserInfoMapper {
    @Update({"<script>",
            "UPDATE lw_user SET",
            "<when test='mobile!=null'>", "mobile=#{mobile},", "</when>",
            "<when test='email!=null'>", "email=#{email},", "</when>",
            "<when test='nickname!=null'>", "nickname=#{nickname},", "</when>",
            "<when test='sex!=-1'>", "sex=#{sex},", "</when>",
            "<when test='sign!=null'>", "sign=#{sign},", "</when>",
            "<when test='birthday!=null'>", "birthday=#{birthday},", "</when>",
            "<when test='avatar!=null'>", "avatar=#{avatar},", "</when>",
            "<when test='country!=null'>", "country=#{country},", "</when>",
            "<when test='province!=null'>", "province=#{province},", "</when>",
            "<when test='city!=null'>", "city=#{city},", "</when>",
            "updatetime=now() WHERE uuid =#{uuid}",
            "</script>"})
    void update(User user);

    @Insert("INSERT INTO hr_user_info(userName,uniqueIdentificationAccount,documentType,IDNumber,provinceId,cityId,countries,dateBirth,educationDegree,schoolId,phone,weChatID,email,account,password,creationTime,logInNumber,sex,userAvatars,isdel,roleId,token)"
            + " VALUES(#{userName},#{uniqueIdentificationAccount},#{documentType},#{IDNumber},#{provinceId},#{cityId},#{countries},#{dateBirth},#{educationDegree},#{schoolId},#{phone},#{weChatID},#{email},#{account},#{password},now(),0,#{sex},#{userAvatars},0,#{roleId},#{token})")
    @Options(useGeneratedKeys = true, keyProperty = "userId", keyColumn = "userId")
    void addUser(UserInfo user);

    @Insert("INSERT INTO student(workNumber,schoolId,professionalId,gradeId,classId,professionalName,gradeName,className,userId,platformId,roleId,isdel)"
            + " VALUES(#{workNumber},#{schoolId},#{professionalId},#{gradeId},#{classId},#{professionalName},#{gradeName},#{className},#{userId},#{platformId},#{roleId},0)")
    void userAddStudent(Student student);

    @Insert("INSERT INTO staff(workNumber,schoolId,staffProfessionalArchitectureId,staffGradeId,staffProfessionalArchitectureName,staffGradeName,roleId,userId,platformId,isdel)"
            + " VALUES(#{workNumber},#{schoolId},#{staffProfessionalArchitectureId},#{staffGradeId},#{staffProfessionalArchitectureName},#{staffGradeName},#{roleId},#{userId},#{platformId},0)")
    void userAddStaff(Staff staff);

    @Select({"<script>",
            "SELECT u.userId,u.userName,s.schoolName,s.provinceId,s.cityId,s.provinceName,s.cityName,u.countries,u.creationTime,u.account,u.logInNumber,u.schoolId,u.roleId FROM hr_user_info u,school s WHERE u.schoolId = s.schoolId and u.isdel = 0",
            " <if test='countries!=null and countries !=\"\" '>and u.countries = #{countries} </if>",
            " <if test='provinceId!=null and provinceId !=\"\" '>and s.provinceId = #{provinceId} </if>",
            " <if test='schoolId!=null and schoolId !=\"\"'>and u.schoolId = #{schoolId} </if>",
            " <if test='cityId!=null and cityId !=\"\" '>and s.cityId = #{cityId} </if>",
            /*" <if test='roleId!=null and roleId !=\"\" '>and u.roleId  LIKE CONCAT('%',#{roleId},'%')</if>",*/
            " <if test='roleId!=null and roleId !=\"\" '>and FIND_IN_SET(#{roleId},u.roleId)</if>",
            " <if test='searchContent!=null and searchContent !=\"\" '>  AND CONCAT(u.userName, s.schoolName) LIKE CONCAT('%',#{searchContent},'%')</if>",
            " <if test='month==3'>and u.creationTime>DATE_SUB(CURDATE(), INTERVAL 3 MONTH)</if>",
            " <if test='month==6'>and u.creationTime>DATE_SUB(CURDATE(), INTERVAL 6 MONTH)</if>",
            " <if test='month==9'>and u.creationTime>DATE_SUB(CURDATE(), INTERVAL 9 MONTH)</if>",
            " <if test='month==12'>and u.creationTime>DATE_SUB(CURDATE(), INTERVAL 12 MONTH)</if>",
            " <if test='creationTime!=null and endTime!=null and endTime!=\"\" and creationTime!=\"\" '> and u.creationTime between #{creationTime} and #{endTime}</if>",
            "GROUP BY u.userId order by u.creationTime desc",
            "</script> "})
    List<UserInfo> queryUserInfo(UserInfo userInfo);

    @Update({"<script>",
            "UPDATE hr_user_info set isdel=1 where userId = #{userId}",
            "</script>"})
    void deleteUser(Integer userId);

    @Update({"<script>",
            "UPDATE staff set isdel=1 where userId = #{userId}",
            "</script>"})
    void deleteStaff(Integer userId);

    @Update({"<script>",
            "UPDATE staff set isdel=1 where userId = #{userId}",
            "</script>"})
    void deleteStudent(Integer userId);

    //修改用户
    @Update("UPDATE hr_user_info SET userName = #{userName},uniqueIdentificationAccount = #{uniqueIdentificationAccount},documentType = #{documentType},IDNumber = #{IDNumber},provinceId = #{provinceId},"
            + "cityId = #{cityId},countries = #{countries},dateBirth = #{dateBirth},educationDegree = #{educationDegree},schoolId = #{schoolId},"
            + "phone = #{phone},weChatID = #{weChatID},email = #{email},account = #{account},sex = #{sex},userAvatars = #{userAvatars} where userId = #{userId}")
    void updateUser(UserInfo user);

    //修改用户
    @Update("UPDATE hr_user_info SET roleId = #{roleId} where userId = #{userId}")
    void updateUserRoleId(Integer userId,String roleId);

    //修改个人档案添加功能(删除后添加用户个人档案)
    @Insert({"<script>",
            "INSERT INTO hr_personal_file(personalCareerId,schoolId,schoolName,disciplineId,disciplineName,professionalClassId,professionalClassName,professionalId,professionalName,userId,updatetime) values " +
                    "(#{personalCareerId},#{schoolId},#{schoolName},#{disciplineId},#{disciplineName},#{professionalClassId},#{professionalClassName},#{professionalId},#{professionalName},#{userId},now())",
            "</script>"})
    void updateUserProfiles(UserProfiles userProfiles);

    //修改个人档案删除功能
    @Delete({"<script>",
            "Delete from hr_personal_file where userId = #{userId}",
            "</script>"})
    void deleteUserProfiles(Integer userId);

    //修改用户组织关系添加功能
    @Insert({"<script>",
            "INSERT INTO hr_organization_relationship(userId,platformId,schoolId,schoolName,roleId,workNumber,oneDepartmentId,oneDepartmentName,twoDepartmentId,twoDepartmentName,professionalId,professionalName,gradeId,gradeName,classId,className,updatetime,customerId) " +
                    "VALUES(#{userId},#{platformId},#{schoolId},#{schoolName},#{roleId},#{workNumber},#{oneDepartmentId},#{oneDepartmentName},#{twoDepartmentId},#{twoDepartmentName},#{professionalId},#{professionalName},#{gradeId},#{gradeName},#{classId},#{className},now(),#{customerId})",
            "</script>"})
    void updateOrganizationRelationship(OrganizationRelationship organizationRelationship);

    //修改员工组织架构删除功能
    @Delete({"<script>",
            "Delete from staff where userId = #{userId} and platformId = #{platformId}",
            "</script>"})
    void deleteStaffOR(Integer userId, Integer platformId);

    //修改学生组织架构删除功能
    @Delete({"<script>",
            "Delete from student where userId = #{userId} and platformId = #{platformId}",
            "</script>"})
    void deleteStudentOR(Integer userId, Integer platformId);

    //修改员工
    @Update("UPDATE staff SET staffName = #{staffName},staffWorkNumber = #{staffWorkNumber},phone = #{phone},email = #{email},staffProfessionalArchitectureId = #{staffProfessionalArchitectureId},"
            + "staffProfessionalArchitectureId = #{staffProfessionalArchitectureId},staffGradeId = #{staffGradeId},roleId = #{roleId} where phone = #{phone}")
    void updateStaff(Staff staff);

    //修改学生
    @Update("UPDATE student SET studentName = #{studentName},studentNumber = #{studentNumber},phone = #{phone},email = #{email},roleId = #{roleId}"
            + ",schoolId = #{schoolId},professionalId = #{professionalId},gradeId = #{gradeId},classId = #{classId} where phone = #{phone}")
    void updateStudent(Student student);

    //登陆
    @Select("SELECT hui.token,hui.schoolId,hui.account,hui.cityId,hui.countries,hui.creationTime,hui.dateBirth,hui.documentType,hui.educationDegree,hui.email,hui.iDNumber,hui.logInNumber,hui.phone,hui.provinceId,hui.sex,hui.uniqueIdentificationAccount,hui.userAvatars,hui.userId,hui.userName,hui.weChatID from hr_user_info hui where hui.isdel=0 and hui.userId = #{userId} ")
    UserInfo logins(UserInfo userInfo);

    //登陆
    @Select({"<script> " +
            "SELECT token,userId,userName,roleId,userAvatars,password from hr_user_info where isdel=0" +
            "<if test='account!=null'>and account = #{account} </if>" +
            "<if test='phone!=null'>and phone = #{phone} </if>" +
            "<if test='email!=null'>and email = #{email} </if>" +
            "and password = #{password}" +
            "</script>"})
    UserInfo adminLogins(UserInfo userInfo);

    //登陆账号密码
    @Select({"<script> " +
            "SELECT hui.schoolId,hui.account,hui.cityId,hui.countries,hui.creationTime,hui.dateBirth,hui.documentType,hui.educationDegree,hui.email,hui.iDNumber,hui.logInNumber,hui.phone,hui.provinceId,hui.sex,hui.uniqueIdentificationAccount,hui.userAvatars,hui.userId,hui.userName,hui.weChatID,hui.password from hr_user_info hui where hui.isdel=0 " +
            "<if test='account!=null'>and account = #{account} </if>" +
            "<if test='phone!=null'>and phone = #{phone} </if>" +
            "<if test='email!=null'>and email = #{email} </if>" +
            "and password = #{password} " +
            "</script>"})
    UserInfo loginsAP(UserInfo userInfo);

    //查询用户角色
    @Select("SELECT userId,roleId from staff where userId = #{userId} and schoolId = #{schoolId}")
    List<Staff> loginStaffRole(Integer userId, Integer schoolId);

    //查询用户角色
    @Select("SELECT userId,roleId from student where userId = #{userId} and schoolId = #{schoolId}")
    List<Student> loginStudentRole(Integer userId, Integer schoolId);

    //登陆查询员工学校信息
    @Select("SELECT sta.schoolId,sch.schoolName,sta.userId from staff sta,school sch where sta.userId = #{userId} and sta.schoolId = sch.schoolId GROUP BY sta.schoolId")
    List<UserInfo> loginGetStaffSchool(Integer userId);

    //登陆查询学生学校信息
    @Select("SELECT stu.schoolId,sch.schoolName,stu.userId from student stu,school sch where stu.userId = #{userId} and stu.schoolId = sch.schoolId GROUP BY stu.schoolId")
    List<UserInfo> loginGetStudentSchool(Integer userId);

    //登陆查询员工学校信息/dianzikeda
    @Select("SELECT sta.schoolId,sch.schoolName,sta.userId from staff sta,school sch where sta.userId = #{userId} and sta.schoolId = sch.schoolId and sch.schoolId=#{schoolId} GROUP BY sta.schoolId")
    List<UserInfo> loginsGetStaffSchoolInfo(Integer userId,Integer schoolId);

    //登陆查询学生学校信息/dianzikeda
    @Select("SELECT stu.schoolId,sch.schoolName,stu.userId,stu.studentId from student stu,school sch where stu.userId = #{userId} and stu.schoolId = sch.schoolId and stu.schoolId=#{schoolId}")
    List<UserInfoReceiveVo> loginsGetStudentSchoolInfo(Integer userId, Integer schoolId);

    //查询用户员工组织关系
    @Select("SELECT * from staff where userId = #{userId} and roleId = #{roleId} and schoolId = #{schoolId}")
    List<Staff> queryStaffAll(Integer userId, String roleId, Integer schoolId);

    //查询用户学生组织关系
    @Select("SELECT * from student where userId = #{userId} and roleId = #{roleId} and schoolId = #{schoolId}")
    List<Student> queryStudentAll(Integer userId, String roleId, Integer schoolId);
//    //查询用户绑定平台信息
//    @Select("SELECT hp.* FROM hr_platform hp,hr_organization_relationship hor WHERE hor.platformId = hp.platformId and hor.userId = #{userId} and hor.isdel = 0 GROUP BY platformId")
//    List<Platform> queryUserPlatform(Integer userId);

    //查询用户绑定学生的平台信息
    @Select("SELECT hp.* FROM hr_platform hp,student stu WHERE stu.platformId = hp.platformId and stu.userId = #{userId} and stu.isdel = 0 GROUP BY platformId")
    List<Platform> queryUserPlatformStudent(Integer userId);

    //查询用户绑定员工的平台信息
    @Select("SELECT hp.* FROM hr_platform hp,staff sta WHERE sta.platformId = hp.platformId and sta.userId = #{userId} and sta.isdel = 0 GROUP BY platformId")
    List<Platform> queryUserPlatformStaff(Integer userId);

    //查询用户手机
    @Select("SELECT userId,phone from hr_user_info  where isdel=0 and phone = #{phone}")
    List<UserInfo> queryPhone(String phone);

    //查询用户详情
    @Select({"<script>",
            "SELECT * from hr_user_info where isdel = 0 and userId = #{userId}",
            "</script> "})
    UserInfo queryUserInfoDetails(Integer userId);

    //查询用户详情
    @Select({"<script>",
            "SELECT * from hr_personal_file where userId = #{userId}",
            "</script> "})
    List<UserProfiles> queryUserProfiles(Integer userId);

    //查询用户组织架构详情
    @Select({"<script>",
            "SELECT * from hr_organization_relationship where userId = #{userId} and platformId = #{platformId}",
            "</script> "})
    List<OrganizationRelationship> queryUserOR(Integer userId, Integer platformId);

    //查询员工组织架构详情
    @Select({"<script>",
            "SELECT sta.*,sch.schoolName from staff sta,school sch where sta.userId = #{userId} and sta.platformId = #{platformId} and sta.schoolId = sch.schoolId",
            "</script> "})
    List<Staff> queryStaffOR(Integer userId, Integer platformId);

    //查询学生组织架构详情
    @Select({"<script>",
            "SELECT stu.*,sch.schoolName from student stu,school sch where stu.userId = #{userId} and stu.platformId = #{platformId} and stu.schoolId = sch.schoolId",
            "</script> "})
    List<Student> queryStudentOR(Integer userId, Integer platformId);

    //查询用户组织架构详情
    @Select({"<script>",
            "SELECT * from hr_organization_relationship where userId = #{userId}",
            "</script> "})
    List<OrganizationRelationship> queryUserIdOR(Integer userId);

    //查询用户员工详情
    @Select({"<script>",
            "SELECT * from staff where userId = #{userId}",
            "</script> "})
    List<Staff> queryUserStaff(Integer userId);

    //查询用户学生详情
    @Select({"<script>",
            "SELECT * from student where userId = #{userId}",
            "</script> "})
    List<Student> queryUserStudent(Integer userId);

    //模糊查询客户
    @Select({"<script>",
            "SELECT customerId,customerName,schoolId FROM customer where isdel = 0",
            " <if test='searchContent!=null and searchContent !=\"\" '>and customerName like CONCAT('%',#{searchContent},'%')</if>",
            " <if test='customerIds!=null'>"
                    + "<foreach collection='customerIds' item='customerIds' open='and schoolId not in (' separator=',' close=')'> #{customerIds}"
                    + "</foreach>"
                    + "</if>",
            "</script> "})
    List<Customer> queryCustomer(@Param("searchContent") String searchContent, @Param("customerIds") List<Integer> customerIds);

    /**
     * 批量插入用户
     *
     * @param users
     */
    @Insert({
            "<script>",
            "insert into user(name, password,accountRole,workNumber,phone,uniqueIdentificationAccount,creationTime,isdel) values ",
            "<foreach collection='users' item='user' index='index' separator=','>",
            "(#{user.name}, #{user.password}, #{user.accountRole}, #{user.workNumber} ,#{user.phone},#{user.uniqueIdentificationAccount},now(),0)",
            "</foreach>",
            "</script>"
    })
    void addUserM(@Param("users") List<UserM> users);

    //修改用户头像
    @Update("update hr_user_info set userAvatars=#{userAvatars} where userId=#{userId}")
    void updateUserAvatars(@Param("userAvatars") String userAvatars, @Param("userId") Integer userId);

    //更新用户登录次数和最后一次登录时间
    @Update({"UPDATE hr_user_info SET logInNumber=logInNumber+1, lastLoginTime=now() WHERE userId=#{userId}"})
    void updateLogInNumber(UserInfo user);

    //更新学生登录次数和最后一次登录时间
    @Update({"UPDATE student SET logInNumber=logInNumber+1, lastLoginTime=now() WHERE userId=#{userId}"})
    void updateStudentLogInNumber(UserInfo user);

    //更新员工登录次数和最后一次登录时间
    @Update({"UPDATE staff SET loginNumber=loginNumber+1, lastLoginTime=now() WHERE userId=#{userId}"})
    void updateStaffLogInNumber(UserInfo user);

    //查询账号是否存在
    @Select("SELECT account,email,userName,userId,uniqueIdentificationAccount,phone,roleId from hr_user_info where isdel = 0 and account = #{account}")
    List<UserInfo> queryAccountIsExist(String account);

    //查询账号是否存在
    @Select("SELECT hor.* from hr_organization_relationship hor,hr_user_info hui where hor.isdel = 0 and hui.account = #{account} and hor.userId = hui.userId and hor.schoolId = #{schoolId}")
    List<OrganizationRelationship> queryAccountIsExistOR(String account, Integer schoolId);

    //查询员工学号、工号是否存在
    @Select("SELECT userId,workNumber,schoolId,roleId from staff where workNumber = #{workNumber} and roleId = #{roleId} and schoolId = #{schoolId} and isdel=0")
    List<Staff> queryStaffWorkNumberIsExist(String workNumber, Integer roleId, Integer schoolId);

    //查询学生学号、工号是否存在
    @Select("SELECT userId,workNumber,schoolId,roleId from student where workNumber = #{workNumber} and roleId = #{roleId} and schoolId = #{schoolId} and isdel=0")
    List<Student> queryStudentWorkNumberIsExist(String workNumber, Integer roleId, Integer schoolId);

    //查询平台
    @Select("SELECT platformId,platformName,domainName,createTime from hr_platform where FIND_IN_SET (platformId,#{platformId})")
    List<Platform> queryPlatform(String platformId);

    //查询学生
    @Select("SELECT * from student where platformId = #{platformId} and userId = #{userId} and isdel=0")
    List<Student> queryStudent1(Integer platformId, Integer userId);

    //查询员工
    @Select("SELECT * from staff where platformId = #{platformId} and userId = #{userId} and isdel=0")
    List<Staff> queryStaff(Integer platformId, Integer userId);

    //删除平台
    @Update("Update hr_organization_relationship set isdel = 1  where platformId = #{platformId} and userId = #{userId}")
    void deletePlatform(Integer platformId, Integer userId);

    //========全承珠
    @Select("select userId,password,accountRole,logInNumber,workNumber,phone,uniqueIdentificationAccount,schoolId from user "
            + " where isdel=0 and password=#{password} and  (phone=#{userAccount}  or workNumber=#{userAccount} or uniqueIdentificationAccount=#{userAccount})")
    UserM loginsQ(@Param("userAccount") String userAccount, @Param("password") String password);


    @Update("update user set lastTimeOfLanding=#{time},logInNumber=#{logInNumber}  where userId=#{userId}")
    void updateUserQ(@Param("time") String time, @Param("logInNumber") Integer logInNumber, @Param("userId") Integer userId);

    /**
     * 批量插入个人档案
     */
    @Insert({
            "<script>",
            "insert into hr_personal_file(personalCareerId,schoolId,disciplineId,professionalClassId,professionalId,userId,schoolName,disciplineName,professionalClassName,professionalName) values ",
            "(#{personalCareerId}, #{schoolId}, #{disciplineId}, #{professionalClassId} ,#{professionalId},#{userId},#{schoolName},#{disciplineName},#{professionalClassName},#{professionalName})",
            "</script>"
    })
    void addPersonalFile(UserProfiles userProfiles);

    //添加用户组织关系
    @Insert({"<script>",
            "INSERT INTO hr_organization_relationship(userId,platformId,schoolId,schoolName,roleId,workNumber,oneDepartmentId,oneDepartmentName,twoDepartmentId,twoDepartmentName,professionalId,professionalName,gradeId,gradeName,classId,className,updatetime,customerId,creationTime) " +
                    "VALUES(#{userId},#{platformId},#{schoolId},#{schoolName},#{roleId},#{workNumber},#{oneDepartmentId},#{oneDepartmentName},#{twoDepartmentId},#{twoDepartmentName},#{professionalId},#{professionalName},#{gradeId},#{gradeName},#{classId},#{className},now(),#{customerId},now())",
            "</script>"})
    void addOrganizationRelationship(OrganizationRelationship organizationRelationship);

    //删除用户组织架构关系
    @Update({"<script>",
            "UPDATE hr_organization_relationship set isdel=1 where userId = #{userId}",
            "</script>"})
    void deleteOrganizationRelationship(Integer userId);

    @Select({"<script> " +
            "SELECT disableAccount FROM hr_user_info u LEFT JOIN student s ON u.userId = s.userId  " +
            "WHERE  s.schoolId = #{schoolId} " +
            "<if test='account!=null'> AND account = #{account} </if> " +
            "<if test='phone!=null'> AND phone = #{phone} </if>" +
            "<if test='email!=null'> AND email = #{email} </if>" +
            "AND u.isdel = 0 AND s.isdel = 0" +
            "</script>"})
    Integer queryDisableAccount(UserInfo userInfo);

    @Select("select roleId from hr_user_info where userId = #{userId}")
    UserInfo queryUser(UserInfo user);

    @Select("select * from hr_user_info where FIND_IN_SET(1,roleId) OR FIND_IN_SET(13,roleId)")
    List<Integer> queryUserIds();
}