package com.yipin.liuwanr.service;

import com.yipin.liuwanr.mapper.AssesmentRecordMapper;
import com.yipin.liuwanr.vo.AssesmentRecordVo;
import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;

@Service
/**
 * 考核记录
 * @author 或然
 *
 */
public class AssesmentRecordService {

    private static Logger logger = Logger.getLogger(AssesmentRecordService.class);

    @Autowired
    private AssesmentRecordMapper mapper;


    /**
     * 根据课程id查询学生信息
     *
     * @param studentId
     * @param courseId
     * @return
     */
    public HashMap<String, Object> queryStudentAssessment(Integer studentId, Integer courseId) {
        HashMap<String, Object> resp = new HashMap<String, Object>();
        AssesmentRecordVo vo = null;
        try {
            if (studentId != null && courseId != null) {
                vo = mapper.getByStudentId(studentId, courseId);//学生信息
                Integer schoolHeight = mapper.getBySchool(courseId, studentId);//学校最高平均分
                if (schoolHeight != null) {
                    vo.setSchoolheightscore(schoolHeight);
                } else {
                    vo.setSchoolheightscore(0);
                }
                AssesmentRecordVo vo1 = mapper.getByCountry(courseId);//全国信息
                if (vo1 != null) {
                    vo.setCountryavgscore(vo1.getCountryavgscore());
                    vo.setCountryheightscore(vo1.getCountryheightscore());
                } else {
                    vo.setCountryavgscore(0.0);
                    vo.setCountryheightscore(0.0);
                }
            }
            resp.put("retvalue", vo);
            resp.put("retcode", 200);
        } catch (RuntimeException e) {
            logger.error(e.getMessage());
            System.out.println(e.getMessage());
            resp.put("retcode", 500);
            resp.put("retvalue", "考核记录信息查询失败");
            return resp;
        }
        return resp;
    }


}
