package com.yipin.liuwanr.service;

import java.util.HashMap;

import com.yipin.liuwanr.entity.StudentCity;
import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yipin.liuwanr.mapper.CityMapper;

@Service
public class CityService {
	
	private static Logger logger = Logger.getLogger(CityService.class);
	
	@Autowired
	private CityMapper cityMapper;

	public HashMap<String, Object> addCity(StudentCity studentCity){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			cityMapper.addCity(studentCity);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			System.out.println(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryCity(Integer provinceId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", cityMapper.queryCity(provinceId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> deleteCity(Integer cityId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			cityMapper.deleteCity(cityId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateCity(StudentCity studentCity){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			cityMapper.updateCity(studentCity);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
}
