package com.yipin.liuwanr.service;

import com.yipin.liuwanr.entity.OrganizationRelationship;
import com.yipin.liuwanr.entity.Student;
import com.yipin.liuwanr.mapper.OrganizationRelationshipMapper;
import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

@Service("organizationRelationshipService")
public class OrganizationRelationshipService {

    @Autowired
    private OrganizationRelationshipMapper organizationRelationshipMapper;

    private static Logger logger = Logger.getLogger(OrganizationRelationshipService.class);


    public HashMap<String, Object> getByuserId(Integer userId) {
        HashMap<String, Object> resp = new HashMap<String, Object>();
        try {
            List<OrganizationRelationship> relationships = organizationRelationshipMapper.getByuserId(userId);
            resp.put("retcode", 200);
            resp.put("retvalue", relationships);
        } catch (Exception e) {
            logger.error(e.getMessage());
            resp.put("retcode", 500);
            resp.put("retvalue", "Inquiry Failed");
            return resp;
        }
        return resp;
    }

    public HashMap<String, Object> deleteByorganizationRelationshipId(Integer organizationRelationshipId) {
        HashMap<String, Object> resp = new HashMap<String, Object>();
        try {
            boolean result = organizationRelationshipMapper.deleteByorganizationRelationshipId(organizationRelationshipId);
            resp.put("retcode", 200);
            resp.put("retvalue", result);
        } catch (Exception e) {
            logger.error(e.getMessage());
            resp.put("retcode", 500);
            resp.put("retvalue", "DELATE Failed");
            return resp;
        }
        return resp;
    }

}
