package com.yipin.liuwanr.service;

import java.util.HashMap;

import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yipin.liuwanr.entity.PersonalCenter;
import com.yipin.liuwanr.mapper.PersonalCenterMapper;

@Service
public class PersonalCenterService {
	
	private static Logger logger = Logger.getLogger(PersonalCenterService.class);
	
	@Autowired
	private PersonalCenterMapper personalCenterMapper;
	
	public HashMap<String, Object> queryPersonalCenter(PersonalCenter personalCenter){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", personalCenterMapper.queryPersonalCenter(personalCenter));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	public HashMap<String, Object> queryPersonalCenterTeacher(PersonalCenter personalCenter){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", personalCenterMapper.queryPersonalCenterTeacher(personalCenter));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}

}
