package com.yipin.liuwanr.service;

import java.util.HashMap;

import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yipin.liuwanr.entity.Province;
import com.yipin.liuwanr.mapper.ProvinceMapper;

@Service
public class ProvinceService {
	
	private static Logger logger = Logger.getLogger(ProvinceService.class);
	
	@Autowired
	private ProvinceMapper provinceMapper;

	public HashMap<String, Object> addProvince(Province province){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			provinceMapper.addProvince(province);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryProvince(Province province){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", provinceMapper.queryProvince(province));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> deleteProvince(Integer provinceId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			provinceMapper.deleteProvince(provinceId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateProvince(Province province){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			provinceMapper.updateProvince(province);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
}
