package com.yipin.liuwanr.service;

import java.util.HashMap;

import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yipin.liuwanr.entity.School;
import com.yipin.liuwanr.mapper.SchoolMapper;

@Service
public class SchoolService {
	
	private static Logger logger = Logger.getLogger(SchoolService.class);
	
	@Autowired
	private SchoolMapper SchoolMapper;

	public HashMap<String, Object> addSchool(School school){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			SchoolMapper.addSchool(school);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> querySchool(School school){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", SchoolMapper.querySchool(school));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> querySchoolDetails(Integer schoolId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", SchoolMapper.querySchoolDetails(schoolId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> deleteSchool(School school){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			SchoolMapper.deleteSchool(school);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateSchool(School school){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			SchoolMapper.updateSchool(school);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
}
