package com.yipin.liuwanr.service;

import java.util.HashMap;
import java.util.List;

import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yipin.liuwanr.entity.StaffGrade;
import com.yipin.liuwanr.mapper.StaffGradeMapper;

@Service
public class StaffGradeService {
	
	private static Logger logger = Logger.getLogger(StaffGradeService.class);
	
	@Autowired
	private StaffGradeMapper staffGradeMapper;

	public HashMap<String, Object> addStaffGrade(StaffGrade staffGrade){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			staffGradeMapper.addStaffGrade(staffGrade);
			Integer staffGradeId = staffGrade.getStaffGradeId();
			resp.put("retvalue", staffGradeId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStaffGrade(Integer staffProfessionalArchitectureId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", staffGradeMapper.queryStaffGrade(staffProfessionalArchitectureId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> deleteStaffGrade(List<Integer> userIds){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			staffGradeMapper.deleteStaffGrade(userIds);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}

	public HashMap<String, Object> deleteStaffGradePs(Integer staffGradeId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			staffGradeMapper.deleteStaffGradePs(staffGradeId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStaffGradeDetails(Integer staffGradeId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", staffGradeMapper.queryStaffGradeDetails(staffGradeId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());			
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateStaffGrade(StaffGrade staffGrade){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			staffGradeMapper.updateStaffGrade(staffGrade);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}

	public List<Integer> queryUserIdsByGradeId(Integer staffGradeId) {
		return staffGradeMapper.queryUserIdsByGradeId(staffGradeId);
	}
}
