package com.yipin.liuwanr.service;

import java.util.HashMap;
import java.util.List;

import com.yipin.liuwanr.mapper.StaffGradeMapper;
import com.yipin.liuwanr.mapper.StaffMapper;
import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yipin.liuwanr.entity.StaffProfessionalArchitecture;
import com.yipin.liuwanr.mapper.StaffProfessionalArchitectureMapper;

@Service
public class StaffProfessionalArchitectureService {
	
	private static Logger logger = Logger.getLogger(StaffProfessionalArchitectureService.class);
	
	@Autowired
	private StaffProfessionalArchitectureMapper staffProfessionalArchitectureMapper;

	@Autowired
	private StaffGradeMapper staffGradeMapper;
	@Autowired
	private StaffMapper staffMapper;

	public HashMap<String, Object> addStaffProfessionalArchitecture(StaffProfessionalArchitecture staffProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			staffProfessionalArchitectureMapper.addStaffProfessionalArchitecture(staffProfessionalArchitecture);
			Integer staffProfessionalArchitectureId = staffProfessionalArchitecture.getStaffProfessionalArchitectureId();
			resp.put("retvalue", staffProfessionalArchitectureId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryAllStaffProfessionalArchitecture(Integer schoolId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue",staffProfessionalArchitectureMapper.queryAllStaffProfessionalArchitecture(schoolId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStaffProfessionalArchitecture(Integer schoolId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", staffProfessionalArchitectureMapper.queryStaffProfessionalArchitecture(schoolId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}

	public HashMap<String, Object> queryStaffPAN(String name,Integer schoolId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", staffProfessionalArchitectureMapper.queryStaffPAN(name,schoolId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> deleteStaffProfessionalArchitecture(Integer staffProfessionalArchitectureId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			//删除员工专业一级组织架构
			staffProfessionalArchitectureMapper.deleteStaffProfessionalArchitecture(staffProfessionalArchitectureId);
			//根据一级架构id删除staff_grade表中二级组织架构（假删）
			staffGradeMapper.delStaffGradeByArchId(staffProfessionalArchitectureId);
			//根据staffProfessionalArchitectureId查询staff表中的userId，然后调用批量删除员工信息接口
			List<Integer> userIds =staffMapper.queryUserIdsByArchId(staffProfessionalArchitectureId);
			if(userIds.size()>0){//说明年级架构下面存在用户
				staffGradeMapper.deleteStaffGrade(userIds);
				staffGradeMapper.deleteStaffArch(staffProfessionalArchitectureId);
			}else{//如果组织架构下面没有员工，则只删除组织架构
				staffGradeMapper.deleteStaffArch(staffProfessionalArchitectureId);
			}

			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateStaffProfessionalArchitecture(StaffProfessionalArchitecture staffProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			staffProfessionalArchitectureMapper.updateStaffProfessionalArchitecture(staffProfessionalArchitecture);
			staffProfessionalArchitectureMapper.updateStaffArchitectureName();
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
}
