package com.yipin.liuwanr.service;

import java.util.HashMap;

import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yipin.liuwanr.entity.StuProfessionalArchitecture;
import com.yipin.liuwanr.mapper.StuProfessionalArchitectureMapper;

@Service
public class StuProfessionalArchitectureService {
	
	private static Logger logger = Logger.getLogger(StuProfessionalArchitectureService.class);
	
	@Autowired
	private StuProfessionalArchitectureMapper professionalArchitectureMapper;

	public HashMap<String, Object> addStuProfessionalArchitecture(StuProfessionalArchitecture stuProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.addStuProfessionalArchitecture(stuProfessionalArchitecture);
			Integer stuProfessionalArchitectureId = stuProfessionalArchitecture.getStuProfessionalArchitectureId();
			resp.put("retvalue", stuProfessionalArchitectureId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStuProfessionalArchitecture(Integer schoolId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStuProfessionalArchitecture(schoolId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStuPAD(Integer stuProfessionalArchitectureId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStuPAD(stuProfessionalArchitectureId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	//删除学生专业
	public HashMap<String, Object> deleteStuProfessionalArchitecture(Integer stuProfessionalArchitectureId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.deleteStuProfessionalArchitecture(stuProfessionalArchitectureId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	//删除学生年级
	public HashMap<String, Object> deleteStuGrade(Integer gradeId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.deleteStuGrade(gradeId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	//删除学生班级
	public HashMap<String, Object> deleteStuClass(Integer classId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.deleteStuClass(classId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateStuProfessionalArchitecture(StuProfessionalArchitecture stuProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.updateStuProfessionalArchitecture(stuProfessionalArchitecture);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStudentProfessionalArchitecture(Integer schoolId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStudentProfessionalArchitecture(schoolId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStuGrade(Integer stuProfessionalArchitectureId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStuGrade(stuProfessionalArchitectureId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStuGradeD(Integer gradeId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStuGradeD(gradeId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStuClass(Integer gradeId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStuClass(gradeId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStuClassD(Integer classId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStuClassD(classId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> addStuClass(StuProfessionalArchitecture stuProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.addStuClass(stuProfessionalArchitecture);
			Integer classId = stuProfessionalArchitecture.getClassId();
			resp.put("retvalue", classId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateStuClass(StuProfessionalArchitecture stuProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.updateStuClass(stuProfessionalArchitecture);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> addStuGrade(StuProfessionalArchitecture stuProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.addStuGrade(stuProfessionalArchitecture);
			Integer gradeId = stuProfessionalArchitecture.getGradeId();
			resp.put("retvalue", gradeId);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> updateStuGrade(StuProfessionalArchitecture stuProfessionalArchitecture){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			professionalArchitectureMapper.updateStuGrade(stuProfessionalArchitecture);
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
	
	public HashMap<String, Object> queryStudent(Integer classId){
		HashMap<String, Object> resp = new HashMap<String, Object>();
		try {
			resp.put("retvalue", professionalArchitectureMapper.queryStudent(classId));
			resp.put("retcode", 200);
		} catch (RuntimeException e) {
			logger.error(e.getMessage());
			resp.put("retcode", 500);
			resp.put("retvalue", "Inquiry Failed");
			return resp;
		}
		return resp;
	}
}
