package com.yipin.liuwanr.tcpserver;

import java.util.HashMap;

import org.apache.mina.core.session.IoSession;
import org.jboss.logging.Logger;

public class MinaSessionManager {

	private static Logger logger = Logger.getLogger(MinaSessionManager.class);
	
	private static HashMap<String, IoSession> sessionMap = new HashMap<String, IoSession>();
	
	public static IoSession getSessionByDevice(String duid){
		return sessionMap.get(duid);
	}
	
	public static boolean isDeviceOnline(String duid){
		return sessionMap.containsKey(duid);
	}
	
	public static void setSessionForDevice(String duid, IoSession session){
		logger.info("Device[" + duid + "] online");
		sessionMap.put(duid, session);
		session.setAttribute("ID",duid);
	}
	
	public static void removeSessionByDevice(String duid){
		logger.info("Device[" + duid + "] offline");
		sessionMap.remove(duid);
	}
	
	public static void removeSession(IoSession sess){
		sessionMap.remove(sess);
	}
}
