package com.yipin.liuwanr.util;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import javax.servlet.http.HttpServletRequest;

@Component
public class UserIdUtils {
    @Autowired
    StringRedisTemplate redisTemplate;
    @Autowired
    HttpServletRequest request;
    public Integer getUserIdByToken(){
        String token = request.getHeader("token");
        if (StringUtils.isEmpty(token)){
            return 0;
        }
        ValueOperations<String, String> ops = redisTemplate.opsForValue();
        Object loginStatus = ops.get(token);
        if (StringUtils.isEmpty(loginStatus)){
            return 0;
        }else {
            String userId = request.getHeader("userId");
            if (!StringUtils.isEmpty(userId)){
                return Integer.parseInt(userId);
            }else {
                return Integer.parseInt(loginStatus.toString());
            }
        }
    }
}
