package com.yipin.liuwanr;

import com.yipin.liuwanr.entity.StudentCity;
import com.yipin.liuwanr.mapper.CityMapper;
import com.yipin.liuwanr.service.CityService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;

@RunWith(SpringRunner.class)
@SpringBootTest
public class CityServiceTest {

    @Autowired
    private CityService cityService;

    @Autowired
    private CityMapper cityMapper;

    /**
     * 新增城市信息方法测试
     */
    /*@Test
    @Transactional
    public void testAddCity() {
        StudentCity city = new StudentCity();
        city.setCityName("hhhh");
        city.setProvinceId(2);
        HashMap<String, Object> map = cityService.addCity(city);
        map.forEach((key, value) -> System.out.println("key = " + key + "  ===>  value = " + value));
    }*/

    /**
     * 查询城市信息方法测试
     */
    @Test
    public void testQueryCity() {
        HashMap<String, Object> map = cityService.queryCity(1);
        Integer retcode = (Integer) map.get("retcode");
        System.out.println(retcode);
        if (retcode == 200) {
            List<StudentCity> cities = (List<StudentCity>) map.get("retvalue");
            cities.forEach(item -> {
                System.out.println(item.toString());
            });
        } else {
            String msg = (String) map.get("retvalue");
            System.out.println(msg);
        }
    }

    /**
     * 删除城市信息方法测试
     */
    @Test
    @Transactional
    public void testDeleteCity() {
        HashMap<String, Object> map = cityService.deleteCity(1);
        map.forEach((key, value) -> System.out.println("key = " + key + "  ===>  value = " + value.toString()));
    }

    /**
     * 删除城市信息方法测试
     */
    @Test
    @Transactional
    public void testUpdateCity() {
        StudentCity studentCity = new StudentCity();
        studentCity.setCityId(1);
        studentCity.setCityName("hhhh");
        studentCity.setProvinceId(2);
        HashMap<String, Object> map = cityService.updateCity(studentCity);
        map.forEach((key, value) -> System.out.println("key = " + key + "  ===>  value = " + value.toString()));
    }
}
