package com.yipin.liuwanr;

import com.yipin.liuwanr.entity.PageResult;
import com.yipin.liuwanr.entity.ServiceConfig;
import com.yipin.liuwanr.service.ServiceConfigService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;

@RunWith(SpringRunner.class)
@SpringBootTest
public class ServiceConfigServiceTest {
    @Autowired
    private ServiceConfigService serviceConfigService;

    @Test
    @Transactional
    public void addServiceConfig() {
        ServiceConfig serviceConfig = new ServiceConfig();
        serviceConfig.setSystemName("测试");
        serviceConfig.setSystemType(2);
        serviceConfig.setSystemAttribution(2);
        serviceConfig.setSystemStatus(1);
        HashMap<String, Object> map = serviceConfigService.addServiceConfig(serviceConfig);
        map.forEach((key, value) -> System.out.println("key = " + key + "  ===>  value = " + value.toString()));
    }

    @Test
    public void queryServiceConfig() {
        ServiceConfig serviceConfig = new ServiceConfig();
        Integer pageNo = 1;
        Integer pageSize = 10;
        HashMap<String, Object> map = serviceConfigService.queryServiceConfig(serviceConfig, pageNo, pageSize);
        Integer retcode = (Integer) map.get("retcode");
        System.out.println(retcode);
        if (retcode == 200) {
            PageResult pageResult = (PageResult) map.get("retvalue");
            Long total = pageResult.getTotal();
            System.out.println("total = " + total);
            List<ServiceConfig> rows = (List<ServiceConfig>) pageResult.getRows();
            rows.forEach(item -> System.out.println(item.toString()));
        } else {
            String msg = (String) map.get("retvalue");
            System.out.println(msg);
        }
    }

    @Test
    public void queryServiceConfigDetails() {
        Integer systemId = 1;
        HashMap<String, Object> map = serviceConfigService.queryServiceConfigDetails(systemId);
        map.forEach((key, value) -> System.out.println("key = " + key + "  ===>  value = " + value.toString()));
    }

    @Test
    @Transactional
    public void deleteServiceConfig() {
        ServiceConfig serviceConfig = new ServiceConfig();
        serviceConfig.setSystemId(1);
        HashMap<String, Object> map = serviceConfigService.deleteServiceConfig(serviceConfig);
        map.forEach((key, value) -> System.out.println("key = " + key + "  ===>  value = " + value.toString()));
    }

    @Test
    @Transactional
    public void updateServiceConfig() {
        ServiceConfig serviceConfig = new ServiceConfig();
        serviceConfig.setSystemName("测试");
        serviceConfig.setSystemType(2);
        serviceConfig.setSystemAttribution(2);
        serviceConfig.setSystemStatus(1);
        serviceConfig.setSystemId(1);
        HashMap<String, Object> map = serviceConfigService.updateServiceConfig(serviceConfig);
        map.forEach((key, value) -> System.out.println("key = " + key + "  ===>  value = " + value.toString()));
    }

}
