package com.yipin.liuwanr.service;

import com.yipin.liuwanr.entity.Assesment;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * @auther River
 * @date 2020/8/11 15:44
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class AssesmentServiceTest {

    @Autowired
    private AssesmentService assesmentService;

    /**
     * 考核管理列表
     */
    @Test
    @Transactional
    public void queryAssesmentConditionTest(){
        Assesment assesment = new Assesment();
        assesment.setStaffId(123);
        assesment.setCourseId(77);
        Integer pageNO = 1;
        Integer pageSize = 10;
        HashMap<String, Object> condition = assesmentService.queryAssesmentCondition(assesment, pageNO, pageSize);
        for (String s : condition.keySet()) {
            System.out.println("key:" + s + "," + "value:" + condition.get(s));
        }
    }

    /**
     * 新建考核管理
     */
    @Test
    @Transactional
    public void addAssesmentTest(){
        Assesment assesment = new Assesment();
        assesment.setAssesmentName("新建考核测试");
        assesment.setClassId("14");
        assesment.setCourseId(77);
        assesment.setExperimentId(334);
        assesment.setReleaseType(0);
        assesment.setStaffId(123);
        assesment.setTimesum("3600000");
        List<Integer> studentIds = new ArrayList<>();
        studentIds.add(67);
        HashMap<String, Object> assesment1 = assesmentService.addAssesment(assesment, studentIds);
        for (String s : assesment1.keySet()) {
            System.out.println("key:" + s + "," + "value:" + assesment1.get(s));
        }
    }

    /**
     * 查询选中的学生有哪些正在参与考核
     */
    @Test
    @Transactional
    public void queryStudentisAssessTest(){
        List<Integer> studentIds = new ArrayList<>();
        studentIds.add(67);
        studentIds.add(65);
        HashMap<String, Object> student = assesmentService.queryStudentisAssess(studentIds);
        for (String s : student.keySet()) {
            System.out.println("key:" + s + "," + "value:" + student.get(s));
        }
    }

    /**
     * 根据id查询考核的信息
     */
    @Test
    @Transactional
    public void queryGetByIdTest(){
        Integer id = 78;
        HashMap<String, Object> assesment = assesmentService.queryGetById(id);
        for (String s : assesment.keySet()) {
            System.out.println("key:" + s + "," + "value:" + assesment.get(s));
        }
    }

    /**
     * 修改考核管理
     */
    @Test
    @Transactional
    public void updateAssesmentTest(){
        Assesment assesment = new Assesment();
        List<Integer> studentIds = new ArrayList<>();
        assesment.setAssesmentName("新建考核测试");
        assesment.setClassId("14");
        assesment.setCourseId(77);
        assesment.setExperimentId(334);
        assesment.setReleaseType(0);
        assesment.setStaffId(123);
        assesment.setTimesum("3600000");
        studentIds.add(67);
        HashMap<String, Object> assesment1 = assesmentService.updateAssesment(assesment, studentIds);
        for (String s : assesment1.keySet()) {
            System.out.println("key:" + s + "," + "value:" + assesment1.get(s));
        }
    }

    /**
     * 启动考核前的判断
     */
    @Test
    @Transactional
    public void assessmentJudgmentTest(){
        Integer assesmentId = 78;
        HashMap<String, Object> assessmentJudgment = assesmentService.assessmentJudgment(assesmentId);
        for (String s : assessmentJudgment.keySet()) {
            System.out.println("key:" + s + "," + "value:" + assessmentJudgment.get(s));
        }
    }

    /**
     * 修改考核状态
     */
    @Test
    @Transactional
    public void updateStateTest(){
        Assesment assesment = new Assesment();
        assesment.setId(79);
        assesment.setAssesmentState(2);
        assesment.setReleaseType(0);
        assesment.setEndTime("1597214647000");
        assesment.setTimesum("17167000");
        HashMap<String, Object> state = assesmentService.updateState(assesment);
        for (String s : state.keySet()) {
            System.out.println("key:" + s + "," + "value:" + state.get(s));
        }
    }

    /**
     * 查询实验班级一级栏目
     * 查询实验班级名称，以及班级一下的学生
     */
    @Test
    @Transactional
    public void queryCretionTimeTest(){
        Integer staffId = 2043;
        Integer schoolId = 123;
        String cretionTime = null;
        HashMap<String, Object> cretionTime1 = assesmentService.queryCretionTime(staffId, schoolId);
        for (String s : cretionTime1.keySet()) {
            System.out.println("key:" + s + "," + "value:" + cretionTime1.get(s));
        }
        HashMap<String, Object> cretionTime2 = assesmentService.queryCretionTime(cretionTime, staffId, schoolId);
        for (String s : cretionTime1.keySet()) {
            System.out.println("key:" + s + "," + "value:" + cretionTime2.get(s));
        }
    }

    /**
     * 考核信息展示
     */
    @Test
    @Transactional
    public void queryAssesmentTest(){
        Integer assesmentId = 79;
        HashMap<String, Object> assesment = assesmentService.queryAssesment(assesmentId);
        for (String s : assesment.keySet()) {
            System.out.println("key:" + s + "," + "value:" + assesment.get(s));
        }
    }

    /**
     * 班级筛选
     */
    @Test
    @Transactional
    public void getByclassTest(){
        Integer assesmentId = 78;
        HashMap<String, Object> byclass = assesmentService.getByclass(assesmentId);
        for (String s : byclass.keySet()) {
            System.out.println("key:" + s + "," + "value:" + byclass.get(s));
        }
    }

    /**
     * 成绩概况
     */
    @Test
    @Transactional
    public void queryScoreTest(){
        Integer assesmentId = 78;
        Integer experimentalClassId = 0;
        Integer classId = 14;
        HashMap<String, Object> score = assesmentService.queryScore(assesmentId, experimentalClassId, classId);
        for (String s : score.keySet()) {
            System.out.println("key:" + s + "," + "value:" + score.get(s));
        }
    }

    /**
     * 成绩柱状图
     */
    @Test
    @Transactional
    public void queryHistogramTest(){
        Integer assesmentId = 78;
        Integer experimentalClassId = 0;
        Integer classId = 14;
        HashMap<String, Object> histogram = assesmentService.queryHistogram(assesmentId, experimentalClassId, classId);
        for (String s : histogram.keySet()) {
            System.out.println("key:" + s + "," + "value:" + histogram.get(s));
        }
    }

    /**
     * 错误分布折线图
     */
    @Test
    @Transactional
    public void getLinechartTest(){
        Integer assesmentId = 78;
        Integer experimentalClassId = 0;
        Integer classId = 14;
        HashMap<String, Object> linechart = assesmentService.getLinechart(assesmentId, experimentalClassId, classId);
        for (String s : linechart.keySet()) {
            System.out.println("key:" + s + "," + "value:" + linechart.get(s));
        }
    }

    /**
     * 成绩明细
     */
    @Test
    @Transactional
    public void queryAssesmentScoreTest(){
        Integer assesmentId = 78;
        Integer experimentalClassId = 0;
        Integer classId = 14;
        HashMap<String, Object> assesmentScore = assesmentService.queryAssesmentScore(assesmentId, experimentalClassId, classId);
        for (String s : assesmentScore.keySet()) {
            System.out.println("key:" + s + "," + "value:" + assesmentScore.get(s));
        }
    }

    /**
     * 开启考核
     */
    @Test
    @Transactional
    public void releaseAssesmentTest(){
        Integer courseId = 14;
        HashMap<String, Object> releaseAssesment = assesmentService.releaseAssesment(courseId);
        for (String s : releaseAssesment.keySet()) {
            System.out.println("key:" + s + "," + "value:" + releaseAssesment.get(s));
        }
    }

    /**
     * 删除考核项目
     */
    @Test
    @Transactional
    public void deleteAssesmentTest(){
        Integer assesmentId = 78;
        HashMap<String, Object> assesment = assesmentService.deleteAssesment(assesmentId);
        for (String s : assesment.keySet()) {
            System.out.println("key:" + s + "," + "value:" + assesment.get(s));
        }
    }

    /**
     * 判断名称是否存在
     */
    @Test
    @Transactional
    public void isNameExistisTest(){
        String assesmentName = "随意";
        HashMap<String, Object> existis = assesmentService.isNameExistis(assesmentName);
        for (String s : existis.keySet()) {
            System.out.println("key:" + s + "," + "value:" + existis.get(s));
        }
    }
}
