package com.yipin.liuwanr.service;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockHttpServletResponse;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;

/**
 * @auther River
 * @date 2020/8/13 9:59
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class AttendanceServiceTest {

    @Autowired
    private AttendanceService attendanceService;


    /**
     * 查询考勤记录
     */
    @Test
    @Transactional
    public void queryAttendanceDetailedTest(){
        Integer studentId = 77;
        Integer courseId = 64;
        Integer pageNo = 1;
        Integer pageSize = 5;
        HashMap<String, Object> detailed = attendanceService.queryAttendanceDetailed(studentId, courseId, pageNo, pageSize);
        for (String s : detailed.keySet()) {
            System.out.println("key:" + s + "," + "value:" + detailed.get(s));
        }
    }

    /**
     * 导出考勤记录
     */
    @Test
    @Transactional
    public void exportPracticeTest(){
        MockHttpServletResponse response = new MockHttpServletResponse();
        Integer studentId = 64;
        Integer courseId = 77;
        String[] title = {"序号","项目名称","实验项目","考勤记录","签到时间"};
        HashMap<String, Object> exportPractice = attendanceService.exportPractice(response, studentId, courseId, title);
        if (exportPractice == null){
            System.out.println("--------------------------Unit tests pass--------------------------");
        }
    }

    /**
     * 考勤个人信息展示
     */
    @Test
    @Transactional
    public void queryAttendanceTest(){
        Integer studentId = 67;
        Integer courseId = 77;
        HashMap<String, Object> attendance = attendanceService.queryAttendance(studentId, courseId);
        for (String s : attendance.keySet()) {
            System.out.println("key:" + s + "," + "value:" + attendance.get(s));
        }
    }
}
