package com.yipin.liuwanr.service;

import org.apache.commons.io.IOUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.lang.Nullable;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.io.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.HashMap;

/**
 * @auther River
 * @date 2020/8/19 9:39
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class MakeuplistServiceTest {

    @Autowired
    private MakeuplistService makeuplistService;

    /**
     * 查询数据
     */
    @Test
    @Transactional
    public void queryAllMakeuplistTest(){
        Integer staffId = 1;
        long uploadTime = 0L;
        Integer uploadType = 1;
        Integer schoolId = 5;
        String time = "2020-07-24 18:51";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        try {
             uploadTime = sdf.parse(time).getTime() / 1000;
        } catch (ParseException e) {
            e.printStackTrace();
        }
        HashMap<String, Object> queryAllMakeuplist = makeuplistService.queryAllMakeuplist(staffId, uploadTime, uploadType, schoolId);
        for (String s : queryAllMakeuplist.keySet()) {
            System.out.println("key:" + s + "," + "value:" + queryAllMakeuplist.get(s));
        }
    }

    /**
     * 获取学生信息
     */
    @Test
    @Transactional
    public void getStudentTest(){
        Integer staffId = 1;
        long uploadTime = 0L;
        Integer uploadType = 1;
        Integer schoolId = 5;
        String time = "2020-07-24 18:51";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        try {
            uploadTime = sdf.parse(time).getTime() / 1000;
        } catch (ParseException e) {
            e.printStackTrace();
        }
        HashMap<String, Object> student = makeuplistService.getStudent(staffId, uploadTime, uploadType, schoolId);
        for (String s : student.keySet()) {
            System.out.println("key:" + s + "," + "value:" + student.get(s));
        }
    }

    /**
     * 获取补考信息
     */
    @Test
    @Transactional
    public void getByMakeuplistTest(){
        Integer staffId = 1;
        long uploadTime = 0L;
        Integer uploadType = 1;
        Integer schoolId = 5;
        String time = "2020-07-24 18:51";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        try {
            uploadTime = sdf.parse(time).getTime() / 1000;
        } catch (ParseException e) {
            e.printStackTrace();
        }
        HashMap<String, Object> makeuplist = makeuplistService.getByMakeuplist(staffId, uploadTime, uploadType, schoolId);
        for (String s : makeuplist.keySet()) {
            System.out.println("key:" + s + "," + "value:" + makeuplist.get(s));
        }
    }

    /**
     * 导入数据
     */
    @Test
    @Transactional
    public void addMakeuplistTest(){
        MultipartFile file = new MultipartFile() {
            @Override
            public String getName() {
                return null;
            }
            @Nullable
            @Override
            public String getOriginalFilename() {
                return null;
            }
            @Nullable
            @Override
            public String getContentType() {
                return null;
            }
            @Override
            public boolean isEmpty() {
                return false;
            }
            @Override
            public long getSize() {
                return 0;
            }
            @Override
            public byte[] getBytes() throws IOException {
                return new byte[0];
            }
            @Override
            public InputStream getInputStream() throws IOException {
                return null;
            }
            @Override
            public void transferTo(File dest) throws IOException, IllegalStateException {
            }
        };
        Integer schoolId = 5;
        Integer staffId = 1;
        long uploadTime = 0L;
        String time = "2020-07-24 18:51";
        File file1 = new File("C:\\Users\\Hello\\Desktop\\aaaa.xlsx");
        try {
            //将file类型文件转换为MultipartFile类型文件
            FileInputStream input = new FileInputStream(file1);
            file = new MockMultipartFile("file", file1.getName(), "text/plain", IOUtils.toByteArray(input));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        try {
            uploadTime = sdf.parse(time).getTime() / 1000;
        } catch (ParseException e) {
            e.printStackTrace();
        }
        HashMap<String, Object> makeuplist = makeuplistService.addMakeuplist(file, schoolId, staffId, uploadTime);
        for (String s : makeuplist.keySet()) {
            System.out.println("key:" + s + "," + "value:" + makeuplist.get(s));
        }
    }
}
