package com.yipin.liuwanr.service;

import com.yipin.liuwanr.entity.CourseSchedule;
import com.yipin.liuwanr.entity.Project_Management;
import com.yipin.liuwanr.vo.CourseAndProjectVo;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;

/**
 * @auther River
 * @date 2020/8/21 11:38
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class ProjectAndCourseServiceTest {

    @Autowired
    private ProjectAndCourseService projectAndCourseService;

    /**
     * 根据课程查询实验项目信息
     */
    @Test
    @Transactional
    public void queryProjectTest(){
        Integer courseId = 77;
        Integer experimentalClassId = 87;
        Integer pageNo = 1;
        Integer pageSize = 10;
        HashMap<String, Object> project = projectAndCourseService.queryProject(courseId, experimentalClassId, pageNo, pageSize);
        for (String s : project.keySet()) {
            System.out.println("key:" + s + "," + "value:" + project.get(s));
        }
    }

    /**
     * 修改项目状态
     */
    @Test
    @Transactional
    public void updateIsExperimentTest(){
        CourseAndProjectVo vo = new CourseAndProjectVo();
        vo.setCourseId(77);
        vo.setExperimentalClassId(87);
        vo.setProject(new Project_Management(1,289));
        HashMap<String, Object> experiment = projectAndCourseService.updateIsExperiment(vo);
        for (String s : experiment.keySet()) {
            System.out.println("key:" + s + "," + "value:" + experiment.get(s));
        }
    }

    /**
     * 修改考勤状态
     */
    @Test
    @Transactional
    public void updateIsAttendanceTest(){
        CourseAndProjectVo vo = new CourseAndProjectVo();
        vo.setCourseId(77);
        vo.setExperimentalClassId(87);
        vo.setProject(new Project_Management(1,289,null));
        HashMap<String, Object> attendance = projectAndCourseService.updateIsAttendance(vo);
        for (String s : attendance.keySet()) {
            System.out.println("key:" + s + "," + "value:" + attendance.get(s));
        }
    }

    /**
     * 获取课程进度
     */
    @Test
    @Transactional
    public void getCourseScheduleTest(){
        Integer courseId = 77;
        Integer experimentalClassId = 87;
        Integer studentId = null;
        HashMap<String, Object> courseSchedule = projectAndCourseService.getCourseSchedule(courseId, experimentalClassId, studentId);
        for (String s : courseSchedule.keySet()) {
            System.out.println("key:" + s + "," + "value:" + courseSchedule.get(s));
        }
    }

    /**
     * 添加课程进度
     */
    @Test
    @Transactional
    public void addCourseScheduleTest(){
        CourseSchedule courseSchedule = new CourseSchedule();
        courseSchedule.setScheduleId(1);
        courseSchedule.setProjectId(5);
        courseSchedule.setCourseId(5);
        courseSchedule.setExperimentalClassId(0);
        HashMap<String, Object> courseSchedule1 = projectAndCourseService.addCourseSchedule(courseSchedule);
        for (String s : courseSchedule1.keySet()) {
            System.out.println("key:" + s + "," + "value:" + courseSchedule1.get(s));
        }
    }

    /**
     * 课程视频
     */
    @Test
    @Transactional
    public void getCoursevideoTest(){
        Integer courseId = 77;
        Integer experimentalClassId = 87;
        Integer studentId = null;
        HashMap<String, Object> coursevideo = projectAndCourseService.getCoursevideo(courseId, experimentalClassId, studentId);
        for (String s : coursevideo.keySet()) {
            System.out.println("key:" + s + "," + "value:" + coursevideo.get(s));
        }
    }
}
