package com.yipin.liuwanr.service;

import com.yipin.liuwanr.entity.School;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;

/**
 * @auther River
 * @date 2020/8/24 9:14
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class SchoolServiceTest {

    @Autowired
    private SchoolService schoolService;

    /**
     * 添加学校
     */
    @Test
    @Transactional
    public void addSchoolTest(){
        School school = new School();
        school.setSchoolName("北京大学");
        school.setProvinceId(1);
        school.setCityId(1);
        school.setLevel(1);
        HashMap<String, Object> addSchool = schoolService.addSchool(school);
        for (String s : addSchool.keySet()) {
            System.out.println("key:" + s + "," + "value:" + addSchool.get(s));
        }
    }

    /**
     * 查询学校
     */
    @Test
    @Transactional
    public void querySchoolTest(){
        School school = new School();
        school.setProvinceId(1);
        school.setCityId(1);
        school.setLevel(1);
        HashMap<String, Object> querySchool = schoolService.querySchool(school);
        for (String s : querySchool.keySet()) {
            System.out.println("key:" + s + "," + "value:" + querySchool.get(s));
        }
    }

    /**
     * 查询学校详情
     */
    @Test
    @Transactional
    public void querySchoolDetailsTest(){
        Integer schoolId = 1;
        HashMap<String, Object> schoolDetails = schoolService.querySchoolDetails(schoolId);
        for (String s : schoolDetails.keySet()) {
            System.out.println("key:" + s + "," + "value:" + schoolDetails.get(s));
        }
    }

    /**
     * 删除学校
     */
    @Test
    @Transactional
    public void deleteSchoolTest(){
        School school = new School();
        school.setSchoolId(1);
        HashMap<String, Object> deleteSchool = schoolService.deleteSchool(school);
        for (String s : deleteSchool.keySet()) {
            System.out.println("key:" + s + "," + "value:" + deleteSchool.get(s));
        }
    }

    /**
     * 更新学校
     */
    @Test
    @Transactional
    public void updateSchoolTest(){
        School school = new School();
        school.setSchoolId(1);
        school.setProvinceId(1);
        school.setCityId(1);
        school.setLevel(1);
        school.setSchoolName("北京大学");
        HashMap<String, Object> updateSchool = schoolService.updateSchool(school);
        for (String s : updateSchool.keySet()) {
            System.out.println("key:" + s + "," + "value:" + updateSchool.get(s));
        }
    }
}
