package com.yipin.liuwanr.service;

import com.yipin.liuwanr.entity.StaffGrade;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;

/**
 * @auther River
 * @date 2020/8/20 10:57
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class StaffGradServiceTest {

    @Autowired
    private StaffGradeService staffGradeService;

    /**
     * 添加员工年级
     */
    @Test
    @Transactional
    public void addStaffGradeTest(){
        StaffGrade staffGrade = new StaffGrade();
        staffGrade.setStaffGradeName("教导处");
        staffGrade.setStaffProfessionalArchitectureId(1);
        HashMap<String, Object> addStaffGrade = staffGradeService.addStaffGrade(staffGrade);
        for (String s : addStaffGrade.keySet()) {
            System.out.println("key:" + s + "," + "value:" + addStaffGrade.get(s));
        }
    }

    /**
     * 查询员工年级
     */
    @Test
    @Transactional
    public void queryStaffGradeTest(){
        Integer staffProfessionalArchitectureId = 1;
        HashMap<String, Object> staffGrade = staffGradeService.queryStaffGrade(staffProfessionalArchitectureId);
        for (String s : staffGrade.keySet()) {
            System.out.println("key:" + s + "," + "value:" + staffGrade.get(s));
        }
    }

    /**
     * 删除员工年级
     */
//    @Test
//    @Transactional
//    public void deleteStaffGradeTest(){
//        Integer staffGradeId = 1;
//        HashMap<String, Object> staffGrade = staffGradeService.deleteStaffGrade(staffGradeId);
//        for (String s : staffGrade.keySet()) {
//            System.out.println("key:" + s + "," + "value:" + staffGrade.get(s));
//        }
//    }

    /**
     * 查询员工年级详情
     */
    @Test
    @Transactional
    public void queryStaffGradeDetailsTest(){
        Integer staffGradeId = 1;
        HashMap<String, Object> staffGradeDetails = staffGradeService.queryStaffGradeDetails(staffGradeId);
        for (String s : staffGradeDetails.keySet()) {
            System.out.println("key:" + s + "," + "value:" + staffGradeDetails.get(s));
        }
    }

    /**
     * 更新员工年级
     */
    @Test
    @Transactional
    public void updateStaffGradeTest(){
        StaffGrade staffGrade = new StaffGrade();
        staffGrade.setStaffProfessionalArchitectureId(1);
        staffGrade.setStaffGradeName("教务处");
        staffGrade.setStaffGradeId(1);
        HashMap<String, Object> staffGrade1 = staffGradeService.updateStaffGrade(staffGrade);
        for (String s : staffGrade1.keySet()) {
            System.out.println("key:" + s + "," + "value:" + staffGrade1.get(s));
        }
    }
}
