package com.yipin.liuwanr.service;

import com.yipin.liuwanr.entity.OrganizationRelationship;
import com.yipin.liuwanr.entity.Staff;
import com.yipin.liuwanr.entity.UserInfo;
import com.yipin.liuwanr.entity.UserM;
import com.yipin.liuwanr.vo.UserVO;
import org.apache.commons.io.IOUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.lang.Nullable;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * @auther River
 * @date 2020/8/24 9:45
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class StaffServiceTest {

    @Autowired
    private StaffService staffService;

    /**
     * 读取员工表
     */
    @Test
    @Transactional
    public void readStaffTest(){
        MultipartFile file = new MultipartFile() {
            @Override
            public String getName() {
                return null;
            }
            @Nullable
            @Override
            public String getOriginalFilename() {
                return null;
            }
            @Nullable
            @Override
            public String getContentType() {
                return null;
            }
            @Override
            public boolean isEmpty() {
                return false;
            }
            @Override
            public long getSize() {
                return 0;
            }
            @Override
            public byte[] getBytes() throws IOException {
                return new byte[0];
            }
            @Override
            public InputStream getInputStream() throws IOException {
                return null;
            }
            @Override
            public void transferTo(File dest) throws IOException, IllegalStateException {
            }
        };
        Integer schoolId = 1;
        File file1 = new File("C:\\Users\\Hello\\Desktop\\aaaa.xlsx");
        try {
            //将file类型文件转换为MultipartFile类型文件
            FileInputStream input = new FileInputStream(file1);
            file = new MockMultipartFile("file", file1.getName(), "text/plain", IOUtils.toByteArray(input));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        HashMap<String, Object> readStaff = staffService.readStaff(file, schoolId);
        for (String s : readStaff.keySet()) {
            System.out.println("key:" + s + "," + "value:" + readStaff.get(s));
        }
    }

    /**
     * 添加员工
     */
    @Test
    @Transactional
    public void addStaffTest(){
        Staff staff = new Staff();
        staff.setSchoolId(2043);
        staff.setEmail("4867687@qq.com");
        staff.setPhone("18873465488");
        staff.setRoleId(3);
        staff.setStaffGradeId(2050);
        staff.setStaffName("zha");
        staff.setStaffProfessionalArchitectureId(2057);
        staff.setWorkNumber("1222");
        staff.setUniqueIdentificationAccount("204312221598238094000");
        HashMap<String, Object> addStaff = staffService.addStaff(staff);
        for (String s : addStaff.keySet()) {
            System.out.println("key:" + s + "," + "value:" + addStaff.get(s));
        }
    }

    /**
     * 查询员工
     */
    @Test
    @Transactional
    public void queryStaffTest(){
        UserInfo userInfo = new UserInfo();
        Integer pageNo = 1;
        Integer pageSize = 10;
        userInfo.setSchoolId(2043);
        HashMap<String, Object> queryStaff = staffService.queryStaff(userInfo, pageNo, pageSize);
        for (String s : queryStaff.keySet()) {
            System.out.println("key:" + s + "," + "value:" + queryStaff.get(s));
        }
    }

    /**
     * 删除员工
     */
    @Test
    @Transactional
    public void deleteStaffTest(){
        List<OrganizationRelationship> OrganizationRelationshipList = new ArrayList<>();
        HashMap<String, Object> deleteStaff = staffService.deleteStaff(OrganizationRelationshipList);
        for (String s : deleteStaff.keySet()) {
            System.out.println("key:" + s + "," + "value:" + deleteStaff.get(s));
        }
    }

    /**
     * 查询员工详情
     */
    @Test
    @Transactional
    public void queryStaffDetailsTest(){
        Integer userId = 2;
        Integer roleId = 3;
        HashMap<String, Object> staffDetails = staffService.queryStaffDetails(userId,roleId);
        for (String s : staffDetails.keySet()) {
            System.out.println("key:" + s + "," + "value:" + staffDetails.get(s));
        }
    }

    /**
     * 更新员工
     */
    @Test
    @Transactional
    public void updateStaffTest(){
        UserVO userVO = new UserVO();
        Staff staff = new Staff();
        UserM user = new UserM();
        staff.setEmail("123@qq.com");
        staff.setPhone("13137366427");
        staff.setRoleId(4);
        staff.setSchoolId(2043);
        staff.setStaffGradeId(2050);
        staff.setStaffId(118);
        staff.setStaffName("世杰-教师");
        staff.setStaffProfessionalArchitectureId(2057);
        staff.setWorkNumber("123");
        staff.setUniqueIdentificationAccount("20431231596424406000");
        userVO.setStaff(staff);
        user.setAccountRole(3);
        user.setCityId(1);
        user.setDisciplineId(1);
        user.setEmail("123@qq.com");
        user.setName("世杰-教师");
        user.setPhone("13137366427");
        user.setProfessionalClassId(1);
        user.setProvinceId(4);
        user.setProfessionalId(4);
        user.setSchoolId(2043);
        user.setUniqueIdentificationAccount("20431231596424406000");
        user.setUserAccount("123");
        user.setUserId(461);
        user.setWorkNumber("123");
        userVO.setUser(user);
        HashMap<String, Object> updateStaff = staffService.updateStaff(userVO);
        for (String s : updateStaff.keySet()) {
            System.out.println("key:" + s + "," + "value:" + updateStaff.get(s));
        }
    }
}
