package com.yipin.liuwanr.service;

import com.yipin.liuwanr.entity.StuProfessionalArchitecture;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;

/**
 * @auther River
 * @date 2020/8/25 9:46
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class StuProfessionalArchitectureServiceTest {

    @Autowired
    private StuProfessionalArchitectureService stuProfessionalArchitectureService;

    /**
     * 添加学生专业组织
     */
    @Test
    @Transactional
    public void addStuProfessionalArchitectureTest(){
        StuProfessionalArchitecture stuPA = new StuProfessionalArchitecture();
        stuPA.setSchoolId(2043);
        stuPA.setStuProfessionalArchitectureName("计算机学院");
        HashMap<String, Object> stuProfessionalArchitecture = stuProfessionalArchitectureService.addStuProfessionalArchitecture(stuPA);
        for (String s : stuProfessionalArchitecture.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuProfessionalArchitecture.get(s));
        }
    }

    /**
     * 查询学生专业架构
     */
    @Test
    @Transactional
    public void queryStuProfessionalArchitectureTest(){
        Integer schoolId = 1;
        HashMap<String, Object> professionalArchitecture = stuProfessionalArchitectureService.queryStuProfessionalArchitecture(schoolId);
        for (String s : professionalArchitecture.keySet()) {
            System.out.println("key:" + s + "," + "value:" + professionalArchitecture.get(s));
        }
    }

    /**
     * 查询学生专业架构详情
     */
    @Test
    @Transactional
    public void queryStuPADTest(){
        Integer stuProfessionalArchitectureId = 34;
        HashMap<String, Object> stuPAD = stuProfessionalArchitectureService.queryStuPAD(stuProfessionalArchitectureId);
        for (String s : stuPAD.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuPAD.get(s));
        }
    }

    /**
     * 删除学生专业
     */
    @Test
    @Transactional
    public void deleteStuProfessionalArchitectureTest(){
        Integer stuProfessionalArchitectureId = 34;
        HashMap<String, Object> professionalArchitecture = stuProfessionalArchitectureService.deleteStuProfessionalArchitecture(stuProfessionalArchitectureId);
        for (String s : professionalArchitecture.keySet()) {
            System.out.println("key:" + s + "," + "value:" + professionalArchitecture.get(s));
        }
    }

    /**
     * 删除学生转年级
     */
    @Test
    @Transactional
    public void deleteStuGradeTest(){
        Integer gradeId = 1;
        HashMap<String, Object> stuGrade = stuProfessionalArchitectureService.deleteStuGrade(gradeId);
        for (String s : stuGrade.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuGrade.get(s));
        }
    }

    /**
     * 删除学生转班级
     */
    @Test
    @Transactional
    public void deleteStuClassTest(){
        Integer classId = 1;
        HashMap<String, Object> stuClass = stuProfessionalArchitectureService.deleteStuClass(classId);
        for (String s : stuClass.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuClass.get(s));
        }
    }

    /**
     * 更新学生专业架构
     */
    @Test
    @Transactional
    public void updateStuProfessionalArchitectureTest(){
        StuProfessionalArchitecture stuPA = new StuProfessionalArchitecture();
        stuPA.setSchoolId(2043);
        stuPA.setStuProfessionalArchitectureId(34);
        stuPA.setStuProfessionalArchitectureName("英语");
        HashMap<String, Object> professionalArchitecture = stuProfessionalArchitectureService.updateStuProfessionalArchitecture(stuPA);
        for (String s : professionalArchitecture.keySet()) {
            System.out.println("key:" + s + "," + "value:" + professionalArchitecture.get(s));
        }
    }

    /**
     * 查询全部学生专业架构
     */
    @Test
    @Transactional
    public void queryStudentProfessionalArchitectureTest(){
        Integer schoolId = 1;
        HashMap<String, Object> professionalArchitecture = stuProfessionalArchitectureService.queryStuProfessionalArchitecture(schoolId);
        for (String s : professionalArchitecture.keySet()) {
            System.out.println("key:" + s + "," + "value:" + professionalArchitecture.get(s));
        }
    }

    /**
     * 查询学生年级
     */
    @Test
    @Transactional
    public void queryStuGradeTest(){
        Integer stuProfessionalArchitectureId = 34;
        HashMap<String, Object> queryStuGrade = stuProfessionalArchitectureService.queryStuGrade(stuProfessionalArchitectureId);
        for (String s : queryStuGrade.keySet()) {
            System.out.println("key:" + s + "," + "value:" + queryStuGrade.get(s));
        }
    }

    /**
     * 查询学生年级详情
     */
    @Test
    @Transactional
    public void queryStuGradeDTest(){
        Integer gradeId = 1;
        HashMap<String, Object> stuGradeD = stuProfessionalArchitectureService.queryStuGradeD(gradeId);
        for (String s : stuGradeD.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuGradeD.get(s));
        }
    }

    /**
     * 查询学生班级
     */
    @Test
    @Transactional
    public void queryStuClassTest(){
        Integer gradeId = 1;
        HashMap<String, Object> stuClass = stuProfessionalArchitectureService.queryStuClass(gradeId);
        for (String s : stuClass.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuClass.get(s));
        }
    }

    /**
     * 查询学生班级详情
     */
    @Test
    @Transactional
    public void queryStuClassDTest(){
        Integer classId = 1;
        HashMap<String, Object> stuClassD = stuProfessionalArchitectureService.queryStuClassD(classId);
        for (String s : stuClassD.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuClassD.get(s));
        }
    }

    /**
     * 添加班级
     */
    @Test
    @Transactional
    public void addStuClassTest(){
        StuProfessionalArchitecture stuPA = new StuProfessionalArchitecture();
        stuPA.setClassName("12");
        stuPA.setGradeId(20);
        HashMap<String, Object> addStuClass = stuProfessionalArchitectureService.addStuClass(stuPA);
        for (String s : addStuClass.keySet()) {
            System.out.println("key:" + s + "," + "value:" + addStuClass.get(s));
        }
    }

    /**
     * 修改班级
     */
    @Test
    @Transactional
    public void updateStuClassTest(){
        StuProfessionalArchitecture stuPA = new StuProfessionalArchitecture();
        stuPA.setClassName("13");
        stuPA.setClassId(76);
        HashMap<String, Object> stuClass = stuProfessionalArchitectureService.updateStuClass(stuPA);
        for (String s : stuClass.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuClass.get(s));
        }
    }

    /**
     * 添加年级
     */
    @Test
    @Transactional
    public void addStuGradeTest(){
        StuProfessionalArchitecture stuPA = new StuProfessionalArchitecture();
        stuPA.setGradeName("2020");
        stuPA.setStuProfessionalArchitectureId(37);
        HashMap<String, Object> stuGrade = stuProfessionalArchitectureService.addStuGrade(stuPA);
        for (String s : stuGrade.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuGrade.get(s));
        }
    }

    /**
     * 修改年级
     */
    @Test
    @Transactional
    public void updateStuGradeTest(){
        StuProfessionalArchitecture stuPA = new StuProfessionalArchitecture();
        stuPA.setGradeId(50);
        stuPA.setGradeName("2018");
        stuPA.setStuProfessionalArchitectureId(37);
        HashMap<String, Object> stuGrade = stuProfessionalArchitectureService.updateStuGrade(stuPA);
        for (String s : stuGrade.keySet()) {
            System.out.println("key:" + s + "," + "value:" + stuGrade.get(s));
        }
    }

    /**
     * 查询学生
     */
    @Test
    @Transactional
    public void queryStudentTest(){
        Integer classId = 1;
        HashMap<String, Object> student = stuProfessionalArchitectureService.queryStudent(classId);
        for (String s : student.keySet()) {
            System.out.println("key:" + s + "," + "value:" + student.get(s));
        }
    }
}
